
$(document).ready(function() {
                  
                  $(".button").mousedown(function() {
                                         $(this).addClass("hover");
                                         $(this).find(".left").addClass("hover");
                                         $(this).find(".center").addClass("hover");
                                         $(this).find(".right").addClass("hover");
                                         });
                  $(".button").mouseup(function() {
                                       $(this).removeClass("hover");
                                       $(this).find(".left").removeClass("hover");
                                       $(this).find(".center").removeClass("hover");
                                       $(this).find(".right").removeClass("hover");
                                       });
                  
                  $(".button").live("touchstart", function() {
                                    $(this).addClass("hover");
                                    $(this).find(".left").addClass("hover");
                                    $(this).find(".center").addClass("hover");
                                    $(this).find(".right").addClass("hover");
                                    });
                  $(".button").live("touchend", function() {
                                    $(this).removeClass("hover");
                                    $(this).find(".left").removeClass("hover");
                                    $(this).find(".center").removeClass("hover");
                                    $(this).find(".right").removeClass("hover");
                                    });
                  $(".button").live("touchmove", function() {
				              		$(this).removeClass("hover");
				              		$(this).find(".left").removeClass("hover");
				              		$(this).find(".center").removeClass("hover");
				              		$(this).find(".right").removeClass("hover");
				              		});
                  });

String.prototype.trim = function() {
    return this.replace(/(^\s*)|(\s*$)/gi, "");
};



// HubUtil
function HubUtil() {
	// call back function 실행시 scope 을 this 로 설정해주는 함수
	this.bind = function(scope, fn) {
		return function() {
			fn.apply(scope, arguments);
		};
	};
    
	// json 을 비교하는 형식, 속도를 위해서 단순한 data 형식의 json 만 비교한다.
	// refernce come from   http://stackoverflow.com/questions/1068834/object-comparison-in-javascript
	this.jsonEquals = function(lhsJson, rhsJson) {
		// 같은 object를 참조하고 있거나 둘 다 null 이면 둘은 동일하다.
		if (lhsJson == rhsJson)
			return true;
		// 둘 중 하나가 null 이면 둘은 다르다.
		if (!lhsJson || !rhsJson)
			return false;
		
		// lhsJson 에 있는 것들이 다 에 있다.
		for (item in lhsJson) {
			if (typeof(rhsJson[item]) == 'undefined') {
				return false;
			}
		}
		
		// rhsJson 에 있는 것들이 다 lhsJson에 있다.
		for (item in rhsJson) {
			if (typeof(lhsJson[item]) == 'undefined') {
				return false;
			}
		}
		
		// lhsJson 이 있는 것과
		for (item in lhsJson) {
			lhsValue = lhsJson[item];
			rhsValue = rhsJson[item];
			if (lhsValue) {
				switch (typeof(lhsValue)) {
					case 'object':
						if (!this.jsonEquals(lhsValue, rhsValue)) {
							return false;
						}
						break;
					default:
						if (lhsValue != rhsValue) {
							return false;
						}
				}
			}
			else {
				if (rhsJson[item])
					return false;
			}
		}
		return true;
	};
    
	// defaultArray 에는 있으나 baseArray 에는 없는 값을 update  해서 새로운 array 를 만들어 낸다.
	this.arrayUpdate = function(baseArray, defaultArray) {
		if (!baseArray || baseArray == undefined)
			baseArray = {};
		
		var newArray = {};
		for (var key in defaultArray) {
			if (!(key in baseArray))
				newArray[key] = defaultArray[key];
			else
				newArray[key] = baseArray[key];
		}
		
		// baseArray에만 있는 값을 찾아서 넣어준다.
		for (var key in baseArray) {
			if (!(key in defaultArray))
				newArray[key] = baseArray[key];
		}
		
		return newArray;
	};
	
	this.convertDisplayText = function(orgText, newLineSupport) {
		var str = orgText;
		str = str.split("&").join("&amp;").split("<").join("&lt;").split(">").join("&gt;").split("  ").join(" &nbsp;");
		
		if(newLineSupport)
			str = str.split("\r\n").join("<br/>").split("\r").join("<br/>").split("\n").join("<br/>");
		return str;
	};
	
	this.minWidth = function() {
		if (hubUtil.isIOS()) {
			if(screen.height > screen.width )
				return screen.width;
			else
				return screen.height;
		}
		
		var orientation = Math.abs(window.orientation) == 90 ? 'landscape' : 'portrait';
		if (orientation == 'portrait')
			return window.outerWidth;
        return window.outerHeight;
        
	};
    
	this.minHeight = function() {
		var orientation = Math.abs(window.orientation) == 90 ? 'landscape' : 'portrait';
		if (orientation == 'landscape')
			return window.outerWidth;
        return window.outerHeight;
	};
    
    this.isIOS = function(){
        if (hubAppInfo &&  hubAppInfo.os == 'ios')
            return true;
        
        if (!hubAppInfo || !hubAppInfo.os) {
            if( navigator.userAgent.match(/iPhone/i) || navigator.userAgent.match(/iPod/i) || navigator.userAgent.match(/iPad/i) )
                return true;
        }
        return false;
    };
    
    this.getOSVersion = function(){
        // boot 함수 호출 전에는 os_version 이 없을 수 있고, 이 때는 이 함수를 사용해서는 안된다.
        // useragent 를 이용한 방법으로 버전만 뽑아 오기는 어렵다.
        if(hubAppInfo.os_version)
            return hubAppInfo.os_version;
        return undefined;
    };
    
    this.frameHeightChange = function(height){
        $(".frame").css({'height':height});
    };
    
    this.trim = function(str) {
        return str.replace(/\s/g, "");
    };
    
    // 20131129 add - isEnable- true : enable button, false : disable button
	this.setEnableBtn = function(id, isEnable) {
		if (isEnable == true) { // enable button
        	$(id).removeClass("disabled");
        	$(id + " .left").removeClass("disabled");
        	$(id + " .center").removeClass("disabled");
        	$(id + " .right").removeClass("disabled");
        	$(id).prop('disabled', false);
		} else { // disable button
        	$(id).addClass("disabled");
        	$(id + " .left").addClass("disabled");
        	$(id + " .center").addClass("disabled");
        	$(id + " .right").addClass("disabled");
        	$(id).prop('disabled', true);
		}
	};
	
	// 20131216 add - 현재 Button 의 enable/disable 상태 Check. 
	this.isEnableBtn = function(id) {
		if ($(id).hasClass('disabled'))
			return false;
		else
			return true;
	};
	
};
var hubUtil = new HubUtil();


// HubConfig
function HubConfig() {
	
	var _release      = 1; /* 0:타운스테일, 1:용의심장, 2:할로우포인트, 3:WRT */
	var _releaseTheme = [[1,0,1],[2,0,2],[1,1,3],[1,1,1]]; // [0][]:타운스테일, [1][]:용의심장, [2][]:할로우포인트, [3][]:WRT
	
    this._logEnable 	   = false;
    this._articleTheme     = _releaseTheme[_release][0]; // 0:not support, 1:타운스테일,WRT,할로우포인트 2:용의심장
    this._clanArticleTheme = _releaseTheme[_release][1]; // 0:not support, 1: 할로우포인트,WRT 
    this._webUrlTheme	   = _releaseTheme[_release][2]; // 0:not support, 1:타운스테일,WRT  2: 용의심장  3: 할로우포인트
    
    this.logEnable = function() {
        return this._logEnable;
    };    
    
    this.articleTheme = function() {
    	return this._articleTheme;
    };

    this.clanArticleTheme = function() {
    	return this._clanArticleTheme;
    }; 
    
    this.webUrlTheme = function() {
    	return this._webUrlTheme;
    }
    
};
var hubConfig = new HubConfig();


// HubApi
function HubApi() {
    this.requestId = undefined;
    this.invokeReturn = undefined;
    
	this._isCalledDialog = false;
	
	this.request = function(param, callback) {
		hubLog.i("web", "hubApi.request");
		var requestId;
		if (typeof hubBridge !== "undefined" && hubBridge !== null) {
			if (typeof hubBridge.request === "function") {
                hubProgress.showWaitProgress(true, null);
				requestId = hubBridge.request(JSON.stringify(param), callback);
				return requestId;
			}
		}
                
		hubProgress.showWaitProgress(true, null);
		
        // ios 인 경우
        if(hubUtil.isIOS()){
            this.requestId = undefined;
            
            var iFrame = document.createElement("IFRAME");
            iFrame.style.width = "0px";
            iFrame.style.height = "0px";
            iFrame.style.border = "0px";
            iFrame.setAttribute("src", "hub://api/request?param=" + encodeURIComponent(JSON.stringify(param)) +"&callback=" + callback);
            document.body.appendChild(iFrame);
            iFrame.parentNode.removeChild(iFrame);
            iFrame = null;
            return this.requestId;
        } 
	};
	
	this.onResponse = function(callback, response) {
		hubLog.i("web", "hubApi.onResponse callback " + callback + " response.requestId " + response.requestId);
		responseStr = JSON.stringify(response);
        hubProgress.hideWaitProgress();
		if(response.error == 9001){ //서버점검중인 경우
			if(this._isCalledDialog) //이미 다이얼로그가 떠있는경우
				return;
            
			this._isCalledDialog= true;
			
			var msg;
			if (hubAppInfo.lang == "ko" && response.result.ko != "undefined") {
				msg = response.result.ko;
			} else if (hubAppInfo.lang == "ja" && response.result.ja != "undefined") {
				msg = response.result.ja;
			} else if (hubAppInfo.lang == "zh" && response.result.zh != "undefined") {
				msg = response.result.zh;
			} else { //default는 영어
				if( response.result.en != "undefined")
					msg = response.result.en;
				else
					msg = "server inspection";
			}
			
			hubDialog.showOkDialog(msg , 'hubApi.closeWebpage');
			return;
		}
		script = callback + "(" + responseStr + ");";
		hubLog.i("web", script);
		eval(script);
	};
	
	this.closePage = function(){
		this._isCalledDialog = false;
		hubNavigator.close();
	};
	
	this.cancel = function(requestId) {
		hubLog.i("web", "hubApi.cancel requestId " + requestId);
		if (typeof hubBridge !== "undefined" && hubBridge !== null) {
			if (typeof hubBridge.cancel === "function") {
				hubBridge.cancel(requestId);
				return;
			}
		}
        
        
        // ios 인 경우
        if(hubUtil.isIOS()){
            var iFrame = document.createElement("IFRAME");
            iFrame.style.width = "0px";
            iFrame.style.height = "0px";
            iFrame.style.border = "0px";
            iFrame.setAttribute("src", "hub://api/cancel?requestId=" + requestId);
            document.body.appendChild(iFrame);
            iFrame.parentNode.removeChild(iFrame);
            iFrame = null;
            return;
        }
	};
	
	this.onEvent = function(param) {
		hubLog.i("web", "hubApi.onEvent param " + param);
		hubEventReceiver.onEvent(param);
	};
	
	this.invoke = function(param, callback) {
		if (typeof hubBridge !== "undefined" && hubBridge !== null) {
			if (typeof hubBridge.invoke === "function") {
				var result = hubBridge.invoke(JSON.stringify(param), callback);
				if (result != undefined && result != null)
					return JSON.parse(result);
				else
					return null;
			}
		}
        
        
        // ios 인 경우
        if(hubUtil.isIOS()){
            this.invokeReturn = undefined;
            
            var iFrame = document.createElement("IFRAME");
            iFrame.style.width = "0px";
            iFrame.style.height = "0px";
            iFrame.style.border = "0px";
            iFrame.setAttribute("src", "hub://api/invoke?param="+ encodeURIComponent(JSON.stringify(param)) + "&callback=" + callback);
            document.body.appendChild(iFrame);
            iFrame.parentNode.removeChild(iFrame);
            iFrame = null;
            if (this.invokeReturn != undefined && this.invokeReturn != null)
                return this.invokeReturn;
            else
                return null;
        }
	};
    
	// 2013/08/30 add for external html url link
    this.agreeDetailApi = function(url) {
		hubLog.i("web", "hubApi.agreeDetailApi url-" + url);
		if (typeof hubBridge !== "undefined" && hubBridge !== null) {
			if (typeof hubBridge.agreeDetailApi === "function") {
				hubBridge.agreeDetailApi(url);
				return;
			}
		}   	
    }
    
    // 2013/09/09 add for show input activity ui
    this.showInputUIApi = function(arg, callback) {
    	hubLog.i("web", "hubApi.showInputUIApi");


        var param = {
                "function" : "showInputUI",
                "argument" : {
            		title_text 			 	: arg.title_text,
            		input_placeholder_text  : arg.input_placeholder_text,
            		input_type 			 	: arg.input_type,
            		input_value 			: arg.input_value,
            		request_input_box_id    : arg.request_input_box_id
                }
            };

    	hubApi.invoke(param, callback);
    } 
    
    this.cancelWebApi = function() {
        
        var param = {
            "function" : "webApiReturn",
            "argument" : {
                type : "agree",
                result : "request cancled",
                error : 906,
            }
        };
        hubApi.invoke(param, null);
        
        
        param = {
            "function" : "close",
        };
        hubApi.invoke(param, null);
    }
	
	this.onInvokeResult = function(callback, response) {
		hubLog.i("web", "hubApi.onInvokeResult callback " + callback + " response " + JSON.stringify(response));
		
		var resultStr = JSON.stringify(response.result);
		script = callback + "(" + resultStr + ");";
		hubLog.i("web", "hubApi.onInvokeResult script " + script);
		eval(script);
		
		hubLog.i("web", "hubApi.onInvokeResult return");
	};
	
	// 2014/10/06 add for Tab New Icon
    this.onTabBoardCategory = function(categoryId) {
		hubLog.i("web", "hubApi.onTabBoardCategory categoryID-" + categoryId);
		
        var param = {
                "function" : "onTabBoardCategory",
                "argument" : {
                	category_id : categoryId
                }
            };
        hubApi.invoke(param, null); 
    }	
};
var hubApi = new HubApi();

// HubLog
function HubLog() {
	this.i = function(tag, text) {
		this._log("i", tag, text);
	};
	this.d = function(tag, text) {
		this._log("d", tag, text);
	};
	this.w = function(tag, text) {
		this._log("w", tag, text);
	};
	this.e = function(tag, text) {
		this._log("e", tag, text);
	};
	this._log = function(level, tag, text) {
        if(!hubConfig.logEnable())
            return;
        
		var param = {
			'function' : 'log',
			'argument' : {
				'level' : level,
				'tag' : tag,
				'text' : text
			}
		};
		hubApi.invoke(param, null);
	};
};
var hubLog = new HubLog();

// HubNavigator
function HubNavigator() {
	this._newFilename = "";
	this._scrollTop = 0;
	this._newParam = {};
	this._backParam = {};
	this._oldNavigationOption = {};
	this._requestMode = "";
	this._navigating = false;
	
	// 브라우저 초기 구동시 animation
	this._newNavigationOption = {
		sliding : "left",
		header : false,
		footer : false
	};
	this._DEFAULT_NAVEGATION_OPTION = {
		sliding : "left",
		header : true,
		footer : true
	};
	this._oldhubPage = null;
	this._DEFAULT_HEADER_STRUCTURE = {
		title : "",
		left : "back",
		right : "close",
		progress : false,
		show : true
	};
	this._DEFAULT_FOOTER_STRUCTURE = {
		show : true
	};
	
	this.boot = function() {
        
		hubLog.i("web", "hubNavigator.boot");
		
		//hubEffector.setup();
		
		// boot, appinfo, start page
		var param 		= { 'function' : "boot" };
		var ret   		= hubApi.invoke(param, null);
		var style_file 	= "style/common.css";
        
		if (ret != undefined && ret.result != undefined) {
			hubAppInfo = ret.result;
		}
        
		// FIX ME .. 추후 native 단에서 전달 받아서 값을 저장 하도록 처리 할것. 
		hubAppInfo.x_profile = "v1n";	
		
        if(hubUtil.isIOS()) {
            var meta = "user-scalable=no, initial-scale=1.0, minimum-scale=1.0, maximum-scale=1.0";
            this.viewportChange(meta);
        } else {
            var meta = "user-scalable=no, initial-scale=1.0, minimum-scale=1.0, maximum-scale=1.0 , width=device-width"
            //var meta = "user-scalable=no, initial-scale=1.0, minimum-scale=1.0, maximum-scale=1.0, target-densitydpi=device-dpi, width=device-width, height=device-height"  ;
            this.viewportChange(meta);            
        }      
        
		if (hubAppInfo.page == undefined) {
			hubAppInfo.page = "agree.html";		
			// hubAppInfo.page = "pc_debug.html"; // pc 브라우져로 확인시 사용
		} else {
            hubAppInfo.page += ".html";
		}
		
		if (hubAppInfo.param == undefined) {
			hubAppInfo.param = null;
		}

		if (hubAppInfo.page != undefined && hubAppInfo.param != undefined 
				&& hubAppInfo.param.articleType != undefined) {
			
			
			if (hubAppInfo.param.articleType == 0) { // 일반 게시판 호출인 경우
				
				if (hubConfig.articleTheme() == 0) { // not support
					hubToast.show(hubLang.get('com_not_support_function'));
					this.close();
					return;
				}
				
        		style_file = "article/theme_" + hubConfig.articleTheme() + "/style/common.css";
        		hubAppInfo.page = "article/theme_" + hubConfig.articleTheme() + "/" + hubAppInfo.page;				
			} else if (hubAppInfo.param.articleType == 1) { // clan 게시판 호출 인 경우
				if (hubConfig.clanArticleTheme() == 0) { // not support
					hubToast.show(hubLang.get('com_not_support_function'));
					this.close();
					return;
				}				
        		style_file = "article_clan/theme_" + hubConfig.clanArticleTheme() + "/style/common.css";
        		hubAppInfo.page = "article_clan/theme_" + hubConfig.clanArticleTheme() + "/" + hubAppInfo.page;				
			}	
		}
				
		if (hubAppInfo.page != undefined && hubAppInfo.page == "web_url_page.html") {
			
			if (hubConfig.webUrlTheme() == 0) { // not support
				hubToast.show(hubLang.get('com_not_support_function'));
				this.close();
				return;
			}
			
    		style_file = "web_url_page/theme_" + hubConfig.webUrlTheme() + "/style/common.css";
    		hubAppInfo.page = "web_url_page/theme_" + hubConfig.webUrlTheme() + "/" +  hubAppInfo.page;	 
		}
		
		// html 의 종류에 따라 CSS 파일을 다르게 사용 (login/profile: common.css 사용, 게시판:common_article_theme_x.css 사용)
        var headID 		= document.getElementsByTagName("head")[0];         
        var cssNode 	= document.createElement('link');
        cssNode.rel 	= 'stylesheet';
        cssNode.href 	= style_file;
        headID.appendChild(cssNode);  
		// 첫 페이지는 effect 없이 보여준다
		hubNavigator.go(hubAppInfo.page, hubAppInfo.param, {sliding:"none"});
	};
	
	this.go = function(filename, param, navigationOption){
		hubLog.i("web", "hubNavigator.go filename " + filename);
		this._backParam = undefined;
		this._scrollTop = 0;
		if (hubPage.structure && hubPage.structure.pageType == "popup") {
			hubLog.i("web", "hubNavigator.go err : pageType of current page is not normal");
			return;
		}
        
		// 현재 페이지와 동일한 정보를 읽어오는 것과 같다면 페이지 이동하지 않는다.
		if (hubHistory.checkPageReload(filename, param))
			return;
		if(this._navigating)
			return;
		this._navigating = true;
        
		this._newFilename = filename;
		this._newParam = param;
		
		this._oldNavigationOption = this._newNavigationOption;
		this._newNavigationOption = {};
		
		if (typeof navigationOption != "object" || navigationOption == null)
			navigationOption = {}
		
		// 넘어온  navigationOption 안의 값을 복사하고 해당 키가 없는 경우 _DEFAULT_NAVEGATION_OPTION 값의 key 를 복사한다.
		this._newNavigationOption = hubUtil.arrayUpdate(navigationOption, this._DEFAULT_NAVEGATION_OPTION);
		
		// 현재 페이지의 정보를 저장한다.
        var scrollTop = $(window).scrollTop();
		//var scrollTop = $("body").scrollTop();
		hubHistory.savePageInfo(filename, param, scrollTop, this._newNavigationOption);

		// ajax file load
		$.get(filename, hubUtil.bind(this, this._onFileLoad)).error( hubUtil.bind(this, this._onFileLoadFail));
	};
	
	this.back = function(backParam){
		hubLog.i("web", "hubNavigator.back param" +  JSON.stringify(backParam) );
		this._backParam = backParam;
		window.setTimeout(hubUtil.bind(this, this._back), 1);
	}
	
	this._back = function(){
		if (hubPage.structure && hubPage.structure.pageType == "popup"){
			hubLog.i("web", "hubNavigator.back err : pageType of current page is not normal");
			return;
		}
		
		if(this._navigating)
			return;
		var prevPageInfo = hubHistory.getPrevPageInfo();
		if (prevPageInfo == false) {
			this.close();
			return;
		}
		var prevPageFragment = hubHistory.loadPageFragement();
		if (!prevPageFragment)
			return this.go(prevPageInfo.filename , prevPageInfo.param, prevPageInfo.navigationOption);
		
		this._navigating = true;
		
		// 저장된 pageDomTree가 있는 경우, DOM Tree자체를 저장해 두고 이 DOM Tree자체를 추가 하도록 한다.
		this._newFilename = prevPageInfo.filename;
		this._newParam = prevPageInfo.param;
		this._oldNavigationOption = this._newNavigationOption;
		this._newNavigationOption = {};
		this._newNavigationOption = prevPageInfo.navigationOption;
		this._prevPageFragment = prevPageFragment;
		this._scrollTop = prevPageInfo.scrollTop;
		
		this._onFileLoad(prevPageFragment.frameDomTree.children());
	};
	
	this.close = function() {
		hubLog.i("web", "hubNavigator.close");
		param = {
			'function': "close"
		};
		hubApi.invoke(param, null);
	};
    
    this.viewportChange = function(content)
    {
        $("#viewport").attr("content", content);
    }
	
    
    this._onFileLoadFail = function(){
	 	this._navigating = false;
    }
    
	this._onFileLoad = function(data) {
		hubLog.i("web", "hubNavigator._onFileLoad");
        
		// exit
		if (hubPage.structure != undefined) {
			if (hubPage.structure.exit != undefined) {
				hubPage.structure.exit();
			}
		}
	
		hubPageReplacer.replace(data, this._newNavigationOption.sliding, this._scrollTop, hubUtil.bind(this, this._slidingComplete), {});
		//(data, slidingDir, compleateCallback, callbackData)
	};
	
	this._slidingComplete = function(_oldframe){
		hubLog.i("web", "hubNavigator._onSlidingComplete");
		
		if (hubHistory.isHistoryBack() || hubPage.structure.history == false) {
			//////// oldFrame을 저장하지 않고 지워야 하는 경우 ////////
			_oldframe.empty();
			_oldframe.remove();
			// clear
			hubPage.private = undefined;
			hubPage.private = {};
			hubPage.structure = undefined;
			hubPage.structure = {};
		} else {
			//////// oldFrame을 저장헤애 하는 경우 ////////
			hubHistory.savePageFragement(_oldframe, hubPage);
			_oldframe.detach();
			// history 를 저장해야 하는 경우, hubHistory 의 _historyFragmentStack 값이 지워지지 않게 해야 한다.
			hubPage = {};
			hubPage.private = {};
			hubPage.structure = {};
		}
		
		if (this._prevPageFragment) {
			//////// _historyFragmentStack 에 저장된 DOM과 hubPage object 를 이용하는 경우 ////////
			hubPage = this._prevPageFragment.hubPage;
			this._prevPageFragment = null;
			
			// 기존 header, footer  의 show 상태 복원
			//hubHeader.show(hubPage.structure.header.show);
			//hubFooter.show(hubPage.structure.footer.show);
			
			this._requestMode = "back";
			
		} else {
			//////// hubNavigator.go 나 _historyFragmentStack 을 이용하지 못한 back 인 경우 ////////
			// script run
			script = document.getElementById("script");
			if (script != undefined) {
				scriptText = script.innerHTML;
				try {
					eval(scriptText);
				}
				catch(err){
					var errMsg = "page eval error \n";
					hubToast.show(errMsg + err);
				}
			}
			
			if (hubPage.structure == undefined) {
				hubPage.structure = {};
			}
			
			// structure.request 에서 header, footer 설정할 수 있음.
			// DOM과 hubPage object 를 이용하는 경우 이미 structure 구조가 구성되어 있어 불필요함.
			hubPage.structure = hubUtil.arrayUpdate(hubPage.structure, {
                                                    header: {},
                                                    footer: {},
                                                    history: true,
                                                    pageType: "normal"
                                                    });
			
			// go 옵션의  header, footer 에 의해 show 상태 설정
			//hubHeader.show(this._newNavigationOption.header);
			//hubFooter.show(this._newNavigationOption.footer);
			
			this._requestMode = "go";
		}
		
		// header, footer
		var hfinvokeparam = {
			"function": "headerfooter",
			"argument": {
            header: {},
            footer: {},
			},
		};
        
		hfinvokeparam.argument.header = hubUtil.arrayUpdate(hubPage.structure.header, this._DEFAULT_HEADER_STRUCTURE);
		hfinvokeparam.argument.footer = hubUtil.arrayUpdate(hubPage.structure.footer, this._DEFAULT_FOOTER_STRUCTURE);
		if (this._newFilename == "home.html") {
			hfinvokeparam.argument.footer.select = "home";
		} else if (this._newFilename == "games.html") {
			hfinvokeparam.argument.footer.select = "games";
		} else if (this._newFilename == "friends.html") {
			hfinvokeparam.argument.footer.select = "friends";
		} else if (this._newFilename == "message.html") {
			hfinvokeparam.argument.footer.select = "message";
		}
		hubApi.invoke(hfinvokeparam, null);
		
		// history
		hubHistory.clearHistoryBack();
		
		window.setTimeout(hubUtil.bind(this, this._request), 1);
		//this._request();
	};
	
	this._request = function() {
		// request
		if (hubPage.structure.request != undefined) {
			hubPage.structure.request(this._newParam, this._requestMode, this._backParam);
		}
		this._navigating = false;
		hubLog.i("web", "hubNavigator go done " + hubNavigator._newFilename);
	};
};
var hubNavigator = new HubNavigator();

// HubPageReplacer
function HubPageReplacer() {
	this._newData = ''
	this._completeCallback = ''
	this._slidingDir = ''
	this._scrollTop = 0;
	
	this._newEffectTime =  undefined;
    this._newEffectTime_IOS = 300;
    this._newEffectTime_default = 100;
	
	this._oldframe = undefined;
	this._newframe = undefined;
	
	this.replace = function(newData, slidingDir, scrollTop, completeCallback) {
		hubLog.i("web", "hubPageReplacer.replace");
        
        this._oldframe = undefined;
        this._newframe = undefined;
        this._newEffectTime = hubUtil.isIOS()? this._newEffectTime_IOS : this._newEffectTime_default;
		this._newData = newData;
		this._slidingDir = slidingDir;
		this._scrollTop = scrollTop;
		this._completeCallback = completeCallback;
		window.setTimeout(hubUtil.bind(this, this._startSliding), 1);
	};
	
	this._startSliding = function() {
		hubLog.i("web", "hubPageReplacer._startSliding");
        // 아이폰 오래된 버전(4.0)에서 popup 형태의 글쓰기 창에서 textarea에 포커스가 있는 상태로 전 페이지로 돌아갈 경우
        // softkeyboard 때문에 frame이 내려가는 형상 수정을 위해 softkeyboard를 닫을 수 있게  blur 한다.
        $("textarea").blur();
        $("input").blur();
		
		if (this._slidingDir == "top" || this._slidingDir == "bottom") {
			return this._verticalSliding(this._slidingDir);
		} else if (this._slidingDir == "left" || this._slidingDir == "right") {
			return this._horizontalSliding(this._slidingDir);
		}
		
		// sliding effect 없는 경우
        //		var windowWidth = jQuery(window).width();
		this._oldframe = $($('.frame').get(0));
        //		$('<div class="frame"></div>').prependTo($("section")).css({
        //                                                                   width: (windowWidth) + 'px'
        //                                                                   }).html(this._newData);

		// 2013.11.14 animation 효과가 없을 경우 화면 깜빡임을 줄이기 위해 기존 
		// timer 로 onSlidingComplete 를 호출하는 대신 함수 내용의 값들을 여기서 직접 처리하도록 수정
        if (this._oldframe)
            this._oldframe.hide();

        if (this._newframe) {
            this._newframe.css({"height": "", "overflow-y": "", "top": ""});
        } else {
            hubProgress.showWaitProgress(true);
            var windowWidth  =  jQuery(window).width();
            $('<div class="frame"></div>').prependTo($("section")).css({width: (windowWidth) + 'px',
                                                                       }).html(this._newData);  
        }
        
        window.scrollTo(0, this._scrollTop);
        this._completeCallback( this._oldframe);
        hubProgress.hideWaitProgress();				
		
		return;
		
		
		// 2013.11.14 animation 효과가 없을 경우 화면 깜빡임을 줄이기 위해 기존 코드 제거
		//window.setTimeout(hubUtil.bind(this, this._onSlidingComplete), 1);
	};
	
	this._horizontalSliding = function(slidingDir) {
		hubLog.i("web", "hubNavigator._horizontalSliding");
		
		var windowWidth = jQuery(window).width();
		var windowHeight = jQuery(window).height();
		
		var scrollTop = $(window).scrollTop();
		this._oldframe = $($('.frame').get(0));
        if(hubUtil.isIOS()){
            //this._oldframe.css({ '-webkit-transform': 'translateZ(0)' });
        } else {
            this._oldframe.css({ 'overflow-y':'hidden' , 'height':(windowHeight  ) + 'px'  });
            this._oldframe.scrollTop(scrollTop);
        }
		
		if (slidingDir == "left"){
			//////// 새로운 페이지에 접속할 경우, 화면 오른쪽에서 왼쪽으로 이동하도록 한다. ////////
			
			//// 새로 불러오는 페이지는 안보이는 화면 오른쪽에 준비한다.
			// prependTo 를 이용해서 첫번째 child에 넣도록한다. (id가 중복될 경우, getDocuementID나 $('#") 동작을 통해
			// 변경될려는 ID를 가져올 수 있게 하기 위해)
            if(!hubUtil.isIOS()){
                $('<div class="frame"></div>').prependTo($("section")).css({
                                                                           left: (windowWidth) + 'px',
                                                                           width: (windowWidth) + 'px',
                                                                           }).html(this._newData);
            }
			
			window.setTimeout(hubUtil.bind(this,
                                           function(){
                                           //// 현재 페이지를 화면사이즈 만큼 왼쪽으로 옮겨 화면 밖으로 옮기고 이벤트가 끝나면페이지를 삭제한다.
                                           
                                           this._oldframe.animate({
                                                                  left: (this._oldframe.position().left - windowWidth) + 'px',
                                                                  '-webkit-transform' :'translateZ(0)',
                                                                  }, this._newEffectTime, hubUtil.bind(this, this._onSlidingComplete));
                                           
                                           //// 새로운 페이지를 화면사이즈 만큼 왼쪽으로 옮겨 화면 안으로 들어오게 한다.
                                           if(!hubUtil.isIOS()){
                                           this._newframe = $($('.frame').get(0));
                                           this._newframe.animate({
                                                                  left: '0px'
                                                                  }, this._newEffectTime)
                                           }
                                           }
                                           ), 1);
			
		} else if (slidingDir == "right") {
			//////// 새로운 페이지에 접속할 경우, 화면 왼쪽에서 오른쪽으로 이동하도록 한다. (실질적으로는 back 동작임) ////////
			
			//// 새로운 페이지는 안보이는 화면 왼쪽에 준비한다.
			// prependTo 를 이용해서 첫번째 child에 넣도록한다. (id가 중복될 경우, getDocuementID나 $('#") 동작을 통해
			// 변경될려는 ID를 가져올 수 있게 하기 위해)
            if(!hubUtil.isIOS()){
                $('<div class="frame"></div>').prependTo($("section")).css({
                                                                           left: (-windowWidth) + 'px',
                                                                           width: (windowWidth) + 'px',
                                                                           }).html(this._newData);
            }
			
			window.setTimeout(hubUtil.bind(this,
                                           function(){
                                           // 현재 페이지를 화면밖 오른쪽으로 옮긴다.  화면에 벗어난 현재 페이지를 삭제한다.
                                           this._oldframe.animate({
                                                                  left: (this._oldframe.position().left + windowWidth) + 'px',
                                                                  '-webkit-transform' :'translateZ(0)',
                                                                  }, this._newEffectTime, hubUtil.bind(this, this._onSlidingComplete));
                                           
                                           // 다시 읽는 페이지를 화면밖 오른쪽으로 옮긴다.
                                           if(!hubUtil.isIOS()){
                                           this._newframe = $($('.frame').get(0));
                                           this._newframe .animate({
                                                                   left: (this._newframe .position().left + windowWidth) + 'px'
                                                                   }, this._newEffectTime);
                                           }
                                           }
                                           ), 1);
		}
	};
	
	this._verticalSliding = function(slidingDir) {
		hubLog.i("web", "hubNavigator._verticalSliding");
		
		var windowWidth  =  jQuery(window).width();
		var windowHeight =  jQuery(window).height();
        
        $(".frame").css({"height": (windowHeight) + "px", "overflow-y": "hidden"});
		
		if (slidingDir == "top"){
			//////// 새로운 페이지에 접속할 경우, 화면 아래에서 위로 이동하도록 한다. ////////
			
			//// 새로 불러오는 페이지는 안보이는 화면 아래쪽에 준비한다.
			// prependTo 를 이용해서 첫번째 child에 넣도록한다. (id가 중복될 경우, getDocuementID나 $('#") 동작을 통해
			// 변경될려는 ID를 가져올 수 있게 하기 위해)
			$('<div class="frame"></div>').prependTo($("section")).css({
                                                                       top: (windowHeight) + 'px' , width: (windowWidth) + 'px'
                                                                       }).html(this._newData);
			
			window.setTimeout(hubUtil.bind(this,
                                           function(){
                                           
                                           //// 현재 페이지를 화면사이즈 만큼 오른쪽으로 옮겨 화면 밖으로 옮기고 이벤트가 끝나면페이지를 삭제한다.
                                           this._oldframe = $($('.frame').get(1));
                                           this._oldframe.animate({
                                                                  top: (this._oldframe.position().top - windowHeight) + 'px'
                                                                  }, this._newEffectTime, hubUtil.bind(this, this._onSlidingComplete));
                                           
                                           //// 새로운 페이지를 화면사이즈 만큼 위쪽으로 옮겨 화면 안으로 들어오게 한다.
                                           this._newframe  = $($('.frame').get(0));
                                           this._newframe .animate({
                                                                   top: '0px'
                                                                   }, this._newEffectTime);
                                           }), 1);
		}
		else if (slidingDir == "bottom" ) {
			//////// 새로운 페이지에 접속할 경우, 화면 위에서 아래로 이동하도록 한다. (실질적으로는 back했을 때 동작임) ////////
			
			//// 새로운 페이지는 안보이는 화면 위쪽에 준비한다.
			// prependTo 를 이용해서 첫번째 child에 넣도록한다. (id가 중복될 경우, getDocuementID나 $('#") 동작을 통해
			// 변경될려는 ID를 가져올 수 있게 하기 위해)
			$('<div class="frame"></div>').prependTo($("section")).css({
                                                                       top: (-windowHeight) + 'px',
                                                                       width: (windowWidth) + 'px', height: (windowHeight) + 'px'
                                                                       }).html(this._newData);
			
			window.setTimeout(hubUtil.bind(this,
                                           function(){
                                           // 현재 페이지를 화면밖 아래으로 옮긴다.  화면에 벗어난 현재 페이지를 삭제한다.
                                           this._oldframe = $($('.frame').get(1));
                                           this._oldframe.animate({
                                                                  top: (this._oldframe.position().top + windowHeight) + 'px'
                                                                  }, this._newEffectTime, hubUtil.bind(this, this._onSlidingComplete));
                                           
                                           // 다시 읽는 페이지를 화면밖 오른쪽으로 옮긴다.
                                           this._newframe = $($('.frame').get(0));
                                           this._newframe.animate({
                                                                  top: (this._newframe.position().top + windowHeight) + 'px'
                                                                  }, this._newEffectTime);
                                           }), 1);
		}
	};
	
	this._onSlidingComplete = function(){
        if (this._oldframe)
            this._oldframe.hide();
        
        window.setTimeout(hubUtil.bind(this, this._onSlidingComplete2) , 1);
    };
    
    this._onSlidingComplete2 = function(){
        if (this._newframe){
            this._newframe.css({
                               "height": "",
                               "overflow-y": "",
                               "top": ""});
            
        } else {
            hubProgress.showWaitProgress(true);
            var windowWidth  =  jQuery(window).width();
            $('<div class="frame"></div>').prependTo($("section")).css({
                                                                       width: (windowWidth) + 'px',
                                                                       }).html(this._newData);  
        }
        window.setTimeout(hubUtil.bind(this, this._onSlidingComplete3) , 1);
    };
    
    this._onSlidingComplete3 = function(){
        window.scrollTo(0, this._scrollTop);
        this._completeCallback( this._oldframe);
        hubProgress.hideWaitProgress();
	};
}
var hubPageReplacer = new HubPageReplacer();

// HubEffector
/*
function HubEffector() {
	this.setup = function() {
		this._registerCommonTouchEventHandler();
	};
	
	this._registerCommonTouchEventHandler = function() {
		hubLog.i("web", "hubEffector._registerCommonTouchEventHandler");
		
		// touch effect에 대한 특수한 class 적용
		// this.lastTouchElement = null;
		var touchEffectClassList = [
		                            // Selvas Hub 에서는 현재 사용하지 않음
                                    ".button.white:not([disabled])",
                                    ".button.black:not([disabled])",
                                    ".button.search:not([disabled])",
                                    ".button.link_button([disabled])",
                                    ".combo:not([disabled])",
                                    ".comboitem",
                                    ".button.portal_friend_button:not([disabled])",
                                    ".button.down:not([disabled])",
                                    ".button.start:not([disabled])",                                    
                               		// Selvas Hub 에서는 현재 사용하지 않음 end
                                    ".listitem:not([disabled])",
                                    ];
		var touchEventMap = touchEventMap = {touchstart: this._onTouchStart, touchend: this._onTouchEnd};
		if (typeof document.ontouchstart == "undefined") // pc
			touchEventMap = {mousedown: this._onTouchStart, mouseup: this._onTouchEnd};
		
		for (var index in touchEffectClassList) {
			$("section").on(touchEventMap, touchEffectClassList[index]);
		}
	};
	
	this._onTouchStart = function(event){
		hubLog.i("web", "hubEffector._onTouchStart");
		$('.touch').removeClass('touch');
		$(event.currentTarget).addClass('touch');
		event.stopPropagation();
	};
	
	this._onTouchEnd = function(event){
		hubLog.i("web", "hubEffector._onTouchEnd");
		$('.touch').removeClass('touch');
		event.stopPropagation();
	};
}
var hubEffector = new HubEffector();
*/

// HubHistory
function HubHistory() {
	this._MAX_HISTORY__COUNT = 50;  // include current pageinfo
	this._historyStack = [];
	this._historyBack = false;
	this._historyFragmentStack = [] ;
	this._MAX_HISTORY_FRAGMENT_COUNT = this._MAX_HISTORY__COUNT;
	this._DEBUG = true;
	
	// 다른 페이지로 이동하는 것인지 같은 페이지를 같은 param 으로 다시 읽어 오는 것인지 확인 한다.
	this.checkPageReload = function(filename, param) {
		hubLog.i("web", "hubHistory.checkPageReload");
		
		// 처음 실행(첫페이지 로딩)하거나 back 동작 중이며 reload 동작이 아니다.
		if (this._historyStack.length == 0 || this._historyBack)
			return false;
		
		// 현재 페이지와 이동하려는 페이지가 같으면 reload 하는 것과 같다.
		var data = this._historyStack[this._historyStack.length - 1];
		if (data.filename == filename && hubUtil.jsonEquals(data.param, param))
			return true;
		
		return false;
	};
	
	this.savePageInfo = function(filename, param, scrollTop, nextNavigationOption) {
		hubLog.i("web", "hubHistory.savePageInfo");
		
		var currentStackData = {'filename': filename, 'param': param, "scrollTop": 0, "navigationOption" : {}};
		if (this._historyBack == true)
			return;
		// 현재 페이지에 history:fase 이면 _historyStack 에서 현재 페이지를 뺀다.
		if ('structure' in hubPage  &&  'history' in hubPage.structure && !hubPage.structure.history)
			this._historyStack.pop();
		else  if (this._historyStack.length > 0) {
			// 다시 현재 페이지로 돌아왔을 때 필요한 sectionEffect는 현재 사용하려는 effect 반대로 값을 저장해 둔다.
			var sectionInverseDir = {"top":"bottom", "right":"left", "bottom":"top", "left":"right" , "none":"none"};
			this._historyStack[this._historyStack.length - 1].navigationOption.sliding = sectionInverseDir[nextNavigationOption.sliding];
			this._historyStack[this._historyStack.length - 1].scrollTop = scrollTop;
		}
		
		if (this._DEBUG)
			hubLog.i("web", "savePageInfo");
		this._historyStack.push(currentStackData);
		
		// _MAX_HISTORY__COUNT 보다 많은 history 를 저장할 경우 맨 앞의 history 를 삭제한다.
		if (this._historyStack.length > this._MAX_HISTORY__COUNT) {
			this._historyStack.splice(0,1);
		}
	};
	
	this.isHistoryBack = function() {
		return this._historyBack;
	};
	
	this.clearHistoryBack = function() {
		this._historyBack = false;
		this._restoreFragemet = false;
	};
	
	this.clearAllHistory = function() {
		this._historyStack.splice(0,this._historyStack.length);
		while(this._historyFragmentStack.length) {
			var oldHistoryFragment = this._historyFragmentStack.shift();
			oldHistoryFragment.frameDomTree.empty();
			oldHistoryFragment.frameDomTree.remove();
			delete oldHistoryFragment.hubPage;
		}
	};
	
	this.getPrevPageInfo = function() {
		hubLog.i("web", "hubHistory.getPrevPageInfo");
		// 자기 페이지에 대한 정보를 stack에 저장하고 있으므로 length가 1일 때 더 이상 back 할 곳이 없다.
		if (this._historyStack.length == 1)
			return false;
		this._historyBack = true;
		this._historyStack.pop();
		if (this._DEBUG)
			hubLog.i("web", "getPrevPageInfo");
		return this._historyStack[this._historyStack.length - 1];
	};
		
	this.savePageFragement = function(domRoot, page) {
		hubLog.i("web", "hubHistory.savePageFragement");
		if (this._historyBack || this._MAX_HISTORY_FRAGMENT_COUNT < 1 )
			return;
		if (hubPage.structure == undefined  || hubPage.structure.history != true)
			return;
		
		if (this._DEBUG)
			hubLog.i("web", "savePageFragement");
		var newPage = {};
		var historyFragment = { 'frameDomTree' : domRoot, 'hubPage' :  page };
		
		this._historyFragmentStack.push(historyFragment);
		
		if (this._historyFragmentStack.length > this._MAX_HISTORY_FRAGMENT_COUNT ){
			var oldHistoryFragment = this._historyFragmentStack.shift();
			oldHistoryFragment.frameDomTree.empty();
			oldHistoryFragment.frameDomTree.remove();
			delete oldHistoryFragment.hubPage;
		}
	};
	
	this.loadPageFragement = function() {
		hubLog.i("web", "hubHistory.loadPageFragement");
		if (this._historyFragmentStack.length == 0)
			return null;
		if (this._DEBUG)
			hubLog.i("web", "loadPageFragement");
		return this._historyFragmentStack.pop();
	};
};
var hubHistory = new HubHistory();

function HubPopup() {
	this._newFilename = "";
	this._scrollTop = 0;
	this._newParam = {};
	this._newData = "";
    
	this._closeParam = null;
	this._basehubPage = null;
	
	this._oldframe = undefined;
	this._newframe = undefined;
	
	this._status = "";  // "open" | "close"
	
	this.open = function(filename, param) {
		hubLog.i("web", "hubPopup.open filename " + filename);
		
        
        if(this._status || 	hubNavigator._navigating )
            return;
		this._status = "open";
        hubNavigator._navigating = true;
		if (hubPage.structure.pageType != "normal") {
			hubLog.i("web", "hubPopup.open error : pageType of current page is popup");
			return;
		}
		
		
		this._newParam = param;
		this._oldNavigationOption = this._newNavigationOption;
		this._newNavigationOption = {};
		this._scrollTop = $(window).scrollTop();;
		
		if (typeof navigationOption != "object" || navigationOption == null)
			navigationOption = {}
		
		// ajax file load
        $.get(filename, hubUtil.bind(this, this._onFileLoad)).error( hubUtil.bind(this, this._onFileLoadFail));
        
	};
    
    this._onFileLoadFail = function(){
	 	hubNavigator._navigating = false;
    }
	
	this._onFileLoad = function(data) {
		hubLog.i("web", "hubPopup._onFileLoad");
		// exit
		if (this._status == "close" && hubPage.structure != undefined) {
			if (hubPage.structure.exit != undefined) {
				hubPage.structure.exit();
			}
		}
		
		var sliding = ''
		var scrollTop = 0;
		if (this._status == "open") {
			sliding = "top";
		}
		else {
			sliding = "bottom";
			scrollTop = this._scrollTop;
		}
		
		//// page 전환효과와 함께, 페이지를 전환하고 받아온 responseText를 document에 추가한다.
		hubPageReplacer.replace(data, sliding, scrollTop, hubUtil.bind(this, this._slidingComplete), {});
		
	};
	
	this._slidingComplete = function(_oldframe) {
		hubLog.i("web", "hubPopup._slidingComplete");
		this._oldframe = _oldframe;
		
		if (this._status == "close") {	
			this._oldframe.empty();
			this._oldframe.remove();
			// clear
			hubPage.private = undefined;
			hubPage.private = {};
			hubPage.structure = undefined;
			hubPage.structure = {};
			
			hubPage = this._basehubPage;
			this._basehubPage = {};
			
			// header, footer
			var hfinvokeparam = {
				"function" : "headerfooter",
				"argument" : {
					header : {},
					footer : {},
				},
			};
			hfinvokeparam.argument.header = hubUtil.arrayUpdate(hubPage.structure.header, hubNavigator._DEFAULT_HEADER_STRUCTURE);
			hfinvokeparam.argument.footer = hubUtil.arrayUpdate(hubPage.structure.footer, hubNavigator._DEFAULT_FOOTER_STRUCTURE);
			hubApi.invoke(hfinvokeparam, null);
		} else {	// open		
			this._basehubPage = hubPage;
			this._oldframe.detach();
			// history 를 저장해야 하는 경우, hubHistory 의 _historyFragmentStack 값이 지워지지 않게 해야 한다.
			hubPage = {};
			hubPage.private = {};
			hubPage.structure = {};
			
			script = document.getElementById("script");
			if (script != undefined) {
				scriptText = script.innerHTML;
				try {
					eval(scriptText);
				}
				catch(err){
					var errMsg = "page eval error \n";
					hubToast.show(errMsg + err);
				}
			}
			
			if (hubPage.structure == undefined) {
				hubPage.structure = {};
			}
			hubPage.structure = hubUtil.arrayUpdate(hubPage.structure, { header : {}, footer : {}, history : true , pageType:"popup" });
            
			// header, footer
			var hfinvokeparam = {
				"function" : "headerfooter",
				"argument" : {
					header : {},
					footer : {},
				},
			};
			hfinvokeparam.argument.header = hubUtil.arrayUpdate(hubPage.structure.header, {
                                                                title : "",
                                                                left : "cancel",
                                                                right : "none",
                                                                progress : false,
                                                                show : true
                                                                });
			hfinvokeparam.argument.footer = hubUtil.arrayUpdate(hubPage.structure.footer, {
                                                                show : false
                                                                });
			hubApi.invoke(hfinvokeparam, null);
		}
		
		// 쪽지 보내기의 경우(message.html), onPopupClose 시점에  hubNavigator.go 를 이용해 페이지 이동을 하고 있으므로 이 때 정상동작을 위해
		// navigating 을 onPopupClose 을 호출하기 전에 _navigating을 해제한다.
        hubNavigator._navigating = false;
		
		// request
		if (this._status == "open" && hubPage.structure.request != undefined) {
			hubPage.structure.request(this._newParam, "go");
		}
		// popup close 시 base page 의 onPopupClose 함수를 호출한다.
		if (this._status == "close" && hubPage.structure.onPopupClose) {
			hubPage.structure.onPopupClose(this._closeParam);
		}
		this._status = undefined;
		
		hubLog.i("web", "hubPopup open done " + this._newFilename);
	};
	
	this.close = function(param) {
		this._closeParam = param;
		window.setTimeout(hubUtil.bind(this,  this._close), 1);
		//this._close();
	};
	
	this._close = function() {
		hubLog.i("web", "hubPopup close");
		if (hubPage.structure.pageType != "popup") {
			hubLog.i("web", "hubPopup err : pageType of current page is not popup");
			return;
		}
		
        if(this._status || hubNavigator._navigating )
            return;
        hubNavigator._navigating = true;
		this._status = "close";
		this._onFileLoad(this._oldframe.children());
	};
};
var hubPopup = new HubPopup();

// HubEventReceiver
/*
 event : {
 name : "onButtonClick",
 argument : {
 source : "left"|"right"|"home"|"games"|"friends"|"message",
 type : "back"|"cancel"|"setting"|"close",
 }
 }
 event : {
 name : "onKeyPress",
 argument : {
 source : "menu"|"back"|"search"|"volumeup"|"volumedown",
 }
 event : {
 name : "onNativeOrientationchange",
 argument : {
 rotation : "landscape" | "portrait",
 }
 }
 */
function HubEventReceiver() {
	this.onOrientationchange = function(){
		hubLog.i("web", "hubEventReceiver.onOrientationchange");
		
	};
	
	this.onResize = function(){
		hubLog.i("web", "hubEventReceiver.onResize");

        // 안드로이드나 PC 웹일 경우, body의 resize 을 이용한다.
        // 20131218 rudeo ios 의 경우 예외 케이스 제거
        // if(!hubUtil.isIOS())
            this._resize();
        
    };
	
	this.onEvent = function(evt) {
		hubLog.i("web", "hubEventReceiver.onEvent evt " + JSON.stringify(evt));
		if (evt == undefined || evt.name == undefined)
			return;

		if (evt.name == 'onButtonClick') {
			this._dispatchOnButtonClick(evt.argument);
		} else if (evt.name == 'onKeyPress') {
			this._dispatchOnKeyPress(evt.argument);
		} else if (evt.name == "onNativeOrientationchange"){
			this._onNativeOrientationchange(evt.argument);
		} else if (evt.name == 'onBackPressed') {
			
			// user_exit_able 값이 존재 할 경우 false 일 경우는 back key 를 눌를시 종료가 되지 않도록 처리(android)
			if (hubPage.structure.user_exit_able == false) {
				return;
			} 
						
			if (hubPage.structure.move_back_able == false) {
	            hubApi.invoke({"function":"close"}, null); 
			} else if(hubPage.structure.check_back_able == true) {
				hubPage.structure.check_back();
			} else {
				hubNavigator.back();
			}
		}
	};
	
	this._dispatchOnButtonClick = function(arg) {
		if (arg == undefined)
			return;
		if (arg.source == undefined)
			return;
        
		// page event handler call
		var handled = false;
		// copy
		var gen = {
			name : "onButtonClick",
			argument : {
				source : arg.source,
				type : arg.type,
			},
		};
		if (arg.source == "left") {
			if (arg.type == "back" || arg.type == "cancel" || arg.type == "setting") {
				if (hubPage != undefined && hubPage.structure != undefined && hubPage.structure.onEvent != undefined)
					handled = hubPage.structure.onEvent(gen);
			}
		} else if (arg.source == "right") {
			if (arg.type == "close") {
				if (hubPage != undefined && hubPage.structure != undefined && hubPage.structure.onEvent != undefined)
					handled = hubPage.structure.onEvent(gen);
			}
		}
        
		// default action
		if (arg.source == "left") {
			if (arg.type == "back") {
				if (handled != true)
					hubPage.structure.pageType == "normal" ? hubNavigator.back() : hubPopup.close(null);
			} else if (arg.type == "cancel") {
				if (handled != true)
					hubPage.structure.pageType == "normal" ? hubNavigator.back() : hubPopup.close(null);
			} if (arg.type == "setting") {
				if (handled != true)
					hubNavigator.go("" + arg.type + ".html");
			}
		} else if (arg.source == "right") {
			if (arg.type == "close") {
				if (handled != true)
					hubNavigator.close();
			}
		} else if (arg.source == "home") {
			hubNavigator.go("" + arg.source + ".html");
		} else if (arg.source == "games") {
			hubNavigator.go("" + arg.source + ".html");
		} else if (arg.source == "friends") {
			hubNavigator.go("" + arg.source + ".html");
		} else if (arg.source == "message") {
			hubNavigator.go("" + arg.source + ".html");
		}
	};
    
	this._dispatchOnKeyPress = function(arg) {
		if (arg == undefined)
			return;
		if (arg.source == undefined)
			return;
        
		// page event handler call
		var handled = false;
		// copy
		var gen = {
			name : "onKeyPress",
			argument : {
				source : arg.source,
			},
		};
		if (hubPage != undefined && hubPage.structure != undefined && hubPage.structure.onEvent != undefined)
			handled = hubPage.structure.onEvent(gen);
		
		// default action
		if (arg.source == "menu") {
			;
		} else if (arg.source == "back") {
			if (handled != true)
				hubPage.structure.pageType == "normal" ? hubNavigator.back() : hubPopup.close(null);
		} else if (arg.source == "search") {
			;
		} else if (arg.source == "volumeup") {
			;
		} else if (arg.source == "volumedown") {
			;
		}
	};
	
	this._onNativeOrientationchange = function(arg){
		if (arg == undefined)
			return;
		if (arg.rotation == undefined)
			return;
		
		var orientationString = arg.rotation;
		hubLog.i("web", "hubEventReceiver.onNativeOrientationchange : " + orientationString);
        // iphone 일 경우, native  roate 가 끝날 때, 강제로 호출되는 함수를 이용해서 rotate
        // 20131218 rudeo ios 의 경우 예외 케이스 제거
        //if(hubUtil.isIOS())
        //  this._resize();

	}
	
	this._resize = function()
    {
		
		var windowWidth = jQuery(window).width();
		$('.frame').css({'width': windowWidth + 'px'})
		
		if(hubPage.structure.OnResize){
			window.setTimeout(hubPage.structure.OnResize, 1);
        }
        
        //$(window).trigger('resize'); // resize 이벤트를 강제로 발생시킴
		
	};
};
var hubEventReceiver = new HubEventReceiver();

// HubHeader
/*
function HubHeader() {
	this.show = function(show) {
		if (show == undefined) {
			return;
		}
		hubPage.structure.header.show = show;
		var param = {
			"function" : "headerfooter",
			"argument" : {
				header : {
					"show" : show
				}
			}
		};
		hubApi.invoke(param, null);
	};
	
	this.setLeft = function(id) {
		if (id == undefined) {
			return;
		}
		hubPage.structure.header.left = id;
		var param = {
			"function" : "headerfooter",
			"argument" : {
				header : {
					"left" : id
				}
			}
		};
		hubApi.invoke(param, null);
	};
	
	this.setRight = function(id) {
		if (id == undefined) {
			return;
		}
		hubPage.structure.header.right = id;
		var param = {
			"function" : "headerfooter",
			"argument" : {
				header : {
					"right" : id
				}
			}
		};
		hubApi.invoke(param, null);
	};
	
	this.setTitle = function(text) {
		if (text == undefined) {
			return;
		}
		hubPage.structure.header.title = text;
		var param = {
			"function" : "headerfooter",
			"argument" : {
				header : {
					"title" : text
				}
			}
		};
		hubApi.invoke(param, null);
	};
	
	this.setProgress = function(show) {
		if (show == undefined) {
			return;
		}
		var param = {
			"function" : "headerfooter",
			"argument" : {
				header : {
					"progress" : show
				}
			}
		};
		hubApi.invoke(param, null);
	};
};
var hubHeader = new HubHeader();
*/

// HubFooter
/*
function HubFooter() {
	this.show = function(show) {
		if (show == undefined) {
			return;
		}
		hubPage.structure.footer.show = show;
		var param = {
			"function" : "headerfooter",
			"argument" : {
				footer : {
					"show" : show
				}
			}
		};
		hubApi.invoke(param, null);
	};
	
	// this.setCount = function(id, count) {
	// };
};
var hubFooter = new HubFooter();
*/

// HubDirty
/*
function HubDirty() {
};
var hubDirty = new HubDirty();
*/

// HubPage
function HubPage() {
	this.private = {};
	this.structure = {};
};
var hubPage = new HubPage();

// HubDialog
function HubDialog() {
	/*
	 * msg: 창뜰때 출력 msg, 
	 * callback: callback function, 
	 * param: callback 호출시 전달 받을 parameter(주의: json data 로 전달 해야함)
	 */ 
	this.showYesNoDialog = function(msg, callback, callback_param) {
		var param = {
			'function' : 'dialog',
			'argument' : {
				'type' 	  : 'yesNo',
				'message' : msg
			}
		};	

		if (callback_param)
			param.argument['param'] = callback_param;

		hubApi.invoke(param, callback);
	};
    
	this.showOkDialog = function(msg, callback) {
		var param = {
			'function' : 'dialog',
			'argument' : {
				'type' : 'ok',
				'message' : msg
			}
		};
		hubApi.invoke(param, callback);
	};
    
	
	this.showProfileImageDialog = function(imageUrl, callback){
		var param = {
			'function' : 'dialog',
			'argument' : {
				'type' : 'profileImageSelect',
                'imageUrl' : imageUrl,
			}
		};
		hubApi.invoke(param, callback);
	};
    
    
    this.showAccountDialog = function(isShowRevertMenu , callback){
        var param = {
            'function' 		: 'dialog',
            'argument' 		: {
            	'type' 				  : 'account',
            	'is_show_revert_menu' : isShowRevertMenu,
            }
        };
        hubApi.invoke(param, callback);
    };
    
    
    this.showArticleImageDialog = function(callback) {
        var param = {
            'function' : 'dialog',
            'argument' : {
                'type' : 'articleImageSelect'
            }
        };
        hubApi.invoke(param, callback);
        
    };
	
};
var hubDialog = new HubDialog();


function HubProgress() {
	
	this.showWaitProgress = function(cancelable, callback) {
		var param = {
			'function' : 'progress',
			'argument' : {
				'type' : 'show',
				'cancelable' : cancelable
			}
		};
		hubApi.invoke(param, callback);
	};
    
	this.hideWaitProgress = function() {
		var param = {
			'function' : 'progress',
			'argument' : {
				'type' : 'hide'
			}
		};
		hubApi.invoke(param, null);
	};
};

var hubProgress = new HubProgress();



function HubToast() {
	this.show = function(msg) {
		var param = {
			'function' : 'toast',
			'argument' : {
				'message' : msg,
			}
		};
		hubApi.invoke(param, null);
	};
	
	this.showError = function(status, error , errMsg) {
		var msg = ""
		if (errMsg) {
			msg = "HTTP status : " + status + " / Error : " + error + "\n" + errMsg;
		}
		else{
			msg = "HTTP status : " + status + " / Error : " + error;
		}
		var param = {
			'function' : 'toast',
			'argument' : {
				'message' : msg,
			}
		};
		hubApi.invoke(param, null);
	};
}
var hubToast = new HubToast();


//HubNavigator의 init 함수에서  정적인 환경정보들을   assign 할 객체
//hardware , os , platform , processor , display , locale  등등
function HubAppInfo() {
};
var hubAppInfo = new HubAppInfo();

// [sinaeyo] Button 을 enable/disable 하기위한 api
function HubControl() {
	this.enable = function(id, enabled) {
		if (enabled) {
			$(id).removeAttr('disabled');
		} else {
			$(id).attr('disabled', "");
		}
	};
    
	this.isEnabled = function(id) {
		return !($(id).attr('disabled'));
	};
	
	this.check = function(id, checked) {
		if (checked) {
			$(id).attr('checked', '');
		} else {
			$(id).removeAttr('checked');
		}
	};
	
	this.isChecked = function(id) {
		return $(id).attr('checked');
	};
};
var hubControl = new HubControl();

function HubMap() {
	this.keys = new Array();
	this.data = new Object();

	this.put = function(key, value) {
	    if(this.data[key] == null){
	        this.keys.push(key);
	    }
	    this.data[key] = value;
	};

	this.get = function(key) {
	    return this.data[key];
	};

	this.remove = function(key) {
		
	    var len = this.keys.length;
	    for(var i=0;i<len;i++){
	    	var k = this.keys[i];	    	
	    	if(k==key) {    		
				this.keys.splice(i, 1);   		
	    		break;
	    	}
	    }	    
	    this.data[key] = null;
	};
	
	this.each = function(fn){
	    if(typeof fn != 'function')	
	        return;
	     
	    var len = this.keys.length;
	    for(var i=0;i<len;i++){
	        var k = this.keys[i];
	        fn(k,this.data[k],i);
	    }
	};

	this.entrys = function() {
	    var len = this.keys.length;
	    var entrys = new Array(len);
	    for (var i = 0; i < len; i++) {
	        entrys[i] = {
	            key : this.keys[i],
	            value : this.data[i]
	        };
	    }
	    return entrys;
	};

	this.isEmpty = function() {
	    return this.keys.length == 0;
	};

	this.size = function(){
	    return this.keys.length;
	};
};
// 주의 : map 의 경우 공용으로 사용시 관리가 되지 힘들것 같아 필요한 각 Page 에서 할당에서 직접 관리 하도록 함
//var hubMap = new HubMap();

// HubLang
var hubLang = {
    
	get : function(id) {
        if (hubAppInfo.lang == "en") {
			if (this._en[id] != undefined)
				return this._en[id];
		} else if (hubAppInfo.lang == "ko") {
			if (this._ko[id] != undefined)
				return this._ko[id];
		} else if (hubAppInfo.lang == "ja") {
			if (this._ja[id] != undefined)
				return this._ja[id];
		} else if (hubAppInfo.lang == "zh" || hubAppInfo.lang == "zh-Hans") {
			if (this._zh[id] != undefined)
				return this._zh[id];
		} else if (hubAppInfo.lang == "de") {
			if (this._de[id] != undefined)
				return this._de[id];
		}  else if (hubAppInfo.lang == "it") {
			if (this._it[id] != undefined)
				return this._it[id];
		}  else if (hubAppInfo.lang == "fr") {
			if (this._fr[id] != undefined)
				return this._fr[id];
		}  else if (hubAppInfo.lang == "es") {
			if (this._es[id] != undefined)
				return this._es[id];
		} 
        
		// 지원하지 않는 언어 또는 해당 언어 테이블에 id 의 값이 없는 경우, default 는 en
		if (this._en[id] != undefined)
			return this._en[id];
		// default 에도 없는 경우
		return "";
	},
	
	get_current_lang : function() {
		if (hubAppInfo.lang == "en") {
			return "en";
		} else if (hubAppInfo.lang == "ko") {
			return "ko";
		} else if (hubAppInfo.lang == "ja") {
			return "ja";
		} else if (hubAppInfo.lang == "zh" || hubAppInfo.lang == "zh-Hans") {
			return "zh";
		}
		
		return "en"; // default
	},
	
	format : function(id) {
		var str = this.get(id);		
		if (arguments.length > 1) {
			// argument 가 있는 경우 {$#num} 스타일의 format 변경
			for (var i=1; i < arguments.length; i++) {
				var regExp = "{$"+ i + "}";
				str = str.split(regExp).join(arguments[i]);
			}
		}
		return str;
	},
	
	format2 : function(id, time) {	
		/*
	     *  1초 미만		   : 방금 전
    	 *	1초 이상 1분 미만         : OO초 전
    	 *	1분 이상 1시간 미만      : OO분 전
    	 *	1시간 이상 24시간 미만 : OO시간 전
    	 *	1일 이상 1주 미만	   : OO일 전
    	 *	1주 이상 1달 미만	   : OO주 전
    	 *	1달 이상 1년 미만	   : OO달 전
    	 *	1년 이상		   : OO년 전
    	 */
		var ret 	= this.get(id);
		var regExp 	= "{$d}";
		
		if (id == 'clan_form_date_cur')
    		return ret;				
		else	
			return ret.split(regExp).join(time);
	},
	
	format_date: function(milliseconds){
	    var d 		 = new Date(milliseconds);
	    var strYear  = d.getFullYear().toString();
	    var month 	 = d.getMonth() + 1;
	    var strMonth = (month < 10)?"0" + month.toString() : month.toString();
	    var day 	 = d.getDate();
	    var strDay 	 = (day < 10)? "0"+day.toString() : day.toString();    
	    return this.format('form_date' , strYear, strMonth, strDay );
	},
	
	article_format_date: function(type, milliseconds){
	    var d 			= new Date(milliseconds);
	    var strYear 	= d.getFullYear().toString();
	    var month 		= d.getMonth() + 1;
	    var strMonth 	= (month < 10)?"0" + month.toString() : month.toString();
	    var day 		= d.getDate();
	    var strDay 		= (day < 10)? "0"+day.toString() : day.toString();   
	    var hour		= d.getHours();
	    var strHour 	= (hour < 10)?"0" + hour.toString() : hour.toString();
	    var minute 		= d.getMinutes();
	    var strMinute 	= (minute < 10)?"0" + minute.toString() : minute.toString();
	    	
	    var today 	 = new Date();
	    // var today_ms = today.getTime(); 

		/*
		 *  type(1) : 금일 작성된 글의 경우 시간:분 으로, 금일 이전의 경우 년/월/일 으로 표시 
	     *  type(2) : 무조건 년/월/일 시:분 으로 표시 
	     *  type(3) : 금일 작성된 글의 경우 시간:분 으로 표시, 금일 이전의 경우 년/월/일 시:분 으로  표시
	     *  type(4) : 글 등록 후 지난 시간으로 표시 
	     *      		- 1초 미만: 방금 전
    	 *				- 1초 이상 1분 미만        : OO초 전
    	 *				- 1분 이상 1시간 미만     : OO분 전
    	 *				- 1시간 이상 24시간 미만: OO시간 전
    	 *				- 1일 이상 1주 미만	 : OO일 전
    	 *				- 1주 이상 1달 미만	 : OO주 전
    	 *				- 1달 이상 1년 미만	 : OO달 전
    	 *				- 1년 이상			 : OO년 전
	     */
	    switch (type) {
	    case 1:
		    if (d.getFullYear()  == today.getFullYear() && 
		    		d.getMonth() == today.getMonth() && 
		    		d.getDate()  == today.getDate()) {
		    	// 금일에 작성된 글의 경우 시간:분 으로 표시
		    	return this.format('form_hour' , strHour, strMinute);
		    } else {
		    	// 금일 이전에 작성된글의 경우 년/월/일 로 표시
		    	return this.format('form_date' , strYear, strMonth, strDay );
		    }
	    case 2:
	    	return this.format('form_date_detail' , strYear, strMonth, strDay, strHour, strMinute );
	    case 3:
		    if (d.getFullYear()  == today.getFullYear() && 
		    		d.getMonth() == today.getMonth() && 
		    		d.getDate()  == today.getDate()) {
		    	// 금일에 작성된 글의 경우 시간:분 으로 표시
		    	return this.format('form_hour' , strHour, strMinute);
		    } else {
		    	// 금일 이전에 작성된글의 경우 년/월/일 로 표시
		    	return this.format('form_date_detail' , strYear, strMonth, strDay, strHour, strMinute );
		    }
	    case 4:
	    	{
	    		var elap_ms = today.getTime() - milliseconds;
	    		
	    		if (elap_ms < 1000) { // 1초 미만
	    			return this.format2('clan_form_date_cur',elap_ms);
	    		} else if (1000 <= elap_ms && elap_ms < (1000*60)) { // 1초 이상 1분 미만
					return this.format2('clan_form_date_sec', parseInt(elap_ms/1000));
	    		} else if ((1000*60) <= elap_ms && elap_ms < (1000*60*60)) { // 1분 이상 1시간 미만	
					return this.format2('clan_form_date_min', parseInt(elap_ms/(1000*60)));
	    		} else if ((1000*60*60) <= elap_ms && elap_ms < (1000*60*60*24)) { // 1시간 이상 24시간 미만
					return this.format2('clan_form_date_hour', parseInt(elap_ms/(1000*60*60)));
	    		} else if ((1000*60*60*24) <= elap_ms && elap_ms < (1000*60*60*24*7)) { // 1일 이상 1주 미만
					return this.format2('clan_form_date_day', parseInt(elap_ms/(1000*60*60*24)));
	    		} else if ((1000*60*60*24*7) <= elap_ms && elap_ms < (1000*60*60*24*30)) { // 1주 이상 1달 미만
					return this.format2('clan_form_date_week', parseInt(elap_ms/(1000*60*60*24*7)));
	    		} else if ((1000*60*60*24*30) <= elap_ms && elap_ms < (1000*60*60*24*365)) { // 1달 이상 1년 미만
					return this.format2('clan_form_date_mon', parseInt(elap_ms/(1000*60*60*24*30)));
	    		} else if ((1000*60*60*24*365) <= elap_ms) { // 1년 이상
					return this.format2('clan_form_date_year', parseInt(elap_ms/(1000*60*60*24*365)));
	    		}
	    	}
	    }
	    
	    return null;
	},
	
	_en : {
		///////////////////////
		// clan 게시판 
		///////////////////////
		
		// clan article 공통 적용
		clan_form_date_cur  : "Just now", 
		clan_form_date_sec  : "{$d} secounds ago", 
		clan_form_date_min  : "{$d} minutes ago", 
		clan_form_date_hour : "{$d} hours ago", 
		clan_form_date_day  : "{$d} days ago", 
		clan_form_date_week : "{$d} weeks ago", 
		clan_form_date_mon  : "{$d} months ago", 
		clan_form_date_year : "{$d} years ago", 

		// article_list
		clan_article_list_search_btn: "Search",
		clan_article_list_write_btn: "Write",		
		
		// article_write
		clan_article_write_delete_all : "Erase everything",
		clan_article_write_delete_all_msg : "Are you sure to erase all?",
		
		///////////////////////
		// 게시판 관련 Page 들 
		///////////////////////
		
		// web_url_page 
		web_url_page_error_msg: "Error occurred during page loading.",
		
		// article 공통 적용
		form_date 		 : "{$2}.{$3}.{$1}", 			// 영어권 날짜 표시 format
		form_hour 		 : "{$1}:{$2}",      			// 시간 표시
		form_date_detail : "{$2}.{$3}.{$1} {$4}:{$5}",  // 영어권 날짜 표시 format (날짜+시간)
		
		// article_list page
		article_list_not_exist_str: "There is no article.<br/> Please upload new article.",
		article_list_not_exist_str2: "There is no article.",
		article_list_more_list_str: "More",
		article_list_loading_list_str: "Loading",
		article_list_hit_str: "Hits",
		article_list_title: "Message board",
		article_list_search_check1_text: "Title+Content",
		article_list_search_check2_text: "Writer",
		article_list_search_ok_btn: "Search",
		article_list_search_input_holder: "Please put search input here.",
		article_list_search_keyword_error: "Please put search input here.",
		
		// article_content_view page
		article_content_view_title: "Message board",
		article_content_view_next_text_str: "Next article",
		article_content_view_prev_text_str: "Previous article",
		article_content_view_list_str: "List",
		article_content_view_list_empty_str: "No article found.",
		article_content_view_modify_str : "Edit",
		article_content_view_delete_str : "Delete",
		article_content_view_delete_confirm_str : "Are you sure about deleting this?",
		article_content_view_cancel_btn_str: "Cancel",
		article_content_view_ok_btn_str: "Confirm",
		article_content_view_delete_success_msg: "Delete confirmed.",
		
		//article_write page
		article_write_title: "Write",
		article_write_title_input_holder: "Please put title here.",
		article_write_content_input_holder: "Please put content here.",
		article_write_toolbar_cancel: "Cancel",
		article_write_toolbar_register: "Register",
		article_write_toolbar_complete: "Complete",		
		article_write_toolbar_photo_attach: "Add Photo",
		article_write_delete_cnt_txt: "Are you sure about deleting this?",
		article_write_title_input_error: "Please put title here.",
		article_write_content_input_error: "Please put content here.",
		article_write_regist_success_msg: "Article has been listed.",
		article_write_modify_success_msg: "Article has been modified.",
		article_write_input_content_empty_msg: "Please input content you want to wirte.",
		article_write_exist_check_msg: "Discard this article you have been wirting?",
		article_write_photo_attach_limit_msg: "Allowed number of photos to be uploaded are {$d}.",
		article_write_content_text_limit_msg: "Maximum number of words are {$d}.",
		
		// article_comment_view page
		article_comment_view_count_str: "Comment",
		article_comment_view_not_exist_str: "There are no comments.<br/>Please add new comment.",
		article_comment_view_comments_str: "View comments",
		article_comment_view_contetn_btn_str: "View content",
		article_comment_view_delete_success_msg: "Comment has been erased.",
		
		// search result page 
		article_search_list_title: "Search Result",
		article_search_list_more_list_str: "More",
		article_search_list_hit_str: "Hits",
		article_search_list_text : "'{$s}' Search Result: {$d} results",
		article_search_list_loading_list_str: "Loading",
		article_search_list_not_exist_str: "There is no search result.<br/> Try different search phrase.",
		
		// article common input view 
		article_common_input_view_ok_btn_str: "Ok",
		article_common_input_view_cancel_btn_str: "Cancel",		
		article_common_input_view_delete_comment_str: "Are you sure about deleting this?",
		article_common_input_view_input_holder: "Please input content you want to wirte.",
		article_common_input_comment_regist_success_msg: "Comment has been registered.",
		article_common_input_empty_msg: "Please input content you want to wirte.",
		
		///////////////////////
		// 공통 적용및 기타
		///////////////////////	    
	    // common text
    	com_iscroll_refresh_msg1: "Please swpie down to refresh.",
    	com_iscroll_refresh_msg2: "Cancel in order to refresh.",
   		com_iscroll_refresh_msg3: "Updating…",		
	    com_article_unknown_user: "unknown user",
	    com_clan_article_title: "Clan Board",
	    com_not_support_function : "This function is not supported.",
		com_clan_article_list_notice_prefix: "Notice"
	},
	_ko : {
		///////////////////////
		// clan 게시판 
		///////////////////////
		
		// clan article 공통 적용
		clan_form_date_cur  : "방금 전", 
		clan_form_date_sec  : "{$d} 초 전", 
		clan_form_date_min  : "{$d} 분 전", 
		clan_form_date_hour : "{$d} 시간 전", 
		clan_form_date_day  : "{$d} 일 전", 
		clan_form_date_week : "{$d} 주 전", 
		clan_form_date_mon  : "{$d} 달 전", 
		clan_form_date_year : "{$d} 년 전", 
		
		// article_list
		clan_article_list_search_btn: "검색",
		clan_article_list_write_btn: "글쓰기",
		
		// article_write
		clan_article_write_delete_all : "내용 모두 지우기",
		clan_article_write_delete_all_msg : "정말 모두 지우시겠습니까?",
		
		///////////////////////
		// 게시판 관련 Page 들 
		///////////////////////
		
		// web_url_page 
		web_url_page_error_msg: "페이지 로딩중 오류가 발생을 하였습니다.",
		
		// article 공통 적용
		form_date 		 : "{$1}.{$2}.{$3}", 			// 날짜 표시
		form_hour 		 : "{$1}:{$2}",      			// 시간 표시
		form_date_detail : "{$1}.{$2}.{$3} {$4}:{$5}",  // 날짜+시간
		
		// article_list page
		article_list_not_exist_str: "게시글이 없습니다.<br/>새로운 게시글을 등록해 주세요.",
		article_list_not_exist_str2: "게시글이 없습니다.",
		article_list_more_list_str: "더보기",
		article_list_loading_list_str: "로딩중",
		article_list_hit_str: "조회",
		article_list_title: "게시판",
		article_list_search_check1_text: "제목+내용",
		article_list_search_check2_text: "작성자",
		article_list_search_ok_btn: "검색",
		article_list_search_input_holder: "검색어를 입력하세요.",
		article_list_search_keyword_error: "검색어를 입력하세요.",
		
		// article_content_view page
		article_content_view_title: "게시판",
		article_content_view_next_text_str: "다음글",
		article_content_view_prev_text_str: "이전글",
		article_content_view_list_str: "목록",
		article_content_view_list_empty_str: "등록된 글이 없습니다.",
		article_content_view_modify_str : "수정",
		article_content_view_delete_str : "삭제",
		article_content_view_delete_confirm_str : "정말 삭제하시겠습니까?",
		article_content_view_cancel_btn_str: "취소",
		article_content_view_ok_btn_str: "확인",
		article_content_view_delete_success_msg: "글이 삭제되었습니다.",
		
		//article_write page
		article_write_title: "글쓰기",
		article_write_title_input_holder: "제목을 입력 하세요.",
		article_write_content_input_holder: "내용을 입력 하세요.",
		article_write_toolbar_cancel: "취소",
		article_write_toolbar_register: "등록",
		article_write_toolbar_complete: "완료",		
		article_write_toolbar_photo_attach: "사진첨부",
		article_write_delete_cnt_txt: "삭제 하시겠습니까?",
		article_write_title_input_error: "제목을 입력해 주세요.",
		article_write_content_input_error: "내용을 입력해 주세요.",
		article_write_regist_success_msg: "글이 등록 되었습니다.",
		article_write_modify_success_msg: "글이 수정 되었습니다",
		article_write_input_content_empty_msg: "등록할 글을 입력해 주세요.",
		article_write_exist_check_msg: "현재 작성중인 글을 취소 하시겠습니까?",
		article_write_photo_attach_limit_msg: "첨부 가능한 사진 개수는 {$d}개 입니다.",
		article_write_content_text_limit_msg: "쓰기 가능한 최대 글자의 수는 {$d}자 입니다.",
		
		// article_comment_view page
		article_comment_view_count_str: "댓글",
		article_comment_view_not_exist_str: "댓글이 없습니다.<br/>새로운 댓글을 등록해 주세요.",
		article_comment_view_comments_str: "댓글보기",
		article_comment_view_contetn_btn_str: "본문보기",
		article_comment_view_delete_success_msg: "댓글이 삭제 되었습니다.",
		
		// search result page 
		article_search_list_title: "검색결과",
		article_search_list_more_list_str: "더보기",
		article_search_list_hit_str: "조희",
		article_search_list_text : "'{$s}' 검색결과 {$d}건",
		article_search_list_loading_list_str: "로딩중",
		article_search_list_not_exist_str: "검색 결과가 없습니다.<br/>다른 검색어로 다시 검색해 보세요.",
		
		// article common input view 
		article_common_input_view_ok_btn_str: "확인",
		article_common_input_view_cancel_btn_str: "취소",		
		article_common_input_view_delete_comment_str: "정말 삭제 하시겠습니까?",
		article_common_input_view_input_holder: "내용을 입력해 주세요.",
		article_common_input_comment_regist_success_msg: "댓글이 등록 되었습니다.",
		article_common_input_empty_msg: "내용을 입력해 주세요.",
        
		///////////////////////
		// 공통 적용및 기타
		///////////////////////	    
	    // common text
    	com_iscroll_refresh_msg1: "새로 고침 하려면 아래로 내리세요.",
    	com_iscroll_refresh_msg2: "새로 고침 하려면 해제하세요.",
   		com_iscroll_refresh_msg3: "업데이트 중...",		 
	    com_article_unknown_user: "알수없는 사용자",
	    com_clan_article_title: "클랜 게시판",
	    com_not_support_function : "지원하지 않는 기능입니다.",
		com_clan_article_list_notice_prefix: "공지"
	},
	_zh : {
		///////////////////////
		// clan 게시판 
		///////////////////////
		
		// clan article 공통 적용
		clan_form_date_cur  : "之前", 
		clan_form_date_sec  : "{$d} 秒前", 
		clan_form_date_min  : "{$d} 分钟前", 
		clan_form_date_hour : "{$d} 小时前", 
		clan_form_date_day  : "{$d} 日前", 
		clan_form_date_week : "{$d} 周前", 
		clan_form_date_mon  : "{$d} 个月前", 
		clan_form_date_year : "{$d} 年前", 
		
		// article_list
		clan_article_list_search_btn: "搜索",
		clan_article_list_write_btn: "编辑",
		
		// article_write
		clan_article_write_delete_all : "删除全部内容",
		clan_article_write_delete_all_msg : "确认删除全部内容吗？",
		
		///////////////////////
		// 게시판 관련 Page 들 
		///////////////////////

		// web_url_page 
		web_url_page_error_msg: "加载页面中发生了错误.",
		
		// article 공통 적용
		form_date 		 : "{$1}.{$2}.{$3}", 			// 날짜 표시
		form_hour 		 : "{$1}:{$2}",      			// 시간 표시
		form_date_detail : "{$1}.{$2}.{$3} {$4}:{$5}",  // 날짜+시간
		
		// article_list page
		article_list_not_exist_str: "没有留言<br/>请留下留言",
		article_list_not_exist_str2: "没有留言.",
		article_list_more_list_str: "更多",
		article_list_loading_list_str: "加载中",
		article_list_hit_str: "查看",
		article_list_title: "留言板",
		article_list_search_check1_text: "标题+内容",
		article_list_search_check2_text: "作者",
		article_list_search_ok_btn: "搜索",
		article_list_search_input_holder: "请输入搜索语言.",
		article_list_search_keyword_error: "请输入搜索语言.",
		
		// article_content_view page
		article_content_view_title: "留言板",
		article_content_view_next_text_str: "下一条",
		article_content_view_prev_text_str: "上一条",
		article_content_view_list_str: "目录",
		article_content_view_list_empty_str: "还没有人在上面留言",
		article_content_view_modify_str : "修改",
		article_content_view_delete_str : "删除",
		article_content_view_delete_confirm_str : "确认删除吗？",
		article_content_view_cancel_btn_str: "取消",
		article_content_view_ok_btn_str: "确认",
		article_content_view_delete_success_msg: "删除完成.",
		
		//article_write page
		article_write_title: "编辑",
		article_write_title_input_holder: "请输入标题.",
		article_write_content_input_holder: "请输入内容.",
		article_write_toolbar_cancel: "取消",
		article_write_toolbar_register: "发布",
		article_write_toolbar_complete: "完成",		
		article_write_toolbar_photo_attach: "添加照片",
		article_write_delete_cnt_txt: "确认删除吗？",
		article_write_title_input_error: "请输入标题.",
		article_write_content_input_error: "请输入内容.",
		article_write_regist_success_msg: "发布成功.",
		article_write_modify_success_msg: "글이 수정 되었습니다",
		article_write_input_content_empty_msg: "请输入发布的内容.",
		article_write_exist_check_msg: "取消编辑中的内容吗？",
		article_write_photo_attach_limit_msg: "最多添加{$d}张照片",
		article_write_content_text_limit_msg: "最多输入{$d}个字数。",
		
		// article_comment_view page
		article_comment_view_count_str: "评论",
		article_comment_view_not_exist_str: "没有评论<br/>请输入评论",
		article_comment_view_comments_str: "查看评论",
		article_comment_view_contetn_btn_str: "查看原文",
		article_comment_view_delete_success_msg: "评论已删除",
		
		// search result page 
		article_search_list_title: "搜索结果",
		article_search_list_more_list_str: "更多",
		article_search_list_hit_str: "查看",
		article_search_list_text : "'{$s}' 搜索结果 {$d}条",
		article_search_list_loading_list_str: "加载中",
		article_search_list_not_exist_str: "没有搜索结果<br/>请用其他搜索词搜索",
		
		// article common input view 
		article_common_input_view_ok_btn_str: "确认",
		article_common_input_view_cancel_btn_str: "取消",		
		article_common_input_view_delete_comment_str: "确认删除吗？",
		article_common_input_view_input_holder: "请输入内容",
		article_common_input_comment_regist_success_msg: "评论发布成功",
		article_common_input_empty_msg: "请输入内容",
        
		///////////////////////
		// 공통 적용및 기타
		///////////////////////	    	    
	    // common text
    	com_iscroll_refresh_msg1: "向下拉刷新页面",
    	com_iscroll_refresh_msg2: "在刷新之前请解锁",
   		com_iscroll_refresh_msg3: "升级中...",		  
	    com_article_unknown_user: "未知用户",
	    com_clan_article_title: "公会 留言板",
	    com_not_support_function : "不支持此功能。",
		com_clan_article_list_notice_prefix: "通知"
	},
	_ja : {
		///////////////////////
		// clan 게시판 
		///////////////////////
		
		// clan article 공통 적용
		clan_form_date_cur  : "只今", 
		clan_form_date_sec  : "{$d} 秒前", 
		clan_form_date_min  : "{$d} 分前", 
		clan_form_date_hour : "{$d} 時間前", 
		clan_form_date_day  : "{$d} 日前", 
		clan_form_date_week : "{$d} 週間前", 
		clan_form_date_mon  : "{$d} 月前", 
		clan_form_date_year : "{$d} 年前", 
		
		// article_list
		clan_article_list_search_btn: "検索",
		clan_article_list_write_btn: "書き込む",
		
		// article_write
		clan_article_write_delete_all : "内容を全て削除",
		clan_article_write_delete_all_msg : "本当に全て削除しますか？",
		
		///////////////////////
		// 게시판 관련 Page 들 
		///////////////////////
		
		// web_url_page 
		web_url_page_error_msg: "ページローディング中にエラーが発生しました。",
		
		// article 공통 적용
		form_date 		 : "{$1}.{$2}.{$3}", 			// 날짜 표시
		form_hour 		 : "{$1}:{$2}",      			// 시간 표시
		form_date_detail : "{$1}.{$2}.{$3} {$4}:{$5}",  // 날짜+시간
		
		// article_list page
		article_list_not_exist_str: "書き込みがありません。<br/>新しい書き込みを登録してください。",
		article_list_not_exist_str2: "書き込みがありません。",
		article_list_more_list_str: "詳しく見る",
		article_list_loading_list_str: "ローディング中",
		article_list_hit_str: "承合",
		article_list_title: "掲示板",
		article_list_search_check1_text: "タイトル＋内容",
		article_list_search_check2_text: "作成者",
		article_list_search_ok_btn: "検索",
		article_list_search_input_holder: "検索語を入力してください。",
		article_list_search_keyword_error: "検索語を入力してください。",
		
		// article_content_view page
		article_content_view_title: "掲示板",
		article_content_view_next_text_str: "次の書き込み",
		article_content_view_prev_text_str: "前の書き込み",
		article_content_view_list_str: "リスト",
		article_content_view_list_empty_str: "登録した書き込みがありません。",
		article_content_view_modify_str : "修正",
		article_content_view_delete_str : "削除",
		article_content_view_delete_confirm_str : "本当に削除しますか？",
		article_content_view_cancel_btn_str: "取消し",
		article_content_view_ok_btn_str: "確認",
		article_content_view_delete_success_msg: "削除を完了しました。",
		
		//article_write page
		article_write_title: "書き込む",
		article_write_title_input_holder: "タイトルを入力してください。",
		article_write_content_input_holder: "内容を入力してください。",
		article_write_toolbar_cancel: "取消し",
		article_write_toolbar_register: "登録",
		article_write_toolbar_complete: "完了",		
		article_write_toolbar_photo_attach: "写真添付",
		article_write_delete_cnt_txt: "削除しますか？",
		article_write_title_input_error: "タイトルを入力してください。",
		article_write_content_input_error: "内容を入力してください。",
		article_write_regist_success_msg: "書き込みが登録されました。",
		article_write_modify_success_msg: "書き込みが修正されました。",
		article_write_input_content_empty_msg: "登録する内容を入力してください。",
		article_write_exist_check_msg: "現在作成中の内容をキャンセルしますか？",
		article_write_photo_attach_limit_msg: "添付可能な写真枚数は{$d}個です。",
		article_write_content_text_limit_msg: "最大書き込み可能な文字数は{$d}字です。",
		
		// article_comment_view page
		article_comment_view_count_str: "書き込み",
		article_comment_view_not_exist_str: "書き込みがありません。<br/>新しい書き込みを登録してください。",
		article_comment_view_comments_str: "書き込みを見る",
		article_comment_view_contetn_btn_str: "本文を見る",
		article_comment_view_delete_success_msg: "書き込みが削除されました。",
		
		// search result page 
		article_search_list_title: "検索結果",
		article_search_list_more_list_str: "詳しく見る",
		article_search_list_hit_str: "承合",
		article_search_list_text : "'{$s}' 検索結果 {$d}件",
		article_search_list_loading_list_str: "ローディング中",
		article_search_list_not_exist_str: "検索結果がありません。<br/>他の検索語で再度検索してみてください。",
		
		// article common input view 
		article_common_input_view_ok_btn_str: "確認",
		article_common_input_view_cancel_btn_str: "取消し",		
		article_common_input_view_delete_comment_str: "本当に削除しますか？",
		article_common_input_view_input_holder: "内容を入力してください。",
		article_common_input_comment_regist_success_msg: "書き込みが登録されました。",
		article_common_input_empty_msg: "内容を入力してください。",
        
		///////////////////////
		// 공통 적용및 기타
		///////////////////////	    
	    // common text
    	com_iscroll_refresh_msg1: "リロードするには、下にドラッグ",
    	com_iscroll_refresh_msg2: "リロードする場合は解除してください。",
   		com_iscroll_refresh_msg3: "アップデート中….",		 
	    com_article_unknown_user: "不明な使用者",
	    com_clan_article_title: "クラン掲示板",
	    com_not_support_function : "支援していない機能です。",
		com_clan_article_list_notice_prefix: "お知らせ"
	},
	_de : {
		///////////////////////
		// clan 게시판 
		///////////////////////
		
		// clan article 공통 적용
		clan_form_date_cur  : "Soeben", 
		clan_form_date_sec  : "Vor {$d} Sekunden", 
		clan_form_date_min  : "Vor {$d} Minuten", 
		clan_form_date_hour : "Vor {$d} Stunden", 
		clan_form_date_day  : "Vor {$d} Tagen", 
		clan_form_date_week : "Vor {$d} Wochen", 
		clan_form_date_mon  : "Vor {$d} Monaten", 
		clan_form_date_year : "Vor {$d} Jahren", 

		// article_list
		clan_article_list_search_btn: "Suche",
		clan_article_list_write_btn: "Schreiben",		
		
		// article_write
		clan_article_write_delete_all : "Alles löschen",
		clan_article_write_delete_all_msg : "Bist du sicher, dass du alle löschen möchtest?",
		
		///////////////////////
		// 게시판 관련 Page 들 
		///////////////////////
		
		// web_url_page 
		web_url_page_error_msg: "Ein Fehler ist aufgetreten beim Laden der Seite.",
		
		// article 공통 적용
		form_date 		 : "{$2}.{$3}.{$1}", 			// 영어권 날짜 표시 format
		form_hour 		 : "{$1}:{$2}",      			// 시간 표시
		form_date_detail : "{$2}.{$3}.{$1} {$4}:{$5}",  // 영어권 날짜 표시 format (날짜+시간)
		
		// article_list page
		article_list_not_exist_str: "Es gibt keine Artikel.<br/> Bitte lade einen neuen ",
		article_list_not_exist_str2: "Es gibt keine Artikel.",
		article_list_more_list_str: "Mehr",
		article_list_loading_list_str: "Wird geladen",
		article_list_hit_str: "Treffer",
		article_list_title: "Forum",
		article_list_search_check1_text: "Titel + Inhalt",
		article_list_search_check2_text: "Schriftsteller",
		article_list_search_ok_btn: "Suche",
		article_list_search_input_holder: "Suchen nach",
		article_list_search_keyword_error: "Suchen nach",
		
		// article_content_view page
		article_content_view_title: "Forum",
		article_content_view_next_text_str: "Nächster Artikel",
		article_content_view_prev_text_str: "Vorheriger Artikel",
		article_content_view_list_str: "Liste",
		article_content_view_list_empty_str: "Kein Artikel gefunden",
		article_content_view_modify_str : "Bearbeiten",
		article_content_view_delete_str : "Löschen",
		article_content_view_delete_confirm_str : "Bist du sicher, dass du dies löschen möchtest?",
		article_content_view_cancel_btn_str: "Abbrechen",
		article_content_view_ok_btn_str: "Bestätigen",
		article_content_view_delete_success_msg: "Löschen bestätigt.",
		
		//article_write page
		article_write_title: "Schreiben",
		article_write_title_input_holder: "Titel hier eingeben.",
		article_write_content_input_holder: "Inhalt hier eingeben.",
		article_write_toolbar_cancel: "Abbrechen",
		article_write_toolbar_register: "Registrieren",
		article_write_toolbar_complete: "Komplett",		
		article_write_toolbar_photo_attach: "Foto hinzufügen",
		article_write_delete_cnt_txt: "Bist du sicher, dass du dies löschen möchtest?",
		article_write_title_input_error: "Titel hier eingeben.",
		article_write_content_input_error: "Inhalt hier eingeben.",
		article_write_regist_success_msg: "Artikel wurde gelistet.",
		article_write_modify_success_msg: "Artikel wurde geändert.",
		article_write_input_content_empty_msg: "Bitte gebe den Inhalt ein.",
		article_write_exist_check_msg: "Den Artikel, den du gerade schreibst, löschen?",
		article_write_photo_attach_limit_msg: "Maximale Anzahl der erlaubten Bilder ist {$d}.",
		article_write_content_text_limit_msg: "Maximale Anzahl von Wörtern ist {$d}.",
		
		// article_comment_view page
		article_comment_view_count_str: "Kommentar.",
		article_comment_view_not_exist_str: "Es gibt keine Kommentare.<br/>Bitte füge einen neuen Kommentar hinzu.",
		article_comment_view_comments_str: "Kommentare anzeigen.",
		article_comment_view_contetn_btn_str: "Inhalt ansehen.",
		article_comment_view_delete_success_msg: "Kommentar wurde gelöscht.",
		
		// search result page 
		article_search_list_title: "Suchergebnis",
		article_search_list_more_list_str: "Mehr",
		article_search_list_hit_str: "Treffer",
		article_search_list_text : "'{$s}' Suchergebnis: {$d} Ergebnisse",
		article_search_list_loading_list_str: "Wird geladen",
		article_search_list_not_exist_str: "Es gibt keine Suchergebnisse.<br/> Bitte versuche es mit einem anderen Suchbegriff.",
		
		// article common input view 
		article_common_input_view_ok_btn_str: "Ok",
		article_common_input_view_cancel_btn_str: "Abbrechen",		
		article_common_input_view_delete_comment_str: "Bist du sicher, dass du dies löschen möchtest?",
		article_common_input_view_input_holder: "Inhalt eingeben.",
		article_common_input_comment_regist_success_msg: "Kommentar wurde registriert.",
		article_common_input_empty_msg: "Inhalt eingeben.",
		
		///////////////////////
		// 공통 적용및 기타
		///////////////////////	    
	    // common text
    	com_iscroll_refresh_msg1: "Bitte wische nach unten, um zu aktualisieren.",
    	com_iscroll_refresh_msg2: "Abbrechen, um zu aktualisieren.",
   		com_iscroll_refresh_msg3: "Wird aktualisiert ...",		
	    com_article_unknown_user: "unbekannter Benutzer",
	    com_clan_article_title: "Clan Forum",
	    com_not_support_function : "Diese Funktion wird nicht unterstützt.",
		com_clan_article_list_notice_prefix: "Ankündigung"
	},
	_it : {
		///////////////////////
		// clan 게시판 
		///////////////////////
		
		// clan article 공통 적용
		clan_form_date_cur  : "Proprio ora", 
		clan_form_date_sec  : "{$d} secondi fa", 
		clan_form_date_min  : "{$d} minuti fa", 
		clan_form_date_hour : "{$d} ore fa", 
		clan_form_date_day  : "{$d} giorni fa", 
		clan_form_date_week : "{$d} settimane fa", 
		clan_form_date_mon  : "{$d} mesi fa", 
		clan_form_date_year : "{$d} anni fa", 

		// article_list
		clan_article_list_search_btn: "Ricerca",
		clan_article_list_write_btn: "Scrivi",		
		
		// article_write
		clan_article_write_delete_all : "Cancella tutto",
		clan_article_write_delete_all_msg : "Sei sicuro di voler cancellare tutto?",
		
		///////////////////////
		// 게시판 관련 Page 들 
		///////////////////////
		
		// web_url_page 
		web_url_page_error_msg: "Si è verificato un errore durante il caricamento della pagina.",
		
		// article 공통 적용
		form_date 		 : "{$2}.{$3}.{$1}", 			// 영어권 날짜 표시 format
		form_hour 		 : "{$1}:{$2}",      			// 시간 표시
		form_date_detail : "{$2}.{$3}.{$1} {$4}:{$5}",  // 영어권 날짜 표시 format (날짜+시간)
		
		// article_list page
		article_list_not_exist_str: "Non c’è nessun articolo.<br/> Carica nuovo articolo.",
		article_list_not_exist_str2: "Non c’è nessun articolo.",
		article_list_more_list_str: "Altro",
		article_list_loading_list_str: "Caricamento in corso...",
		article_list_hit_str: "Hits",
		article_list_title: "Bacheca messaggi",
		article_list_search_check1_text: "Titolo + Contenuto",
		article_list_search_check2_text: "Scrittore",
		article_list_search_ok_btn: "Ricerca",
		article_list_search_input_holder: "Cerca",
		article_list_search_keyword_error: "Cerca",
		
		// article_content_view page
		article_content_view_title: "Bacheca messaggi",
		article_content_view_next_text_str: "Articolo successivo",
		article_content_view_prev_text_str: "Articolo precedente",
		article_content_view_list_str: "Elenco",
		article_content_view_list_empty_str: "Nessun articolo trovato",
		article_content_view_modify_str : "Modifica",
		article_content_view_delete_str : "Cancella",
		article_content_view_delete_confirm_str : "Sei sicuro di voler eliminare?",
		article_content_view_cancel_btn_str: "Elimina",
		article_content_view_ok_btn_str: "Conferma",
		article_content_view_delete_success_msg: "Eliminazione confermata.",
		
		//article_write page
		article_write_title: "Scrivi",
		article_write_title_input_holder: "Inserisci il titolo qui.",
		article_write_content_input_holder: "Inserisci il contenuto qui.",
		article_write_toolbar_cancel: "Elimina",
		article_write_toolbar_register: "Registra",
		article_write_toolbar_complete: "Completo",		
		article_write_toolbar_photo_attach: "Aggiungi foto",
		article_write_delete_cnt_txt: "Sei sicuro di voler eliminare?",
		article_write_title_input_error: "Inserisci il titolo qui.",
		article_write_content_input_error: "Inserisci il contenuto qui.",
		article_write_regist_success_msg: "L’articolo è stato inserito nell’elenco.",
		article_write_modify_success_msg: "Articolo è stato modificato.",
		article_write_input_content_empty_msg: "Inserisci il contenuto.",
		article_write_exist_check_msg: "Eliminare l'articolo che stai scrivendo?",
		article_write_photo_attach_limit_msg: "Il numero massimo di foto consentito è {$d}.",
		article_write_content_text_limit_msg: "Il numero massimo di parole è {$d}.",
		
		// article_comment_view page
		article_comment_view_count_str: "Commento.",
		article_comment_view_not_exist_str: "Non ci sono commenti.<br/>Aggiungere nuovo commento.",
		article_comment_view_comments_str: "Visualizza commenti.",
		article_comment_view_contetn_btn_str: "Visualizza contenuto.",
		article_comment_view_delete_success_msg: "Il commento è stato cancellato.",
		
		// search result page 
		article_search_list_title: "Risultato della ricerca",
		article_search_list_more_list_str: "Altro",
		article_search_list_hit_str: "Hits",
		article_search_list_text : "'{$s}' Risultato della ricerca: {$d} risultati",
		article_search_list_loading_list_str: "Caricamento in corso...",
		article_search_list_not_exist_str: "Non ci sono risultati di ricerca.<br/> Prova ricercando una frase diversa.",
		
		// article common input view 
		article_common_input_view_ok_btn_str: "Ok",
		article_common_input_view_cancel_btn_str: "Elimina",		
		article_common_input_view_delete_comment_str: "Sei sicuro di voler eliminare?",
		article_common_input_view_input_holder: "Inserisci il contenuto.",
		article_common_input_comment_regist_success_msg: "Il commento è stato registrato.",
		article_common_input_empty_msg: "Inserisci il contenuto.",
		
		///////////////////////
		// 공통 적용및 기타
		///////////////////////	    
	    // common text
    	com_iscroll_refresh_msg1: "Scorri verso il basso per aggiornare.",
    	com_iscroll_refresh_msg2: "Annulla per aggiornare.",
   		com_iscroll_refresh_msg3: "Aggiornamento in corso...",		
	    com_article_unknown_user: "utente sconosciuto",
	    com_clan_article_title: "Clan Consiglio",
	    com_not_support_function : "Questa funzione non è supportata.",
		com_clan_article_list_notice_prefix: "avviso"
	},
	_fr : {
		///////////////////////
		// clan 게시판 
		///////////////////////
		
		// clan article 공통 적용
		clan_form_date_cur  : "À l’instant", 
		clan_form_date_sec  : "Il y a {$d} secondes", 
		clan_form_date_min  : "Il y a {$d} minutes", 
		clan_form_date_hour : "Il y a {$d} heures", 
		clan_form_date_day  : "Il y a {$d} jours", 
		clan_form_date_week : "Il y a {$d} semaines", 
		clan_form_date_mon  : "Il y a {$d} mois", 
		clan_form_date_year : "Il y a {$d} années", 

		// article_list
		clan_article_list_search_btn: "Recherche",
		clan_article_list_write_btn: "Écrire",		
		
		// article_write
		clan_article_write_delete_all : "Tout effacer",
		clan_article_write_delete_all_msg : "Êtes-vous sûr de vouloir tout effacer ?",
		
		///////////////////////
		// 게시판 관련 Page 들 
		///////////////////////
		
		// web_url_page 
		web_url_page_error_msg: "Une erreur est survenue lors du chargement de la page.",
		
		// article 공통 적용
		form_date 		 : "{$2}.{$3}.{$1}", 			// 영어권 날짜 표시 format
		form_hour 		 : "{$1}:{$2}",      			// 시간 표시
		form_date_detail : "{$2}.{$3}.{$1} {$4}:{$5}",  // 영어권 날짜 표시 format (날짜+시간)
		
		// article_list page
		article_list_not_exist_str: "Il n’existe aucun article.<br/> Veuillez télécharger un nouvel article.",
		article_list_not_exist_str2: "Il n’existe aucun article.",
		article_list_more_list_str: "Plus",
		article_list_loading_list_str: "Chargement en cours",
		article_list_hit_str: "Impacts",
		article_list_title: "Tableau d’affichage",
		article_list_search_check1_text: "Titre + Contenu",
		article_list_search_check2_text: "Rédacteur",
		article_list_search_ok_btn: "Recherche",
		article_list_search_input_holder: "Rechercher",
		article_list_search_keyword_error: "Rechercher",
		
		// article_content_view page
		article_content_view_title: "Tableau d’affichage",
		article_content_view_next_text_str: "Article suivant",
		article_content_view_prev_text_str: "Article précédent",
		article_content_view_list_str: "Liste",
		article_content_view_list_empty_str: "Aucun article trouvé",
		article_content_view_modify_str : "Modifier",
		article_content_view_delete_str : "Effacer",
		article_content_view_delete_confirm_str : "Êtes-vous sûr de vouloir supprimer ceci ?",
		article_content_view_cancel_btn_str: "Annuler",
		article_content_view_ok_btn_str: "Confirmer",
		article_content_view_delete_success_msg: "Suppression confirmée.",
		
		//article_write page
		article_write_title: "Écrire",
		article_write_title_input_holder: "Saisir le titre ici.",
		article_write_content_input_holder: "Saisir le contenu ici.",
		article_write_toolbar_cancel: "Annuler",
		article_write_toolbar_register: "S’enregistrer",
		article_write_toolbar_complete: "Terminer",		
		article_write_toolbar_photo_attach: "Ajouter une photo",
		article_write_delete_cnt_txt: "Êtes-vous sûr de vouloir supprimer ceci ?",
		article_write_title_input_error: "Saisir le titre ici.",
		article_write_content_input_error: "Saisir le contenu ici.",
		article_write_regist_success_msg: "L’article a été classé.",
		article_write_modify_success_msg: "Article a été modifié.",
		article_write_input_content_empty_msg: "Veuillez saisir le contenu.",
		article_write_exist_check_msg: "Jeter l'article que vous êtes en train d'écrire ?",
		article_write_photo_attach_limit_msg: "Le nombre maximal de photos autorisée est de{$d}.",
		article_write_content_text_limit_msg: "Le nombre maximum de mots est de{$d}.",
		
		// article_comment_view page
		article_comment_view_count_str: "Commentaire.",
		article_comment_view_not_exist_str: "Il n'y a aucun commentaire.<br/>Veuillez ajouter un commentaire.",
		article_comment_view_comments_str: "Voir les commentaires.",
		article_comment_view_contetn_btn_str: "Voir le contenu.",
		article_comment_view_delete_success_msg: "Le commentaire a été effacé.",
		
		// search result page 
		article_search_list_title: "Résultat de la recherche",
		article_search_list_more_list_str: "Plus",
		article_search_list_hit_str: "Impacts",
		article_search_list_text : "'{$s}' Résultat de la recherche: {$d} résultats",
		article_search_list_loading_list_str: "Chargement en cours",
		article_search_list_not_exist_str: "Il n'y a pas de résultats de recherche.<br/> Veuillez essayer une formulation de recherche différente.",
		
		// article common input view 
		article_common_input_view_ok_btn_str: "Ok",
		article_common_input_view_cancel_btn_str: "Annuler",		
		article_common_input_view_delete_comment_str: "Êtes-vous sûr de vouloir supprimer ceci ?",
		article_common_input_view_input_holder: "Entrez le contenu.",
		article_common_input_comment_regist_success_msg: "Le commentaire a été enregistré.",
		article_common_input_empty_msg: "Entrez le contenu.",
		
		///////////////////////
		// 공통 적용및 기타
		///////////////////////	    
	    // common text
    	com_iscroll_refresh_msg1: "Veuillez balayer vers le bas pour rafraîchir.",
    	com_iscroll_refresh_msg2: "Annuler pour rafraîchir.",
   		com_iscroll_refresh_msg3: "Mise à jour en cours...",		
	    com_article_unknown_user: "utilisateur inconnu",
	    com_clan_article_title: "Conseil clan",
	    com_not_support_function : "Cette fonction ne est pas supportée.",
		com_clan_article_list_notice_prefix: "avis"
	},
	_es : {
		///////////////////////
		// clan 게시판 
		///////////////////////
		
		// clan article 공통 적용
		clan_form_date_cur  : "En este momento", 
		clan_form_date_sec  : "Hace {$d} segundos", 
		clan_form_date_min  : "Hace {$d} minutos", 
		clan_form_date_hour : "Hace {$d} horas", 
		clan_form_date_day  : "Hace {$d} días", 
		clan_form_date_week : "Hace {$d} semanas", 
		clan_form_date_mon  : "Hace {$d} meses", 
		clan_form_date_year : "Hace {$d} años", 

		// article_list
		clan_article_list_search_btn: "Búsqueda",
		clan_article_list_write_btn: "Escribir",		
		
		// article_write
		clan_article_write_delete_all : "Borrar todo",
		clan_article_write_delete_all_msg : "¿Seguro que quiere borrar todo?",
		
		///////////////////////
		// 게시판 관련 Page 들 
		///////////////////////
		
		// web_url_page 
		web_url_page_error_msg: "Ocurrió un error al cargar la página.",
		
		// article 공통 적용
		form_date 		 : "{$2}.{$3}.{$1}", 			// 영어권 날짜 표시 format
		form_hour 		 : "{$1}:{$2}",      			// 시간 표시
		form_date_detail : "{$2}.{$3}.{$1} {$4}:{$5}",  // 영어권 날짜 표시 format (날짜+시간)
		
		// article_list page
		article_list_not_exist_str: "No hay ningún artículo.<br/> Por favor, suba artículo nuevo.",
		article_list_not_exist_str2: "No hay ningún artículo.",
		article_list_more_list_str: "Más",
		article_list_loading_list_str: "Cargando",
		article_list_hit_str: "Aciertos",
		article_list_title: "Tablero de mensajes",
		article_list_search_check1_text: "Título+Contenido",
		article_list_search_check2_text: "Escritor",
		article_list_search_ok_btn: "Búsqueda",
		article_list_search_input_holder: "Buscar",
		article_list_search_keyword_error: "Buscar",
		
		// article_content_view page
		article_content_view_title: "Tablero de mensajes",
		article_content_view_next_text_str: "Artículo siguiente",
		article_content_view_prev_text_str: "Artículo anterior",
		article_content_view_list_str: "Lista",
		article_content_view_list_empty_str: "Ningún artículo encontrado",
		article_content_view_modify_str : "Editar",
		article_content_view_delete_str : "Borrar",
		article_content_view_delete_confirm_str : "¿Está seguro que quiere borrar esto?",
		article_content_view_cancel_btn_str: "Cancelar",
		article_content_view_ok_btn_str: "Confirmar",
		article_content_view_delete_success_msg: "Eliminar confirmado.",
		
		//article_write page
		article_write_title: "Escribir",
		article_write_title_input_holder: "Introduzca el título aquí.",
		article_write_content_input_holder: "Introduzca el contenido aquí.",
		article_write_toolbar_cancel: "Cancelar",
		article_write_toolbar_register: "Registrarse",
		article_write_toolbar_complete: "Completo",		
		article_write_toolbar_photo_attach: "Añadir foto",
		article_write_delete_cnt_txt: "¿Está seguro que quiere borrar esto?",
		article_write_title_input_error: "Introduzca el título aquí.",
		article_write_content_input_error: "Introduzca el contenido aquí.",
		article_write_regist_success_msg: "Artículo ha sido incluido.",
		article_write_modify_success_msg: "El artículo ha sido modificado.",
		article_write_input_content_empty_msg: "Por favor ingrese contenido.",
		article_write_exist_check_msg: "¿Desechar el artículo que está escribiendo actualmente?",
		article_write_photo_attach_limit_msg: "El número máximo de fotos permitido es {$d}.",
		article_write_content_text_limit_msg: "El número máximo de palabras es {$d}.",
		
		// article_comment_view page
		article_comment_view_count_str: "Comentario.",
		article_comment_view_not_exist_str: "No hay comentarios.<br/>Por favor, añada nuevo comentario.",
		article_comment_view_comments_str: "Ver los comentarios.",
		article_comment_view_contetn_btn_str: "Ver el contenido.",
		article_comment_view_delete_success_msg: "El comentario ha sido borrado.",
		
		// search result page 
		article_search_list_title: "Resultado de la búsqueda",
		article_search_list_more_list_str: "Más",
		article_search_list_hit_str: "Aciertos",
		article_search_list_text : "'{$s}' Buscar resultado: {$d} resultados",
		article_search_list_loading_list_str: "Cargando",
		article_search_list_not_exist_str: "No hay resultados de búsqueda.<br/> Por favor, intente con una frase de búsqueda diferente.",
		
		// article common input view 
		article_common_input_view_ok_btn_str: "De acuerdo",
		article_common_input_view_cancel_btn_str: "Cancelar",		
		article_common_input_view_delete_comment_str: "¿Seguro que quiere borrar esto?",
		article_common_input_view_input_holder: "Ingrese contenido.",
		article_common_input_comment_regist_success_msg: "El comentario ha sido registrado.",
		article_common_input_empty_msg: "Ingrese contenido.",
		
		///////////////////////
		// 공통 적용및 기타
		///////////////////////	    
	    // common text
    	com_iscroll_refresh_msg1: "Por favor, deslizar hacia abajo para actualizar.",
    	com_iscroll_refresh_msg2: "Cancelar con el fin de actualizar.",
   		com_iscroll_refresh_msg3: "Actualizando...",		
	    com_article_unknown_user: "usuario desconocido",
	    com_clan_article_title: "Junta clan",
	    com_not_support_function : "Esta función no es compatible.",
		com_clan_article_list_notice_prefix: "aviso"
	},
};
