
$(document).ready(function() {
                  
                  $(".button").mousedown(function() {
                                         $(this).addClass("hover");
                                         $(this).find(".left").addClass("hover");
                                         $(this).find(".center").addClass("hover");
                                         $(this).find(".right").addClass("hover");
                                         });
                  $(".button").mouseup(function() {
                                       $(this).removeClass("hover");
                                       $(this).find(".left").removeClass("hover");
                                       $(this).find(".center").removeClass("hover");
                                       $(this).find(".right").removeClass("hover");
                                       });
                  
                  $(".button").live("touchstart", function() {
                                    $(this).addClass("hover");
                                    $(this).find(".left").addClass("hover");
                                    $(this).find(".center").addClass("hover");
                                    $(this).find(".right").addClass("hover");
                                    });
                  $(".button").live("touchend", function() {
                                    $(this).removeClass("hover");
                                    $(this).find(".left").removeClass("hover");
                                    $(this).find(".center").removeClass("hover");
                                    $(this).find(".right").removeClass("hover");
                                    });
                  $(".button").live("touchmove", function() {
				              		$(this).removeClass("hover");
				              		$(this).find(".left").removeClass("hover");
				              		$(this).find(".center").removeClass("hover");
				              		$(this).find(".right").removeClass("hover");
				              		});
                  });

String.prototype.trim = function() {
    return this.replace(/(^\s*)|(\s*$)/gi, "");
};



// HubUtil
function HubUtil() {
	// call back function 실행시 scope 을 this 로 설정해주는 함수
	this.bind = function(scope, fn) {
		return function() {
			fn.apply(scope, arguments);
		};
	};
    
	// json 을 비교하는 형식, 속도를 위해서 단순한 data 형식의 json 만 비교한다.
	// refernce come from   http://stackoverflow.com/questions/1068834/object-comparison-in-javascript
	this.jsonEquals = function(lhsJson, rhsJson) {
		// 같은 object를 참조하고 있거나 둘 다 null 이면 둘은 동일하다.
		if (lhsJson == rhsJson)
			return true;
		// 둘 중 하나가 null 이면 둘은 다르다.
		if (!lhsJson || !rhsJson)
			return false;
		
		// lhsJson 에 있는 것들이 다 에 있다.
		for (item in lhsJson) {
			if (typeof(rhsJson[item]) == 'undefined') {
				return false;
			}
		}
		
		// rhsJson 에 있는 것들이 다 lhsJson에 있다.
		for (item in rhsJson) {
			if (typeof(lhsJson[item]) == 'undefined') {
				return false;
			}
		}
		
		// lhsJson 이 있는 것과
		for (item in lhsJson) {
			lhsValue = lhsJson[item];
			rhsValue = rhsJson[item];
			if (lhsValue) {
				switch (typeof(lhsValue)) {
					case 'object':
						if (!this.jsonEquals(lhsValue, rhsValue)) {
							return false;
						}
						break;
					default:
						if (lhsValue != rhsValue) {
							return false;
						}
				}
			}
			else {
				if (rhsJson[item])
					return false;
			}
		}
		return true;
	};
    
	// defaultArray 에는 있으나 baseArray 에는 없는 값을 update  해서 새로운 array 를 만들어 낸다.
	this.arrayUpdate = function(baseArray, defaultArray) {
		if (!baseArray || baseArray == undefined)
			baseArray = {};
		
		var newArray = {};
		for (var key in defaultArray) {
			if (!(key in baseArray))
				newArray[key] = defaultArray[key];
			else
				newArray[key] = baseArray[key];
		}
		
		// baseArray에만 있는 값을 찾아서 넣어준다.
		for (var key in baseArray) {
			if (!(key in defaultArray))
				newArray[key] = baseArray[key];
		}
		
		return newArray;
	};
	
	this.convertDisplayText = function(orgText, newLineSupport) {
		var str = orgText;
		str = str.split("&").join("&amp;").split("<").join("&lt;").split(">").join("&gt;").split("  ").join(" &nbsp;");
		
		if(newLineSupport)
			str = str.split("\r\n").join("<br/>").split("\r").join("<br/>").split("\n").join("<br/>");
		return str;
	};
	
	this.minWidth = function() {
		if (hubUtil.isIOS()) {
			if(screen.height > screen.width )
				return screen.width;
			else
				return screen.height;
		}
		
		var orientation = Math.abs(window.orientation) == 90 ? 'landscape' : 'portrait';
		if (orientation == 'portrait')
			return window.outerWidth;
        return window.outerHeight;
        
	};
    
	this.minHeight = function() {
		var orientation = Math.abs(window.orientation) == 90 ? 'landscape' : 'portrait';
		if (orientation == 'landscape')
			return window.outerWidth;
        return window.outerHeight;
	};
    
    this.isIOS = function(){
        if (hubAppInfo &&  hubAppInfo.os == 'ios')
            return true;
        
        if (!hubAppInfo || !hubAppInfo.os) {
            if( navigator.userAgent.match(/iPhone/i) || navigator.userAgent.match(/iPod/i) || navigator.userAgent.match(/iPad/i) )
                return true;
        }
        return false;
    };
    
    this.getOSVersion = function(){
        // boot 함수 호출 전에는 os_version 이 없을 수 있고, 이 때는 이 함수를 사용해서는 안된다.
        // useragent 를 이용한 방법으로 버전만 뽑아 오기는 어렵다.
        if(hubAppInfo.os_version)
            return hubAppInfo.os_version;
        return undefined;
    };
    
    this.frameHeightChange = function(height){
        $(".frame").css({'height':height});
    };
    
    this.trim = function(str) {
        return str.replace(/\s/g, "");
    };
    
    // 20131129 add - isEnable- true : enable button, false : disable button
	this.setEnableBtn = function(id, isEnable) {
		if (isEnable == true) { // enable button
        	$(id).removeClass("disabled");
        	$(id + " .left").removeClass("disabled");
        	$(id + " .center").removeClass("disabled");
        	$(id + " .right").removeClass("disabled");
        	$(id).prop('disabled', false);
		} else { // disable button
        	$(id).addClass("disabled");
        	$(id + " .left").addClass("disabled");
        	$(id + " .center").addClass("disabled");
        	$(id + " .right").addClass("disabled");
        	$(id).prop('disabled', true);
		}
	};
	
	// 20131216 add - 현재 Button 의 enable/disable 상태 Check. 
	this.isEnableBtn = function(id) {
		if ($(id).hasClass('disabled'))
			return false;
		else
			return true;
	};
	
};
var hubUtil = new HubUtil();


// HubConfig
function HubConfig() {
    this._logEnable 	   = false;
    
    this.logEnable = function() {
        return this._logEnable;
    };   
};
var hubConfig = new HubConfig();


// HubApi
function HubApi() {
    this.requestId = undefined;
    this.invokeReturn = undefined;
    
	this._isCalledDialog = false;
	
	this.request = function(param, callback) {
		hubLog.i("web", "hubApi.request");
		var requestId;
		if (typeof hubBridge !== "undefined" && hubBridge !== null) {
			if (typeof hubBridge.request === "function") {
                hubProgress.showWaitProgress(true, null);
				requestId = hubBridge.request(JSON.stringify(param), callback);
				return requestId;
			}
		}
                
		hubProgress.showWaitProgress(true, null);
		
        // ios 인 경우
        if(hubUtil.isIOS()){
            this.requestId = undefined;
            
            var iFrame = document.createElement("IFRAME");
            iFrame.style.width = "0px";
            iFrame.style.height = "0px";
            iFrame.style.border = "0px";
            iFrame.setAttribute("src", "hub://api/request?param=" + encodeURIComponent(JSON.stringify(param)) +"&callback=" + callback);
            document.body.appendChild(iFrame);
            iFrame.parentNode.removeChild(iFrame);
            iFrame = null;
            return this.requestId;
        } 
	};
	
	this.onResponse = function(callback, response) {
		hubLog.i("web", "hubApi.onResponse callback " + callback + " response.requestId " + response.requestId);
		responseStr = JSON.stringify(response);
        hubProgress.hideWaitProgress();
		if(response.error == 9001){ //서버점검중인 경우
			if(this._isCalledDialog) //이미 다이얼로그가 떠있는경우
				return;
            
			this._isCalledDialog= true;
			
			var msg;
			if (hubAppInfo.lang == "ko" && response.result.ko != "undefined") {
				msg = response.result.ko;
			} else if (hubAppInfo.lang == "ja" && response.result.ja != "undefined") {
				msg = response.result.ja;
			} else if (hubAppInfo.lang == "zh" && response.result.zh != "undefined") {
				msg = response.result.zh;
			} else { //default는 영어
				if( response.result.en != "undefined")
					msg = response.result.en;
				else
					msg = "server inspection";
			}
			
			hubDialog.showOkDialog(msg , 'hubApi.closeWebpage');
			return;
		}
		script = callback + "(" + responseStr + ");";
		hubLog.i("web", script);
		eval(script);
	};
	
	this.closePage = function(){
		this._isCalledDialog = false;
		hubNavigator.close();
	};
	
	this.cancel = function(requestId) {
		hubLog.i("web", "hubApi.cancel requestId " + requestId);
		if (typeof hubBridge !== "undefined" && hubBridge !== null) {
			if (typeof hubBridge.cancel === "function") {
				hubBridge.cancel(requestId);
				return;
			}
		}
        
        
        // ios 인 경우
        if(hubUtil.isIOS()){
            var iFrame = document.createElement("IFRAME");
            iFrame.style.width = "0px";
            iFrame.style.height = "0px";
            iFrame.style.border = "0px";
            iFrame.setAttribute("src", "hub://api/cancel?requestId=" + requestId);
            document.body.appendChild(iFrame);
            iFrame.parentNode.removeChild(iFrame);
            iFrame = null;
            return;
        }
	};
	
	this.onEvent = function(param) {
		hubLog.i("web", "hubApi.onEvent param " + param);
		hubEventReceiver.onEvent(param);
	};
	
	this.invoke = function(param, callback) {
		if (typeof hubBridge !== "undefined" && hubBridge !== null) {
			if (typeof hubBridge.invoke === "function") {
				var result = hubBridge.invoke(JSON.stringify(param), callback);
				if (result != undefined && result != null)
					return JSON.parse(result);
				else
					return null;
			}
		}
        
        
        // ios 인 경우
        if(hubUtil.isIOS()){
            this.invokeReturn = undefined;
            
            var iFrame = document.createElement("IFRAME");
            iFrame.style.width = "0px";
            iFrame.style.height = "0px";
            iFrame.style.border = "0px";
            iFrame.setAttribute("src", "hub://api/invoke?param="+ encodeURIComponent(JSON.stringify(param)) + "&callback=" + callback);
            document.body.appendChild(iFrame);
            iFrame.parentNode.removeChild(iFrame);
            iFrame = null;
            if (this.invokeReturn != undefined && this.invokeReturn != null)
                return this.invokeReturn;
            else
                return null;
        }
	};
    
	// 2013/08/30 add for external html url link
    this.agreeDetailApi = function(url) {
		hubLog.i("web", "hubApi.agreeDetailApi url-" + url);
		if (typeof hubBridge !== "undefined" && hubBridge !== null) {
			if (typeof hubBridge.agreeDetailApi === "function") {
				hubBridge.agreeDetailApi(url);
				return;
			}
		}   	
    }
    
    // 2013/09/09 add for show input activity ui
    this.showInputUIApi = function(arg, callback) {
    	hubLog.i("web", "hubApi.showInputUIApi");


        var param = {
                "function" : "showInputUI",
                "argument" : {
            		title_text 			 	: arg.title_text,
            		input_placeholder_text  : arg.input_placeholder_text,
            		input_type 			 	: arg.input_type,
            		input_value 			: arg.input_value,
            		request_input_box_id    : arg.request_input_box_id
                }
            };

    	hubApi.invoke(param, callback);
    } 
    
    this.cancelWebApi = function() {
        
        var param = {
            "function" : "webApiReturn",
            "argument" : {
                type : "agree",
                result : "request cancled",
                error : 906,
            }
        };
        hubApi.invoke(param, null);
        
        
        param = {
            "function" : "close",
        };
        hubApi.invoke(param, null);
    }
	
	this.onInvokeResult = function(callback, response) {
		hubLog.i("web", "hubApi.onInvokeResult callback " + callback + " response " + JSON.stringify(response));
		
		var resultStr = JSON.stringify(response.result);
		script = callback + "(" + resultStr + ");";
		hubLog.i("web", "hubApi.onInvokeResult script " + script);
		eval(script);
		
		hubLog.i("web", "hubApi.onInvokeResult return");
	};
};
var hubApi = new HubApi();

// HubLog
function HubLog() {
	this.i = function(tag, text) {
		this._log("i", tag, text);
	};
	this.d = function(tag, text) {
		this._log("d", tag, text);
	};
	this.w = function(tag, text) {
		this._log("w", tag, text);
	};
	this.e = function(tag, text) {
		this._log("e", tag, text);
	};
	this._log = function(level, tag, text) {
        if(!hubConfig.logEnable())
            return;
        
		var param = {
			'function' : 'log',
			'argument' : {
				'level' : level,
				'tag' : tag,
				'text' : text
			}
		};
		hubApi.invoke(param, null);
	};
};
var hubLog = new HubLog();

// HubNavigator
function HubNavigator() {
	this._newFilename = "";
	this._scrollTop = 0;
	this._newParam = {};
	this._backParam = {};
	this._oldNavigationOption = {};
	this._requestMode = "";
	this._navigating = false;
	
	// 브라우저 초기 구동시 animation
	this._newNavigationOption = {
		sliding : "left",
		header : false,
		footer : false
	};
	this._DEFAULT_NAVEGATION_OPTION = {
		sliding : "left",
		header : true,
		footer : true
	};
	this._oldhubPage = null;
	this._DEFAULT_HEADER_STRUCTURE = {
		title : "",
		left : "back",
		right : "close",
		progress : false,
		show : true
	};
	this._DEFAULT_FOOTER_STRUCTURE = {
		show : true
	};
	
	this.boot = function() {
        
		hubLog.i("web", "hubNavigator.boot");
		
		//hubEffector.setup();
		
		// boot, appinfo, start page
		var param 		= { 'function' : "boot" };
		var ret   		= hubApi.invoke(param, null);
		var style_file 	= "style/common.css";
        
		if (ret != undefined && ret.result != undefined) {
			hubAppInfo = ret.result;
		}
        
		// FIX ME .. 추후 native 단에서 전달 받아서 값을 저장 하도록 처리 할것. 
		hubAppInfo.x_profile = "v1n";	
		
        if(hubUtil.isIOS()) {
            var meta = "user-scalable=no, initial-scale=1.0, minimum-scale=1.0, maximum-scale=1.0";
            this.viewportChange(meta);
        } else {
            var meta = "user-scalable=no, initial-scale=1.0, minimum-scale=1.0, maximum-scale=1.0 , width=device-width"
            //var meta = "user-scalable=no, initial-scale=1.0, minimum-scale=1.0, maximum-scale=1.0, target-densitydpi=device-dpi, width=device-width, height=device-height"  ;
            this.viewportChange(meta);            
        }      
        
		if (hubAppInfo.page == undefined) {
			hubAppInfo.page = "agree.html";		
			// hubAppInfo.page = "pc_debug.html"; // pc 브라우져로 확인시 사용
		} else {
            hubAppInfo.page += ".html";
		}
		
		if (hubAppInfo.param == undefined) {
			hubAppInfo.param = null;
		}
		
		// html 의 종류에 따라 CSS 파일을 다르게 사용 (login/profile: common.css 사용, 게시판:common_article_theme_x.css 사용)
        var headID 		= document.getElementsByTagName("head")[0];         
        var cssNode 	= document.createElement('link');
        cssNode.rel 	= 'stylesheet';
        cssNode.href 	= style_file;
        headID.appendChild(cssNode);  
		
        var fileLocation = "./"+hubAppInfo.page;
        var response = $.ajax({
                              url: fileLocation,
                              type: 'HEAD',
                              async: false
                              }).status;
        if(response == 200){
            // 첫 페이지는 effect 없이 보여준다
            hubNavigator.go(hubAppInfo.page, hubAppInfo.param, {sliding:"none"});
        } else {
            hubToast.show("file not found. file_name: "+ hubAppInfo.page);
            var param = {"function":"close"};
            hubApi.invoke(param, null);
        }

	};
	
	this.go = function(filename, param, navigationOption){
		hubLog.i("web", "hubNavigator.go filename " + filename);
		this._backParam = undefined;
		this._scrollTop = 0;
		if (hubPage.structure && hubPage.structure.pageType == "popup") {
			hubLog.i("web", "hubNavigator.go err : pageType of current page is not normal");
			return;
		}
        
		// 현재 페이지와 동일한 정보를 읽어오는 것과 같다면 페이지 이동하지 않는다.
		if (hubHistory.checkPageReload(filename, param))
			return;
		if(this._navigating)
			return;
		this._navigating = true;
        
		this._newFilename = filename;
		this._newParam = param;
		
		this._oldNavigationOption = this._newNavigationOption;
		this._newNavigationOption = {};
		
		if (typeof navigationOption != "object" || navigationOption == null)
			navigationOption = {}
		
		// 넘어온  navigationOption 안의 값을 복사하고 해당 키가 없는 경우 _DEFAULT_NAVEGATION_OPTION 값의 key 를 복사한다.
		this._newNavigationOption = hubUtil.arrayUpdate(navigationOption, this._DEFAULT_NAVEGATION_OPTION);
		
		// 현재 페이지의 정보를 저장한다.
        var scrollTop = $(window).scrollTop();
		//var scrollTop = $("body").scrollTop();
		hubHistory.savePageInfo(filename, param, scrollTop, this._newNavigationOption);

		// ajax file load
		$.get(filename, hubUtil.bind(this, this._onFileLoad)).error( hubUtil.bind(this, this._onFileLoadFail));
	};
	
	this.back = function(backParam){
		hubLog.i("web", "hubNavigator.back param" +  JSON.stringify(backParam) );
		this._backParam = backParam;
		window.setTimeout(hubUtil.bind(this, this._back), 1);
	}
	
	this._back = function(){
		if (hubPage.structure && hubPage.structure.pageType == "popup"){
			hubLog.i("web", "hubNavigator.back err : pageType of current page is not normal");
			return;
		}
		
		if(this._navigating)
			return;
		var prevPageInfo = hubHistory.getPrevPageInfo();
		if (prevPageInfo == false) {
			this.close();
			return;
		}
		var prevPageFragment = hubHistory.loadPageFragement();
		if (!prevPageFragment)
			return this.go(prevPageInfo.filename , prevPageInfo.param, prevPageInfo.navigationOption);
		
		this._navigating = true;
		
		// 저장된 pageDomTree가 있는 경우, DOM Tree자체를 저장해 두고 이 DOM Tree자체를 추가 하도록 한다.
		this._newFilename = prevPageInfo.filename;
		this._newParam = prevPageInfo.param;
		this._oldNavigationOption = this._newNavigationOption;
		this._newNavigationOption = {};
		this._newNavigationOption = prevPageInfo.navigationOption;
		this._prevPageFragment = prevPageFragment;
		this._scrollTop = prevPageInfo.scrollTop;
		
		this._onFileLoad(prevPageFragment.frameDomTree.children());
	};
	
	this.close = function() {
		hubLog.i("web", "hubNavigator.close");
		param = {
			'function': "close"
		};
		hubApi.invoke(param, null);
	};
    
    this.viewportChange = function(content)
    {
        $("#viewport").attr("content", content);
    }
	
    
    this._onFileLoadFail = function(){
	 	this._navigating = false;
    }
    
	this._onFileLoad = function(data) {
		hubLog.i("web", "hubNavigator._onFileLoad");
        
		// exit
		if (hubPage.structure != undefined) {
			if (hubPage.structure.exit != undefined) {
				hubPage.structure.exit();
			}
		}
	
		hubPageReplacer.replace(data, this._newNavigationOption.sliding, this._scrollTop, hubUtil.bind(this, this._slidingComplete), {});
		//(data, slidingDir, compleateCallback, callbackData)
	};
	
	this._slidingComplete = function(_oldframe){
		hubLog.i("web", "hubNavigator._onSlidingComplete");
		
		if (hubHistory.isHistoryBack() || hubPage.structure.history == false) {
			//////// oldFrame을 저장하지 않고 지워야 하는 경우 ////////
			_oldframe.empty();
			_oldframe.remove();
			// clear
			hubPage.private = undefined;
			hubPage.private = {};
			hubPage.structure = undefined;
			hubPage.structure = {};
		} else {
			//////// oldFrame을 저장헤애 하는 경우 ////////
			hubHistory.savePageFragement(_oldframe, hubPage);
			_oldframe.detach();
			// history 를 저장해야 하는 경우, hubHistory 의 _historyFragmentStack 값이 지워지지 않게 해야 한다.
			hubPage = {};
			hubPage.private = {};
			hubPage.structure = {};
		}
		
		if (this._prevPageFragment) {
			//////// _historyFragmentStack 에 저장된 DOM과 hubPage object 를 이용하는 경우 ////////
			hubPage = this._prevPageFragment.hubPage;
			this._prevPageFragment = null;
			
			// 기존 header, footer  의 show 상태 복원
			//hubHeader.show(hubPage.structure.header.show);
			//hubFooter.show(hubPage.structure.footer.show);
			
			this._requestMode = "back";
			
		} else {
			//////// hubNavigator.go 나 _historyFragmentStack 을 이용하지 못한 back 인 경우 ////////
			// script run
			script = document.getElementById("script");
			if (script != undefined) {
				scriptText = script.innerHTML;
				try {
					eval(scriptText);
				}
				catch(err){
					var errMsg = "page eval error \n";
					hubToast.show(errMsg + err);
				}
			}
			
			if (hubPage.structure == undefined) {
				hubPage.structure = {};
			}
			
			// structure.request 에서 header, footer 설정할 수 있음.
			// DOM과 hubPage object 를 이용하는 경우 이미 structure 구조가 구성되어 있어 불필요함.
			hubPage.structure = hubUtil.arrayUpdate(hubPage.structure, {
                                                    header: {},
                                                    footer: {},
                                                    history: true,
                                                    pageType: "normal"
                                                    });
			
			// go 옵션의  header, footer 에 의해 show 상태 설정
			//hubHeader.show(this._newNavigationOption.header);
			//hubFooter.show(this._newNavigationOption.footer);
			
			this._requestMode = "go";
		}
		
		// header, footer
		var hfinvokeparam = {
			"function": "headerfooter",
			"argument": {
            header: {},
            footer: {},
			},
		};
        
		hfinvokeparam.argument.header = hubUtil.arrayUpdate(hubPage.structure.header, this._DEFAULT_HEADER_STRUCTURE);
		hfinvokeparam.argument.footer = hubUtil.arrayUpdate(hubPage.structure.footer, this._DEFAULT_FOOTER_STRUCTURE);
		if (this._newFilename == "home.html") {
			hfinvokeparam.argument.footer.select = "home";
		} else if (this._newFilename == "games.html") {
			hfinvokeparam.argument.footer.select = "games";
		} else if (this._newFilename == "friends.html") {
			hfinvokeparam.argument.footer.select = "friends";
		} else if (this._newFilename == "message.html") {
			hfinvokeparam.argument.footer.select = "message";
		}
		hubApi.invoke(hfinvokeparam, null);
		
		// history
		hubHistory.clearHistoryBack();
		
		window.setTimeout(hubUtil.bind(this, this._request), 1);
		//this._request();
	};
	
	this._request = function() {
		// request
		if (hubPage.structure.request != undefined) {
			hubPage.structure.request(this._newParam, this._requestMode, this._backParam);
		}
		this._navigating = false;
		hubLog.i("web", "hubNavigator go done " + hubNavigator._newFilename);
	};
};
var hubNavigator = new HubNavigator();

// HubPageReplacer
function HubPageReplacer() {
	this._newData = ''
	this._completeCallback = ''
	this._slidingDir = ''
	this._scrollTop = 0;
	
	this._newEffectTime =  undefined;
    this._newEffectTime_IOS = 300;
    this._newEffectTime_default = 100;
	
	this._oldframe = undefined;
	this._newframe = undefined;
	
	this.replace = function(newData, slidingDir, scrollTop, completeCallback) {
		hubLog.i("web", "hubPageReplacer.replace");
        
        this._oldframe = undefined;
        this._newframe = undefined;
        this._newEffectTime = hubUtil.isIOS()? this._newEffectTime_IOS : this._newEffectTime_default;
		this._newData = newData;
		this._slidingDir = slidingDir;
		this._scrollTop = scrollTop;
		this._completeCallback = completeCallback;
		window.setTimeout(hubUtil.bind(this, this._startSliding), 1);
	};
	
	this._startSliding = function() {
		hubLog.i("web", "hubPageReplacer._startSliding");
        // 아이폰 오래된 버전(4.0)에서 popup 형태의 글쓰기 창에서 textarea에 포커스가 있는 상태로 전 페이지로 돌아갈 경우
        // softkeyboard 때문에 frame이 내려가는 형상 수정을 위해 softkeyboard를 닫을 수 있게  blur 한다.
        $("textarea").blur();
        $("input").blur();
		
		if (this._slidingDir == "top" || this._slidingDir == "bottom") {
			return this._verticalSliding(this._slidingDir);
		} else if (this._slidingDir == "left" || this._slidingDir == "right") {
			return this._horizontalSliding(this._slidingDir);
		}
		
		// sliding effect 없는 경우
        //		var windowWidth = jQuery(window).width();
		this._oldframe = $($('.frame').get(0));
        //		$('<div class="frame"></div>').prependTo($("section")).css({
        //                                                                   width: (windowWidth) + 'px'
        //                                                                   }).html(this._newData);

		// 2013.11.14 animation 효과가 없을 경우 화면 깜빡임을 줄이기 위해 기존 
		// timer 로 onSlidingComplete 를 호출하는 대신 함수 내용의 값들을 여기서 직접 처리하도록 수정
        if (this._oldframe)
            this._oldframe.hide();

        if (this._newframe) {
            this._newframe.css({"height": "", "overflow-y": "", "top": ""});
        } else {
            hubProgress.showWaitProgress(true);
            var windowWidth  =  jQuery(window).width();
            $('<div class="frame"></div>').prependTo($("section")).css({width: (windowWidth) + 'px',
                                                                       }).html(this._newData);  
        }
        
        window.scrollTo(0, this._scrollTop);
        this._completeCallback( this._oldframe);
        hubProgress.hideWaitProgress();				
		
		return;
		
		
		// 2013.11.14 animation 효과가 없을 경우 화면 깜빡임을 줄이기 위해 기존 코드 제거
		//window.setTimeout(hubUtil.bind(this, this._onSlidingComplete), 1);
	};
	
	this._horizontalSliding = function(slidingDir) {
		hubLog.i("web", "hubNavigator._horizontalSliding");
		
		var windowWidth = jQuery(window).width();
		var windowHeight = jQuery(window).height();
		
		var scrollTop = $(window).scrollTop();
		this._oldframe = $($('.frame').get(0));
        if(hubUtil.isIOS()){
            //this._oldframe.css({ '-webkit-transform': 'translateZ(0)' });
        } else {
            this._oldframe.css({ 'overflow-y':'hidden' , 'height':(windowHeight  ) + 'px'  });
            this._oldframe.scrollTop(scrollTop);
        }
		
		if (slidingDir == "left"){
			//////// 새로운 페이지에 접속할 경우, 화면 오른쪽에서 왼쪽으로 이동하도록 한다. ////////
			
			//// 새로 불러오는 페이지는 안보이는 화면 오른쪽에 준비한다.
			// prependTo 를 이용해서 첫번째 child에 넣도록한다. (id가 중복될 경우, getDocuementID나 $('#") 동작을 통해
			// 변경될려는 ID를 가져올 수 있게 하기 위해)
            if(!hubUtil.isIOS()){
                $('<div class="frame"></div>').prependTo($("section")).css({
                                                                           left: (windowWidth) + 'px',
                                                                           width: (windowWidth) + 'px',
                                                                           }).html(this._newData);
            }
			
			window.setTimeout(hubUtil.bind(this,
                                           function(){
                                           //// 현재 페이지를 화면사이즈 만큼 왼쪽으로 옮겨 화면 밖으로 옮기고 이벤트가 끝나면페이지를 삭제한다.
                                           
                                           this._oldframe.animate({
                                                                  left: (this._oldframe.position().left - windowWidth) + 'px',
                                                                  '-webkit-transform' :'translateZ(0)',
                                                                  }, this._newEffectTime, hubUtil.bind(this, this._onSlidingComplete));
                                           
                                           //// 새로운 페이지를 화면사이즈 만큼 왼쪽으로 옮겨 화면 안으로 들어오게 한다.
                                           if(!hubUtil.isIOS()){
                                           this._newframe = $($('.frame').get(0));
                                           this._newframe.animate({
                                                                  left: '0px'
                                                                  }, this._newEffectTime)
                                           }
                                           }
                                           ), 1);
			
		} else if (slidingDir == "right") {
			//////// 새로운 페이지에 접속할 경우, 화면 왼쪽에서 오른쪽으로 이동하도록 한다. (실질적으로는 back 동작임) ////////
			
			//// 새로운 페이지는 안보이는 화면 왼쪽에 준비한다.
			// prependTo 를 이용해서 첫번째 child에 넣도록한다. (id가 중복될 경우, getDocuementID나 $('#") 동작을 통해
			// 변경될려는 ID를 가져올 수 있게 하기 위해)
            if(!hubUtil.isIOS()){
                $('<div class="frame"></div>').prependTo($("section")).css({
                                                                           left: (-windowWidth) + 'px',
                                                                           width: (windowWidth) + 'px',
                                                                           }).html(this._newData);
            }
			
			window.setTimeout(hubUtil.bind(this,
                                           function(){
                                           // 현재 페이지를 화면밖 오른쪽으로 옮긴다.  화면에 벗어난 현재 페이지를 삭제한다.
                                           this._oldframe.animate({
                                                                  left: (this._oldframe.position().left + windowWidth) + 'px',
                                                                  '-webkit-transform' :'translateZ(0)',
                                                                  }, this._newEffectTime, hubUtil.bind(this, this._onSlidingComplete));
                                           
                                           // 다시 읽는 페이지를 화면밖 오른쪽으로 옮긴다.
                                           if(!hubUtil.isIOS()){
                                           this._newframe = $($('.frame').get(0));
                                           this._newframe .animate({
                                                                   left: (this._newframe .position().left + windowWidth) + 'px'
                                                                   }, this._newEffectTime);
                                           }
                                           }
                                           ), 1);
		}
	};
	
	this._verticalSliding = function(slidingDir) {
		hubLog.i("web", "hubNavigator._verticalSliding");
		
		var windowWidth  =  jQuery(window).width();
		var windowHeight =  jQuery(window).height();
        
        $(".frame").css({"height": (windowHeight) + "px", "overflow-y": "hidden"});
		
		if (slidingDir == "top"){
			//////// 새로운 페이지에 접속할 경우, 화면 아래에서 위로 이동하도록 한다. ////////
			
			//// 새로 불러오는 페이지는 안보이는 화면 아래쪽에 준비한다.
			// prependTo 를 이용해서 첫번째 child에 넣도록한다. (id가 중복될 경우, getDocuementID나 $('#") 동작을 통해
			// 변경될려는 ID를 가져올 수 있게 하기 위해)
			$('<div class="frame"></div>').prependTo($("section")).css({
                                                                       top: (windowHeight) + 'px' , width: (windowWidth) + 'px'
                                                                       }).html(this._newData);
			
			window.setTimeout(hubUtil.bind(this,
                                           function(){
                                           
                                           //// 현재 페이지를 화면사이즈 만큼 오른쪽으로 옮겨 화면 밖으로 옮기고 이벤트가 끝나면페이지를 삭제한다.
                                           this._oldframe = $($('.frame').get(1));
                                           this._oldframe.animate({
                                                                  top: (this._oldframe.position().top - windowHeight) + 'px'
                                                                  }, this._newEffectTime, hubUtil.bind(this, this._onSlidingComplete));
                                           
                                           //// 새로운 페이지를 화면사이즈 만큼 위쪽으로 옮겨 화면 안으로 들어오게 한다.
                                           this._newframe  = $($('.frame').get(0));
                                           this._newframe .animate({
                                                                   top: '0px'
                                                                   }, this._newEffectTime);
                                           }), 1);
		}
		else if (slidingDir == "bottom" ) {
			//////// 새로운 페이지에 접속할 경우, 화면 위에서 아래로 이동하도록 한다. (실질적으로는 back했을 때 동작임) ////////
			
			//// 새로운 페이지는 안보이는 화면 위쪽에 준비한다.
			// prependTo 를 이용해서 첫번째 child에 넣도록한다. (id가 중복될 경우, getDocuementID나 $('#") 동작을 통해
			// 변경될려는 ID를 가져올 수 있게 하기 위해)
			$('<div class="frame"></div>').prependTo($("section")).css({
                                                                       top: (-windowHeight) + 'px',
                                                                       width: (windowWidth) + 'px', height: (windowHeight) + 'px'
                                                                       }).html(this._newData);
			
			window.setTimeout(hubUtil.bind(this,
                                           function(){
                                           // 현재 페이지를 화면밖 아래으로 옮긴다.  화면에 벗어난 현재 페이지를 삭제한다.
                                           this._oldframe = $($('.frame').get(1));
                                           this._oldframe.animate({
                                                                  top: (this._oldframe.position().top + windowHeight) + 'px'
                                                                  }, this._newEffectTime, hubUtil.bind(this, this._onSlidingComplete));
                                           
                                           // 다시 읽는 페이지를 화면밖 오른쪽으로 옮긴다.
                                           this._newframe = $($('.frame').get(0));
                                           this._newframe.animate({
                                                                  top: (this._newframe.position().top + windowHeight) + 'px'
                                                                  }, this._newEffectTime);
                                           }), 1);
		}
	};
	
	this._onSlidingComplete = function(){
        if (this._oldframe)
            this._oldframe.hide();
        
        window.setTimeout(hubUtil.bind(this, this._onSlidingComplete2) , 1);
    };
    
    this._onSlidingComplete2 = function(){
        if (this._newframe){
            this._newframe.css({
                               "height": "",
                               "overflow-y": "",
                               "top": ""});
            
        } else {
            hubProgress.showWaitProgress(true);
            var windowWidth  =  jQuery(window).width();
            $('<div class="frame"></div>').prependTo($("section")).css({
                                                                       width: (windowWidth) + 'px',
                                                                       }).html(this._newData);  
        }
        window.setTimeout(hubUtil.bind(this, this._onSlidingComplete3) , 1);
    };
    
    this._onSlidingComplete3 = function(){
        window.scrollTo(0, this._scrollTop);
        this._completeCallback( this._oldframe);
        hubProgress.hideWaitProgress();
	};
}
var hubPageReplacer = new HubPageReplacer();

// HubEffector
/*
function HubEffector() {
	this.setup = function() {
		this._registerCommonTouchEventHandler();
	};
	
	this._registerCommonTouchEventHandler = function() {
		hubLog.i("web", "hubEffector._registerCommonTouchEventHandler");
		
		// touch effect에 대한 특수한 class 적용
		// this.lastTouchElement = null;
		var touchEffectClassList = [
		                            // Selvas Hub 에서는 현재 사용하지 않음
                                    ".button.white:not([disabled])",
                                    ".button.black:not([disabled])",
                                    ".button.search:not([disabled])",
                                    ".button.link_button([disabled])",
                                    ".combo:not([disabled])",
                                    ".comboitem",
                                    ".button.portal_friend_button:not([disabled])",
                                    ".button.down:not([disabled])",
                                    ".button.start:not([disabled])",                                    
                               		// Selvas Hub 에서는 현재 사용하지 않음 end
                                    ".listitem:not([disabled])",
                                    ];
		var touchEventMap = touchEventMap = {touchstart: this._onTouchStart, touchend: this._onTouchEnd};
		if (typeof document.ontouchstart == "undefined") // pc
			touchEventMap = {mousedown: this._onTouchStart, mouseup: this._onTouchEnd};
		
		for (var index in touchEffectClassList) {
			$("section").on(touchEventMap, touchEffectClassList[index]);
		}
	};
	
	this._onTouchStart = function(event){
		hubLog.i("web", "hubEffector._onTouchStart");
		$('.touch').removeClass('touch');
		$(event.currentTarget).addClass('touch');
		event.stopPropagation();
	};
	
	this._onTouchEnd = function(event){
		hubLog.i("web", "hubEffector._onTouchEnd");
		$('.touch').removeClass('touch');
		event.stopPropagation();
	};
}
var hubEffector = new HubEffector();
*/

// HubHistory
function HubHistory() {
	this._MAX_HISTORY__COUNT = 50;  // include current pageinfo
	this._historyStack = [];
	this._historyBack = false;
	this._historyFragmentStack = [] ;
	this._MAX_HISTORY_FRAGMENT_COUNT = this._MAX_HISTORY__COUNT;
	this._DEBUG = true;
	
	// 다른 페이지로 이동하는 것인지 같은 페이지를 같은 param 으로 다시 읽어 오는 것인지 확인 한다.
	this.checkPageReload = function(filename, param) {
		hubLog.i("web", "hubHistory.checkPageReload");
		
		// 처음 실행(첫페이지 로딩)하거나 back 동작 중이며 reload 동작이 아니다.
		if (this._historyStack.length == 0 || this._historyBack)
			return false;
		
		// 현재 페이지와 이동하려는 페이지가 같으면 reload 하는 것과 같다.
		var data = this._historyStack[this._historyStack.length - 1];
		if (data.filename == filename && hubUtil.jsonEquals(data.param, param))
			return true;
		
		return false;
	};
	
	this.savePageInfo = function(filename, param, scrollTop, nextNavigationOption) {
		hubLog.i("web", "hubHistory.savePageInfo");
		
		var currentStackData = {'filename': filename, 'param': param, "scrollTop": 0, "navigationOption" : {}};
		if (this._historyBack == true)
			return;
		// 현재 페이지에 history:fase 이면 _historyStack 에서 현재 페이지를 뺀다.
		if ('structure' in hubPage  &&  'history' in hubPage.structure && !hubPage.structure.history)
			this._historyStack.pop();
		else  if (this._historyStack.length > 0) {
			// 다시 현재 페이지로 돌아왔을 때 필요한 sectionEffect는 현재 사용하려는 effect 반대로 값을 저장해 둔다.
			var sectionInverseDir = {"top":"bottom", "right":"left", "bottom":"top", "left":"right" , "none":"none"};
			this._historyStack[this._historyStack.length - 1].navigationOption.sliding = sectionInverseDir[nextNavigationOption.sliding];
			this._historyStack[this._historyStack.length - 1].scrollTop = scrollTop;
		}
		
		if (this._DEBUG)
			hubLog.i("web", "savePageInfo");
		this._historyStack.push(currentStackData);
		
		// _MAX_HISTORY__COUNT 보다 많은 history 를 저장할 경우 맨 앞의 history 를 삭제한다.
		if (this._historyStack.length > this._MAX_HISTORY__COUNT) {
			this._historyStack.splice(0,1);
		}
	};
	
	this.isHistoryBack = function() {
		return this._historyBack;
	};
	
	this.clearHistoryBack = function() {
		this._historyBack = false;
		this._restoreFragemet = false;
	};
	
	this.clearAllHistory = function() {
		this._historyStack.splice(0,this._historyStack.length);
		while(this._historyFragmentStack.length) {
			var oldHistoryFragment = this._historyFragmentStack.shift();
			oldHistoryFragment.frameDomTree.empty();
			oldHistoryFragment.frameDomTree.remove();
			delete oldHistoryFragment.hubPage;
		}
	};
	
	this.getPrevPageInfo = function() {
		hubLog.i("web", "hubHistory.getPrevPageInfo");
		// 자기 페이지에 대한 정보를 stack에 저장하고 있으므로 length가 1일 때 더 이상 back 할 곳이 없다.
		if (this._historyStack.length == 1)
			return false;
		this._historyBack = true;
		this._historyStack.pop();
		if (this._DEBUG)
			hubLog.i("web", "getPrevPageInfo");
		return this._historyStack[this._historyStack.length - 1];
	};
		
	this.savePageFragement = function(domRoot, page) {
		hubLog.i("web", "hubHistory.savePageFragement");
		if (this._historyBack || this._MAX_HISTORY_FRAGMENT_COUNT < 1 )
			return;
		if (hubPage.structure == undefined  || hubPage.structure.history != true)
			return;
		
		if (this._DEBUG)
			hubLog.i("web", "savePageFragement");
		var newPage = {};
		var historyFragment = { 'frameDomTree' : domRoot, 'hubPage' :  page };
		
		this._historyFragmentStack.push(historyFragment);
		
		if (this._historyFragmentStack.length > this._MAX_HISTORY_FRAGMENT_COUNT ){
			var oldHistoryFragment = this._historyFragmentStack.shift();
			oldHistoryFragment.frameDomTree.empty();
			oldHistoryFragment.frameDomTree.remove();
			delete oldHistoryFragment.hubPage;
		}
	};
	
	this.loadPageFragement = function() {
		hubLog.i("web", "hubHistory.loadPageFragement");
		if (this._historyFragmentStack.length == 0)
			return null;
		if (this._DEBUG)
			hubLog.i("web", "loadPageFragement");
		return this._historyFragmentStack.pop();
	};
};
var hubHistory = new HubHistory();

function HubPopup() {
	this._newFilename = "";
	this._scrollTop = 0;
	this._newParam = {};
	this._newData = "";
    
	this._closeParam = null;
	this._basehubPage = null;
	
	this._oldframe = undefined;
	this._newframe = undefined;
	
	this._status = "";  // "open" | "close"
	
	this.open = function(filename, param) {
		hubLog.i("web", "hubPopup.open filename " + filename);
		
        
        if(this._status || 	hubNavigator._navigating )
            return;
		this._status = "open";
        hubNavigator._navigating = true;
		if (hubPage.structure.pageType != "normal") {
			hubLog.i("web", "hubPopup.open error : pageType of current page is popup");
			return;
		}
		
		
		this._newParam = param;
		this._oldNavigationOption = this._newNavigationOption;
		this._newNavigationOption = {};
		this._scrollTop = $(window).scrollTop();;
		
		if (typeof navigationOption != "object" || navigationOption == null)
			navigationOption = {}
		
		// ajax file load
        $.get(filename, hubUtil.bind(this, this._onFileLoad)).error( hubUtil.bind(this, this._onFileLoadFail));
        
	};
    
    this._onFileLoadFail = function(){
	 	hubNavigator._navigating = false;
    }
	
	this._onFileLoad = function(data) {
		hubLog.i("web", "hubPopup._onFileLoad");
		// exit
		if (this._status == "close" && hubPage.structure != undefined) {
			if (hubPage.structure.exit != undefined) {
				hubPage.structure.exit();
			}
		}
		
		var sliding = ''
		var scrollTop = 0;
		if (this._status == "open") {
			sliding = "top";
		}
		else {
			sliding = "bottom";
			scrollTop = this._scrollTop;
		}
		
		//// page 전환효과와 함께, 페이지를 전환하고 받아온 responseText를 document에 추가한다.
		hubPageReplacer.replace(data, sliding, scrollTop, hubUtil.bind(this, this._slidingComplete), {});
		
	};
	
	this._slidingComplete = function(_oldframe) {
		hubLog.i("web", "hubPopup._slidingComplete");
		this._oldframe = _oldframe;
		
		if (this._status == "close") {	
			this._oldframe.empty();
			this._oldframe.remove();
			// clear
			hubPage.private = undefined;
			hubPage.private = {};
			hubPage.structure = undefined;
			hubPage.structure = {};
			
			hubPage = this._basehubPage;
			this._basehubPage = {};
			
			// header, footer
			var hfinvokeparam = {
				"function" : "headerfooter",
				"argument" : {
					header : {},
					footer : {},
				},
			};
			hfinvokeparam.argument.header = hubUtil.arrayUpdate(hubPage.structure.header, hubNavigator._DEFAULT_HEADER_STRUCTURE);
			hfinvokeparam.argument.footer = hubUtil.arrayUpdate(hubPage.structure.footer, hubNavigator._DEFAULT_FOOTER_STRUCTURE);
			hubApi.invoke(hfinvokeparam, null);
		} else {	// open		
			this._basehubPage = hubPage;
			this._oldframe.detach();
			// history 를 저장해야 하는 경우, hubHistory 의 _historyFragmentStack 값이 지워지지 않게 해야 한다.
			hubPage = {};
			hubPage.private = {};
			hubPage.structure = {};
			
			script = document.getElementById("script");
			if (script != undefined) {
				scriptText = script.innerHTML;
				try {
					eval(scriptText);
				}
				catch(err){
					var errMsg = "page eval error \n";
					hubToast.show(errMsg + err);
				}
			}
			
			if (hubPage.structure == undefined) {
				hubPage.structure = {};
			}
			hubPage.structure = hubUtil.arrayUpdate(hubPage.structure, { header : {}, footer : {}, history : true , pageType:"popup" });
            
			// header, footer
			var hfinvokeparam = {
				"function" : "headerfooter",
				"argument" : {
					header : {},
					footer : {},
				},
			};
			hfinvokeparam.argument.header = hubUtil.arrayUpdate(hubPage.structure.header, {
                                                                title : "",
                                                                left : "cancel",
                                                                right : "none",
                                                                progress : false,
                                                                show : true
                                                                });
			hfinvokeparam.argument.footer = hubUtil.arrayUpdate(hubPage.structure.footer, {
                                                                show : false
                                                                });
			hubApi.invoke(hfinvokeparam, null);
		}
		
		// 쪽지 보내기의 경우(message.html), onPopupClose 시점에  hubNavigator.go 를 이용해 페이지 이동을 하고 있으므로 이 때 정상동작을 위해
		// navigating 을 onPopupClose 을 호출하기 전에 _navigating을 해제한다.
        hubNavigator._navigating = false;
		
		// request
		if (this._status == "open" && hubPage.structure.request != undefined) {
			hubPage.structure.request(this._newParam, "go");
		}
		// popup close 시 base page 의 onPopupClose 함수를 호출한다.
		if (this._status == "close" && hubPage.structure.onPopupClose) {
			hubPage.structure.onPopupClose(this._closeParam);
		}
		this._status = undefined;
		
		hubLog.i("web", "hubPopup open done " + this._newFilename);
	};
	
	this.close = function(param) {
		this._closeParam = param;
		window.setTimeout(hubUtil.bind(this,  this._close), 1);
		//this._close();
	};
	
	this._close = function() {
		hubLog.i("web", "hubPopup close");
		if (hubPage.structure.pageType != "popup") {
			hubLog.i("web", "hubPopup err : pageType of current page is not popup");
			return;
		}
		
        if(this._status || hubNavigator._navigating )
            return;
        hubNavigator._navigating = true;
		this._status = "close";
		this._onFileLoad(this._oldframe.children());
	};
};
var hubPopup = new HubPopup();

// HubEventReceiver
/*
 event : {
 name : "onButtonClick",
 argument : {
 source : "left"|"right"|"home"|"games"|"friends"|"message",
 type : "back"|"cancel"|"setting"|"close",
 }
 }
 event : {
 name : "onKeyPress",
 argument : {
 source : "menu"|"back"|"search"|"volumeup"|"volumedown",
 }
 event : {
 name : "onNativeOrientationchange",
 argument : {
 rotation : "landscape" | "portrait",
 }
 }
 */
function HubEventReceiver() {
	this.onOrientationchange = function(){
		hubLog.i("web", "hubEventReceiver.onOrientationchange");
		
	};
	
	this.onResize = function(){
		hubLog.i("web", "hubEventReceiver.onResize");

        // 안드로이드나 PC 웹일 경우, body의 resize 을 이용한다.
        // 20131218 rudeo ios 의 경우 예외 케이스 제거
        // if(!hubUtil.isIOS())
            this._resize();
        
    };
	
	this.onEvent = function(evt) {
		hubLog.i("web", "hubEventReceiver.onEvent evt " + JSON.stringify(evt));
		if (evt == undefined || evt.name == undefined)
			return;

		if (evt.name == 'onButtonClick') {
			this._dispatchOnButtonClick(evt.argument);
		} else if (evt.name == 'onKeyPress') {
			this._dispatchOnKeyPress(evt.argument);
		} else if (evt.name == "onNativeOrientationchange"){
			this._onNativeOrientationchange(evt.argument);
		} else if (evt.name == 'onBackPressed') {
			
			// user_exit_able 값이 존재 할 경우 false 일 경우는 back key 를 눌를시 종료가 되지 않도록 처리(android)
			if (hubPage.structure.user_exit_able == false) {
				return;
			} 
						
			if (hubPage.structure.move_back_able == false) {
	            hubApi.invoke({"function":"close"}, null); 
			} else if(hubPage.structure.check_back_able == true) {
				hubPage.structure.check_back();
			} else {
				hubNavigator.back();
			}
		}
	};
	
	this._dispatchOnButtonClick = function(arg) {
		if (arg == undefined)
			return;
		if (arg.source == undefined)
			return;
        
		// page event handler call
		var handled = false;
		// copy
		var gen = {
			name : "onButtonClick",
			argument : {
				source : arg.source,
				type : arg.type,
			},
		};
		if (arg.source == "left") {
			if (arg.type == "back" || arg.type == "cancel" || arg.type == "setting") {
				if (hubPage != undefined && hubPage.structure != undefined && hubPage.structure.onEvent != undefined)
					handled = hubPage.structure.onEvent(gen);
			}
		} else if (arg.source == "right") {
			if (arg.type == "close") {
				if (hubPage != undefined && hubPage.structure != undefined && hubPage.structure.onEvent != undefined)
					handled = hubPage.structure.onEvent(gen);
			}
		}
        
		// default action
		if (arg.source == "left") {
			if (arg.type == "back") {
				if (handled != true)
					hubPage.structure.pageType == "normal" ? hubNavigator.back() : hubPopup.close(null);
			} else if (arg.type == "cancel") {
				if (handled != true)
					hubPage.structure.pageType == "normal" ? hubNavigator.back() : hubPopup.close(null);
			} if (arg.type == "setting") {
				if (handled != true)
					hubNavigator.go("" + arg.type + ".html");
			}
		} else if (arg.source == "right") {
			if (arg.type == "close") {
				if (handled != true)
					hubNavigator.close();
			}
		} else if (arg.source == "home") {
			hubNavigator.go("" + arg.source + ".html");
		} else if (arg.source == "games") {
			hubNavigator.go("" + arg.source + ".html");
		} else if (arg.source == "friends") {
			hubNavigator.go("" + arg.source + ".html");
		} else if (arg.source == "message") {
			hubNavigator.go("" + arg.source + ".html");
		}
	};
    
	this._dispatchOnKeyPress = function(arg) {
		if (arg == undefined)
			return;
		if (arg.source == undefined)
			return;
        
		// page event handler call
		var handled = false;
		// copy
		var gen = {
			name : "onKeyPress",
			argument : {
				source : arg.source,
			},
		};
		if (hubPage != undefined && hubPage.structure != undefined && hubPage.structure.onEvent != undefined)
			handled = hubPage.structure.onEvent(gen);
		
		// default action
		if (arg.source == "menu") {
			;
		} else if (arg.source == "back") {
			if (handled != true)
				hubPage.structure.pageType == "normal" ? hubNavigator.back() : hubPopup.close(null);
		} else if (arg.source == "search") {
			;
		} else if (arg.source == "volumeup") {
			;
		} else if (arg.source == "volumedown") {
			;
		}
	};
	
	this._onNativeOrientationchange = function(arg){
		if (arg == undefined)
			return;
		if (arg.rotation == undefined)
			return;
		
		var orientationString = arg.rotation;
		hubLog.i("web", "hubEventReceiver.onNativeOrientationchange : " + orientationString);
        // iphone 일 경우, native  roate 가 끝날 때, 강제로 호출되는 함수를 이용해서 rotate
        // 20131218 rudeo ios 의 경우 예외 케이스 제거
        //if(hubUtil.isIOS())
        //  this._resize();

	}
	
	this._resize = function()
    {
		
		var windowWidth = jQuery(window).width();
		$('.frame').css({'width': windowWidth + 'px'})
		
		if(hubPage.structure.OnResize){
			window.setTimeout(hubPage.structure.OnResize, 1);
        }
        
        //$(window).trigger('resize'); // resize 이벤트를 강제로 발생시킴
		
	};
};
var hubEventReceiver = new HubEventReceiver();

// HubHeader
/*
function HubHeader() {
	this.show = function(show) {
		if (show == undefined) {
			return;
		}
		hubPage.structure.header.show = show;
		var param = {
			"function" : "headerfooter",
			"argument" : {
				header : {
					"show" : show
				}
			}
		};
		hubApi.invoke(param, null);
	};
	
	this.setLeft = function(id) {
		if (id == undefined) {
			return;
		}
		hubPage.structure.header.left = id;
		var param = {
			"function" : "headerfooter",
			"argument" : {
				header : {
					"left" : id
				}
			}
		};
		hubApi.invoke(param, null);
	};
	
	this.setRight = function(id) {
		if (id == undefined) {
			return;
		}
		hubPage.structure.header.right = id;
		var param = {
			"function" : "headerfooter",
			"argument" : {
				header : {
					"right" : id
				}
			}
		};
		hubApi.invoke(param, null);
	};
	
	this.setTitle = function(text) {
		if (text == undefined) {
			return;
		}
		hubPage.structure.header.title = text;
		var param = {
			"function" : "headerfooter",
			"argument" : {
				header : {
					"title" : text
				}
			}
		};
		hubApi.invoke(param, null);
	};
	
	this.setProgress = function(show) {
		if (show == undefined) {
			return;
		}
		var param = {
			"function" : "headerfooter",
			"argument" : {
				header : {
					"progress" : show
				}
			}
		};
		hubApi.invoke(param, null);
	};
};
var hubHeader = new HubHeader();
*/

// HubFooter
/*
function HubFooter() {
	this.show = function(show) {
		if (show == undefined) {
			return;
		}
		hubPage.structure.footer.show = show;
		var param = {
			"function" : "headerfooter",
			"argument" : {
				footer : {
					"show" : show
				}
			}
		};
		hubApi.invoke(param, null);
	};
	
	// this.setCount = function(id, count) {
	// };
};
var hubFooter = new HubFooter();
*/

// HubDirty
/*
function HubDirty() {
};
var hubDirty = new HubDirty();
*/

// HubPage
function HubPage() {
	this.private = {};
	this.structure = {};
};
var hubPage = new HubPage();

// HubDialog
function HubDialog() {
	/*
	 * msg: 창뜰때 출력 msg, 
	 * callback: callback function, 
	 * param: callback 호출시 전달 받을 parameter(주의: json data 로 전달 해야함)
	 */ 
	this.showYesNoDialog = function(msg, callback, callback_param) {
		var param = {
			'function' : 'dialog',
			'argument' : {
				'type' 	  : 'yesNo',
				'message' : msg
			}
		};	

		if (callback_param)
			param.argument['param'] = callback_param;

		hubApi.invoke(param, callback);
	};
    
	this.showOkDialog = function(msg, callback) {
		var param = {
			'function' : 'dialog',
			'argument' : {
				'type' : 'ok',
				'message' : msg
			}
		};
		hubApi.invoke(param, callback);
	};
    
	
	this.showProfileImageDialog = function(imageUrl, callback){
		var param = {
			'function' : 'dialog',
			'argument' : {
				'type' : 'profileImageSelect',
                'imageUrl' : imageUrl,
			}
		};
		hubApi.invoke(param, callback);
	};
    
    
    this.showAccountDialog = function(isShowRevertMenu , callback){
        var param = {
            'function' 		: 'dialog',
            'argument' 		: {
            	'type' 				  : 'account',
            	'is_show_revert_menu' : isShowRevertMenu,
            }
        };
        hubApi.invoke(param, callback);
    };
    
    
    this.showArticleImageDialog = function(callback) {
        var param = {
            'function' : 'dialog',
            'argument' : {
                'type' : 'articleImageSelect'
            }
        };
        hubApi.invoke(param, callback);
        
    };
	
};
var hubDialog = new HubDialog();


function HubProgress() {
	
	this.showWaitProgress = function(cancelable, callback) {
		var param = {
			'function' : 'progress',
			'argument' : {
				'type' : 'show',
				'cancelable' : cancelable
			}
		};
		hubApi.invoke(param, callback);
	};
    
	this.hideWaitProgress = function() {
		var param = {
			'function' : 'progress',
			'argument' : {
				'type' : 'hide'
			}
		};
		hubApi.invoke(param, null);
	};
};

var hubProgress = new HubProgress();



function HubToast() {
	this.show = function(msg) {
		var param = {
			'function' : 'toast',
			'argument' : {
				'message' : msg,
			}
		};
		hubApi.invoke(param, null);
	};
	
	this.showError = function(status, error , errMsg) {
		var msg = ""
		if (errMsg) {
			msg = "HTTP status : " + status + " / Error : " + error + "\n" + errMsg;
		}
		else{
			msg = "HTTP status : " + status + " / Error : " + error;
		}
		var param = {
			'function' : 'toast',
			'argument' : {
				'message' : msg,
			}
		};
		hubApi.invoke(param, null);
	};
}
var hubToast = new HubToast();


//HubNavigator의 init 함수에서  정적인 환경정보들을   assign 할 객체
//hardware , os , platform , processor , display , locale  등등
function HubAppInfo() {
};
var hubAppInfo = new HubAppInfo();

// [sinaeyo] Button 을 enable/disable 하기위한 api
function HubControl() {
	this.enable = function(id, enabled) {
		if (enabled) {
			$(id).removeAttr('disabled');
		} else {
			$(id).attr('disabled', "");
		}
	};
    
	this.isEnabled = function(id) {
		return !($(id).attr('disabled'));
	};
	
	this.check = function(id, checked) {
		if (checked) {
			$(id).attr('checked', '');
		} else {
			$(id).removeAttr('checked');
		}
	};
	
	this.isChecked = function(id) {
		return $(id).attr('checked');
	};
};
var hubControl = new HubControl();

function HubMap() {
	this.keys = new Array();
	this.data = new Object();

	this.put = function(key, value) {
	    if(this.data[key] == null){
	        this.keys.push(key);
	    }
	    this.data[key] = value;
	};

	this.get = function(key) {
	    return this.data[key];
	};

	this.remove = function(key) {
		
	    var len = this.keys.length;
	    for(var i=0;i<len;i++){
	    	var k = this.keys[i];	    	
	    	if(k==key) {    		
				this.keys.splice(i, 1);   		
	    		break;
	    	}
	    }	    
	    this.data[key] = null;
	};
	
	this.each = function(fn){
	    if(typeof fn != 'function')	
	        return;
	     
	    var len = this.keys.length;
	    for(var i=0;i<len;i++){
	        var k = this.keys[i];
	        fn(k,this.data[k],i);
	    }
	};

	this.entrys = function() {
	    var len = this.keys.length;
	    var entrys = new Array(len);
	    for (var i = 0; i < len; i++) {
	        entrys[i] = {
	            key : this.keys[i],
	            value : this.data[i]
	        };
	    }
	    return entrys;
	};

	this.isEmpty = function() {
	    return this.keys.length == 0;
	};

	this.size = function(){
	    return this.keys.length;
	};
};
// 주의 : map 의 경우 공용으로 사용시 관리가 되지 힘들것 같아 필요한 각 Page 에서 할당에서 직접 관리 하도록 함
//var hubMap = new HubMap();

// HubLang
var hubLang = {
    
	get : function(id) {
        if (hubAppInfo.lang == "en") {
			if (this._en[id] != undefined)
				return this._en[id];
		} else if (hubAppInfo.lang == "ko") {
			if (this._ko[id] != undefined)
				return this._ko[id];
		} else if (hubAppInfo.lang == "ja") {
			if (this._ja[id] != undefined)
				return this._ja[id];
		} else if (hubAppInfo.lang == "zh" || hubAppInfo.lang == "zh-Hans") {
			if (this._zh[id] != undefined)
				return this._zh[id];
		} else if (hubAppInfo.lang == "de") {
			if (this._de[id] != undefined)
				return this._de[id];
		}  else if (hubAppInfo.lang == "it") {
			if (this._it[id] != undefined)
				return this._it[id];
		}  else if (hubAppInfo.lang == "fr") {
			if (this._fr[id] != undefined)
				return this._fr[id];
		}  else if (hubAppInfo.lang == "es") {
			if (this._es[id] != undefined)
				return this._es[id];
		} 
		
        
		// 지원하지 않는 언어 또는 해당 언어 테이블에 id 의 값이 없는 경우, default 는 en
		if (this._en[id] != undefined)
			return this._en[id];
		// default 에도 없는 경우
		return "";
	},
	
	get_current_lang : function() {
		if (hubAppInfo.lang == "en") {
			return "en";
		} else if (hubAppInfo.lang == "ko") {
			return "ko";
		} else if (hubAppInfo.lang == "ja") {
			return "ja";
		} else if (hubAppInfo.lang == "zh" || hubAppInfo.lang == "zh-Hans") {
			return "zh";
		}
		
		return "en"; // default
	},
			
	_en : {			
		///////////////////////
		// 로그인/프로파일 Page
		///////////////////////
		// Profile view page
		profile_account_default_info: "Please select",
		profile_basic_info_format: "{$1} / {$2}",
		profile_title_text: "User information",
		profile_account: "Basic information",
	    profile_nickname: "Nick name",
	    profile_change_photo_btn: "Change",
	    profile_verify_email_send_msg: "Verification mail has been sent out.",

	    // profile_edit_basic_info 
	    profile_edit_basic_info_title_text: "Basic information change",
	    profile_edit_basic_info_sex_male: "Male",
	    profile_edit_basic_info_sex_female: "Female",
	    profile_edit_basic_info_age_10: "10-19",
	    profile_edit_basic_info_age_20: "20-29",
	    profile_edit_basic_info_age_30: "30-39",
	    profile_edit_basic_info_age_40: "40-49",
	    profile_edit_basic_info_age_50: "50-59",
	    profile_edit_basic_info_age_60: "over60",
	    profile_edit_basic_info_save_fail: "Failed to save profile.",    
	    profile_edit_basic_info_load_error: "Error occurred while requesting user info.",
	    
	    // login_guide page
	    login_guide_title_text: "Login guide",  
	    login_guide_login_exist_msg: "You are already logged in.",
	    
	    // login_set_account page
	    login_set_account_title_text: "Account setting",
	    login_set_account_device_link_login_desc: "Account info can be transferred to additional device.",
	    
	    // login_account_info page
	    login_account_info_title_text: "Account info",
	    login_account_info_email_title_label: "SELVAS account",
	    login_account_info_chg_pwd_btn: "Change password",
	    	    
	    // login_device_link_recommend_1 page
	    login_device_link_recommend_1_title_text: "Link Device",
	    login_device_link_recommend_1_google_link_desc: "Please log into Google Play Games and try again.",
	    login_device_link_recommend_1_selvas_link_desc: "Please try logging in after logging into SELVAS account.",
	    login_device_link_recommend_1_gamecenter_link_desc: "Please try logging in after logging into Apple Game Center account.",
	 
	    // login_device_link_recommend_2 page
	    login_device_link_recommend_2_title_text: "Link Device",
	    login_device_link_recommend_2_link_desc: "If you want to play from multiple {$1} device, try logging into {$2} account from game setting menu and log into {$3}.<br><br>" +
	    		"It will automatically link with other {$1} device by logging into {$2} account.",

	    // login_device_link_option_1 page
	    login_device_link_option_1_title_text: "Link Device",
	    login_device_link_option_1_link_desc: "You can link tow devices to play or transfer to another device and enjoy the game.",
	    login_device_link_option_1_current_device: "Currently active<br/>device",
	    login_device_link_option_1_new_device: "New<br/>device",
	    
	    // login_device_link_option_2 page
	    login_device_link_option_2_title_text: "Link Device",
	    login_device_link_option_2_link_desc: "Select newly linked device type.",
	    login_device_link_option_2_link_desc2: "※ Other OS not supported.",
	    login_device_link_option_2_ios_device: "iOS Device",
	    login_device_link_option_2_android_device: "Android Device",
	    
	    // login_device_link_code_output page
	    login_device_link_code_output_title_text: "Link Device",
	    login_device_link_code_output_desc1: "Enter below <br/> link code to new device you want to link.",
	    login_device_link_code_output_desc2: "You can link to new device by entering link code to new device's account setting menu.",
	    login_device_link_code_output_valid_time: "Valid time for link code",
	    login_device_link_code_output_refresh_btn: "Issue new link code",
	    login_device_link_code_output_warn_msg: "Warning: do not share link code to others",

	    // login_device_link_code_input page
	    login_device_link_code_input_title_text: "Link Device",
	    login_device_link_code_input_holder: "Link Code",
	    login_device_link_code_input_desc1: "Please enter link code.",
	    login_device_link_code_input_desc2: "You can receive link code from link device of account setting menu from your original device.",
	    
	    // login_device_link_confirm page
	    login_device_link_confirm_title_text: "Link Device",
	    login_device_link_confirm_desc1: "Are you sure about deleting current progress on this device and replacing with following account data?",
	    
	    // login_device_link_complete page
	    login_device_link_complete_title_text: "Link Device",
	    login_device_link_complete_desc1: "Device link has been complete. By clicking Ok button will sync account information.",
	    
		// Change password page (현재 사용안함)
	    login_change_pwd_sub_cur_pwd_input_title: "현재 비밀번호",
	    login_change_pwd_sub_cur_pwd_input_holder: "현재 비밀번호",
	    login_change_pwd_sub_new_pwd_input_title: "새 비밀번호",
	    login_change_pwd_sub_new_pwd_input_holder: "새 비밀번호",
	    login_change_pwd_sub_new_pwd_confirm_input_title: "새 비밀번호 확인",
	    login_change_pwd_sub_new_pwd_confirm_input_holder: "새 비밀번호 확인",	    
	    login_change_pwd_title_text: "비밀번호 변경",	    
	    login_change_pwd_desc_text_p: "변경하실 비밀번호를 입력해주세요.<br/>6자리 이상 입력해야 비밀번호를<br/>변경하실 수 있습니다.<br/>",
	    login_change_pwd_desc_text_l: "변경하실 비밀번호를 입력해주세요.<br/>6자리 이상 입력해야 비밀번호를 변경하실 수 있습니다.<br/>",
	    login_change_pwd_current_pwd_input: "현재 비밀번호",
	    login_change_pwd_new_pwd_input: "새 비밀번호",
	    login_change_pwd_new_pwd_confirm_input: "새 비밀번호 확인",
	    login_change_pwd_not_input_cur_pwd: "현재 비밀번호를 입력해주세요.",
	    login_change_pwd_not_input_new_pwd: "새로운 비밀번호를 입력해주세요.",
	    login_change_pwd_not_match_new_pwd: "새로운 비밀번호가 일치하지 않습니다.",
	    login_change_pwd_success_message:"비밀번호가 변경되었습니다.",
        
        // login_nick_name page (현재 사용안함)
	    login_nick_name_title_text: "닉네임 입력",
	    login_nick_name_sub_input_title: "Nick name",
	    login_nick_name_sub_input_holder: "입력",	    
	    login_nick_name_desc_text_p: "사용하실 닉네임을 입력해주십시오.<br/>2자 이상 입력해야 다음으로 이동됩니다.",
	    login_nick_name_desc_text_l: "사용하실 닉네임을 입력해주십시오.<br/>2자 이상 입력해야 다음으로 이동됩니다.",
	    login_nick_name_lable: "Nick name",
	    login_nick_name_input: "입력",
        
        // login_selvas_login page (현재 사용안함)
	    login_selvas_login_title_text: "사용자 로그인",
	    login_selvas_login_find_pwd_btn: "비밀번호 찾기",	    
	    login_selvas_login_desc_text_p: "SELVAS 회원가입 시에 등록하신<br/>이메일 주소와 비밀번호를 입력해 주세요.<br/>비밀번호를 분실하신 경우<br/>\"비밀번호 찾기\"를 선택하시면 됩니다.",
	    login_selvas_login_desc_text_l: "SELVAS 회원가입 시에 등록하신 이메일 주소와 비밀번호를 입력해 <br/>주세요. 비밀번호를 분실하신 경우 \"비밀번호 찾기\"를 선택하시면 됩니다.",
	    login_selvas_login_email_lable: "이메일",
	    login_selvas_login_password_lable: "Password",
	    login_selvas_login_email_input: "email@selvas.com",
	    login_selvas_login_password_input: "입력",
	    login_selvas_login_join_member_btn: "Member register",
	    login_selvas_login_sub_email_input_title: "이메일",
	    login_selvas_login_sub_email_input_holder: "email@selvas.com",
	    login_selvas_login_sub_pwd_input_title: "Password",
	    login_selvas_login_sub_pwd_input_holder: "Password",
	    login_selvas_login_check_password_text: "비밀번호를 입력해 주세요.",	
 
		///////////////////////
		// 공통 적용및 기타
		///////////////////////	    
        // 닉네임 변경 시 error msg
        change_nick_failed : "Failed to change nick name.",
        
		// status bar
	    com_status_confirm_btn: "Ok",
	    com_status_finish_btn: "Complete",
	    com_status_cancel_btn: "Cancel",
	    com_status_aggree_btn: "Agree",
	    com_status_close_btn: "Close",
	    com_status_back_btn: "Back",
	    
	    // common text	
	    com_google_login_box_title: "Sign in",
	    com_game_center_login_box_title: "Game Center Login",
	    com_selvas_login_box_title: "SELVAS Login",   
	    com_device_link_box_title: "Link Device",
		com_account_info_btn: "Account information",
	    com_google_login_desc: "Logging into Google Play Games will not only protect user information, but also allow game play from multiple Android devices.",
	    com_selvas_login_desc: "Logging into Selvas account instead of Google Play Games will also protect user information.",
	    com_game_center_login_desc: "By logging into Game Center using Apple account will not only protect user information but also allow game play from multiple iOS devices."
	},
	_ko : {
		///////////////////////
		// 로그인/프로파일 Page
		///////////////////////
		// Profile view page
		profile_account_default_info: "선택안함",
		profile_basic_info_format: "{$1} / {$2}",
		profile_title_text: "사용자 정보",
		profile_account: "기본 정보",
	    profile_nickname: "닉네임",
	    profile_change_photo_btn: "변경",
	    profile_verify_email_send_msg: "인증이메일이 발송 되었습니다",

	    // profile_edit_basic_info 
	    profile_edit_basic_info_title_text: "기본 정보 변경",
	    profile_edit_basic_info_sex_male: "남성",
	    profile_edit_basic_info_sex_female: "여성",
	    profile_edit_basic_info_age_10: "10대",
	    profile_edit_basic_info_age_20: "20대",
	    profile_edit_basic_info_age_30: "30대",
	    profile_edit_basic_info_age_40: "40대",
	    profile_edit_basic_info_age_50: "50대",
	    profile_edit_basic_info_age_60: "60대",
	    profile_edit_basic_info_save_fail: "프로필 저장을 실패했습니다.",    
	    profile_edit_basic_info_load_error: "사용자 정보를 요청중 오류가 발생을 하였습니다.",
   
	    // login_guide page
	    login_guide_title_text: "로그인 안내",  
	    login_guide_login_exist_msg: "현재 로그인이 되어 있습니다.",
	    
	    // login_set_account page
	    login_set_account_title_text: "계정 설정",
	    login_set_account_device_link_login_desc: "현재 사용중인 디바이스가 아닌 새로운 디바이스로 계정을 이동시켜 게임 플레이가 가능합니다.",
	    
	    // login_account_info page
	    login_account_info_title_text: "계정 정보",
	    login_account_info_email_title_label: "SELVAS 계정",
	    login_account_info_chg_pwd_btn: "비밀번호 변경",
	    	    
	    // login_device_link_recommend_1 page
	    login_device_link_recommend_1_title_text: "디바이스 연동",
	    login_device_link_recommend_1_google_link_desc: "Google Play Games에 먼저 로그인하신 후, 다시 시도해 주시기 바랍니다.",
	    login_device_link_recommend_1_selvas_link_desc: "SELVAS 계정으로 먼저 로그인하신 후, 다시 시도해 주시기 바랍니다.",
	    login_device_link_recommend_1_gamecenter_link_desc: "Apple 계정으로 Game Center에 먼저 로그인하신 후, 다시 시도해 주시기 바랍니다.",
	 
	    // login_device_link_recommend_2 page
	    login_device_link_recommend_2_title_text: "디바이스 연동",
	    login_device_link_recommend_2_link_desc: "여러 개의 {$1} 디바이스에서 게임 플레이하기를 원하시면, 게임 설정 메뉴를 통하여 {$2} 계정으로 {$3}에 로그인하시면 됩니다.<br><br>" +
	    		"다른 {$1} 디바이스에서도 동일한 {$2} 계정으로 로그인하시면 동일한 계정 정보가 자동으로 동기화됩니다.",

	    // login_device_link_option_1 page
	    login_device_link_option_1_title_text: "디바이스 연동",
	    login_device_link_option_1_link_desc: "두 개의 디바이스 플레이 혹은 새로운 디바이스로 계정을 이동시켜 플레이할 수 있습니다.",
	    login_device_link_option_1_current_device: "플레이 중인<br/>디바이스",
	    login_device_link_option_1_new_device: "새로운<br/>디바이스",
	    
	    // login_device_link_option_2 page
	    login_device_link_option_2_title_text: "디바이스 연동",
	    login_device_link_option_2_link_desc: "새로 연동할 디바이스 타입을 선택해 주세요.",
	    login_device_link_option_2_link_desc2: "※ 그 외 OS에서는 게임을 지원하고 있지 않습니다.",
	    login_device_link_option_2_ios_device: "iOS 디바이스",
	    login_device_link_option_2_android_device: "Android 디바이스",
	    
	    // login_device_link_code_output page
	    login_device_link_code_output_title_text: "디바이스 연동",
	    login_device_link_code_output_desc1: "새로 연동할 디바이스에서 아래 연동코드를<br/>입력해 주세요.",
	    login_device_link_code_output_desc2: "새로 연동할 디바이스로 계정 설정 메뉴의 디바이스 연동을 선택하면 연동코드를 입력할 수 있습니다.",
	    login_device_link_code_output_valid_time: "연동코드 유효시간",
	    login_device_link_code_output_refresh_btn: "연동코드 새로 받기",
	    login_device_link_code_output_warn_msg: "연동코드는 본인 외 제 3자에게 누설 금지",

	    // login_device_link_code_input page
	    login_device_link_code_input_title_text: "디바이스 연동",
	    login_device_link_code_input_holder: "연동코드",
	    login_device_link_code_input_desc1: "연동코드를 입력해 주세요.",
	    login_device_link_code_input_desc2: "원래 사용하던 디바이스로 계정 설정 메뉴의 디바이스 연동을 선택하면 연동코드를 받을 수 있습니다.",
	    
	    // login_device_link_confirm page
	    login_device_link_confirm_title_text: "디바이스 연동",
	    login_device_link_confirm_desc1: "현재 플레이하던 계정의 데이터를 삭제하고, 정말 다음의 계정으로 대체하시겠습니까?",
	    
	    // login_device_link_complete page
	    login_device_link_complete_title_text: "디바이스 연동",
	    login_device_link_complete_desc1: "디바이스 연동이 완료되었습니다. 확인 버튼을 누르시면 해당 계정의 게임 데이터가 동기화됩니다.",
	    
		// Change password page (현재 사용안함)
	    login_change_pwd_sub_cur_pwd_input_title: "현재 비밀번호",
	    login_change_pwd_sub_cur_pwd_input_holder: "현재 비밀번호",
	    login_change_pwd_sub_new_pwd_input_title: "새 비밀번호",
	    login_change_pwd_sub_new_pwd_input_holder: "새 비밀번호",
	    login_change_pwd_sub_new_pwd_confirm_input_title: "새 비밀번호 확인",
	    login_change_pwd_sub_new_pwd_confirm_input_holder: "새 비밀번호 확인",	    
	    login_change_pwd_title_text: "비밀번호 변경",	    
	    login_change_pwd_desc_text_p: "변경하실 비밀번호를 입력해주세요.<br/>6자리 이상 입력해야 비밀번호를<br/>변경하실 수 있습니다.<br/>",
	    login_change_pwd_desc_text_l: "변경하실 비밀번호를 입력해주세요.<br/>6자리 이상 입력해야 비밀번호를 변경하실 수 있습니다.<br/>",
	    login_change_pwd_current_pwd_input: "현재 비밀번호",
	    login_change_pwd_new_pwd_input: "새 비밀번호",
	    login_change_pwd_new_pwd_confirm_input: "새 비밀번호 확인",
	    login_change_pwd_not_input_cur_pwd: "현재 비밀번호를 입력해주세요.",
	    login_change_pwd_not_input_new_pwd: "새로운 비밀번호를 입력해주세요.",
	    login_change_pwd_not_match_new_pwd: "새로운 비밀번호가 일치하지 않습니다.",
	    login_change_pwd_success_message:"비밀번호가 변경되었습니다.",
        
        // login_nick_name page (현재 사용안함)
	    login_nick_name_title_text: "닉네임 입력",
	    login_nick_name_sub_input_title: "닉네임",
	    login_nick_name_sub_input_holder: "입력",	    
	    login_nick_name_desc_text_p: "사용하실 닉네임을 입력해주십시오.<br/>2자 이상 입력해야 다음으로 이동됩니다.",
	    login_nick_name_desc_text_l: "사용하실 닉네임을 입력해주십시오.<br/>2자 이상 입력해야 다음으로 이동됩니다.",
	    login_nick_name_lable: "닉네임",
	    login_nick_name_input: "입력",
        
        // login_selvas_login page (현재 사용안함)
	    login_selvas_login_title_text: "사용자 로그인",
	    login_selvas_login_find_pwd_btn: "비밀번호 찾기",	    
	    login_selvas_login_desc_text_p: "SELVAS 회원가입 시에 등록하신<br/>이메일 주소와 비밀번호를 입력해 주세요.<br/>비밀번호를 분실하신 경우<br/>\"비밀번호 찾기\"를 선택하시면 됩니다.",
	    login_selvas_login_desc_text_l: "SELVAS 회원가입 시에 등록하신 이메일 주소와 비밀번호를 입력해 <br/>주세요. 비밀번호를 분실하신 경우 \"비밀번호 찾기\"를 선택하시면 됩니다.",
	    login_selvas_login_email_lable: "이메일",
	    login_selvas_login_password_lable: "비밀번호",
	    login_selvas_login_email_input: "email@selvas.com",
	    login_selvas_login_password_input: "입력",
	    login_selvas_login_join_member_btn: "회원가입",
	    login_selvas_login_sub_email_input_title: "이메일",
	    login_selvas_login_sub_email_input_holder: "email@selvas.com",
	    login_selvas_login_sub_pwd_input_title: "비밀번호",
	    login_selvas_login_sub_pwd_input_holder: "비밀번호",
	    login_selvas_login_check_password_text: "비밀번호를 입력해 주세요.",	
        
		///////////////////////
		// 공통 적용및 기타
		///////////////////////	    
        // 닉네임 변경 시 error msg
        change_nick_failed : "닉네임 변경에 실패하였습니다.",
        
		// status bar
	    com_status_confirm_btn: "확인",
	    com_status_finish_btn: "완료",
	    com_status_cancel_btn: "취소",
	    com_status_aggree_btn: "동의",
	    com_status_close_btn: "닫기",
	    com_status_back_btn: "뒤로",
	    
	    // common text	
	    com_google_login_box_title: "Sign in",
	    com_game_center_login_box_title: "Game Center 로그인",
	    com_selvas_login_box_title: "SELVAS 로그인",   
	    com_device_link_box_title: "디바이스 연동",
		com_account_info_btn: "계정 정보",
	    com_google_login_desc: "Google Play Games에 로그인하면 계정 정보 보호 및 여러 개의 Android 디바이스에서 게임 플레이가 가능합니다",
	    com_selvas_login_desc: "Google Play Games에 로그인하는 대신 SELVAS 계정으로 로그인하셔도 계정 정보 보호가 가능합니다.",
	    com_game_center_login_desc: "Apple 계정으로 Game Center에 로그인하면 계정 정보 보호 및 여러 개의 iOS 디바이스에서 게임 플레이가 가능합니다."
	},
	_zh : {
		///////////////////////
		// 로그인/프로파일 Page
		///////////////////////
		// Profile view page
		profile_account_default_info: "不选择",
		profile_basic_info_format: "{$1} / {$2}",
		profile_title_text: "用户信息",
		profile_account: "基本信息",
	    profile_nickname: "昵称",
	    profile_change_photo_btn: "变更",
	    profile_verify_email_send_msg: "发送了认证邮件",

	    // profile_edit_basic_info 
	    profile_edit_basic_info_title_text: "修改基本信息",
	    profile_edit_basic_info_sex_male: "男性",
	    profile_edit_basic_info_sex_female: "女性",
	    profile_edit_basic_info_age_10: "10~19岁",
	    profile_edit_basic_info_age_20: "20~29岁",
	    profile_edit_basic_info_age_30: "30~39岁",
	    profile_edit_basic_info_age_40: "40~49岁",
	    profile_edit_basic_info_age_50: "50~59岁",
	    profile_edit_basic_info_age_60: "60~69岁",
	    profile_edit_basic_info_save_fail: "保存个人信息失败",    
	    profile_edit_basic_info_load_error: "请求用户信息中发生了错误",
 
	    // login_guide page
	    login_guide_title_text: "登录引导",  
	    login_guide_login_exist_msg: "已经登录了",
	    
	    // login_set_account page
	    login_set_account_title_text: "设置账户",
	    login_set_account_device_link_login_desc: "可以在增加设备玩游戏或移动账户信息。",
	    
	    // login_account_info page
	    login_account_info_title_text: "设置账户",
	    login_account_info_email_title_label: "SELVAS账户",
	    login_account_info_chg_pwd_btn: "变更密码",
	    	    
	    // login_device_link_recommend_1 page
	    login_device_link_recommend_1_title_text: "联动设备",
	    login_device_link_recommend_1_google_link_desc: "Google Play Games登录后，请重试",
	    login_device_link_recommend_1_selvas_link_desc: "用SELVAS账户登录之后，请重试",
	    login_device_link_recommend_1_gamecenter_link_desc: "用Apple账户登录Game Center之后，请重试",
	 
	    // login_device_link_recommend_2 page
	    login_device_link_recommend_2_title_text: "联动设备",
	    login_device_link_recommend_2_link_desc: "希望在多个{$1}设备上玩游戏，在{$3}上通过游戏设置菜单登录{$2}账户即可。<br><br>" +"其它{$1}设备上用同一个{$2}账户登录。那么两个设备内信息自动同步。",

	    // login_device_link_option_1 page
	    login_device_link_option_1_title_text: "联动设备",
	    login_device_link_option_1_link_desc: "在两个设备上玩游戏或只在新的设备上保留账户都可以。",
	    login_device_link_option_1_current_device: "正在玩的<br/>设备",
	    login_device_link_option_1_new_device: "另一个<br/>设备",
	    
	    // login_device_link_option_2 page
	    login_device_link_option_2_title_text: "联动设备",
	    login_device_link_option_2_link_desc: "请选择联动的设备型号",
	    login_device_link_option_2_link_desc2: "※ 其他OS上不支持游戏",
	    login_device_link_option_2_ios_device: "iOS 设备",
	    login_device_link_option_2_android_device: "Android 设备",
	    
	    // login_device_link_code_output page
	    login_device_link_code_output_title_text: "设备联动",
	    login_device_link_code_output_desc1: "需要联动的设备上输入以下联动代码。",
	    login_device_link_code_output_desc2: "账户设置上选择联动设备，输入联动代码。（需要联动的设备）",
	    login_device_link_code_output_valid_time: "联动代码有效时间",
	    login_device_link_code_output_refresh_btn: "接收新的联动代码",
	    login_device_link_code_output_warn_msg: "禁止向第三者提供联动代码",

	    // login_device_link_code_input page
	    login_device_link_code_input_title_text: "设备联动",
	    login_device_link_code_input_holder: "联动代码",
	    login_device_link_code_input_desc1: "请输入联动代码",
	    login_device_link_code_input_desc2: "账户设置上选择联动设备，即可获得联动代码（原设备）",
	    
	    // login_device_link_confirm page
	    login_device_link_confirm_title_text: "设备联动",
	    login_device_link_confirm_desc1: "确认用以下账户替换当前账户？",
	    
	    // login_device_link_complete page
	    login_device_link_complete_title_text: "设备联动",
	    login_device_link_complete_desc1: "完成设备联动。点击确认，同步当前游戏数据。",
	    
		// Change password page (현재 사용안함)
	    login_change_pwd_sub_cur_pwd_input_title: "현재 비밀번호",
	    login_change_pwd_sub_cur_pwd_input_holder: "현재 비밀번호",
	    login_change_pwd_sub_new_pwd_input_title: "새 비밀번호",
	    login_change_pwd_sub_new_pwd_input_holder: "새 비밀번호",
	    login_change_pwd_sub_new_pwd_confirm_input_title: "새 비밀번호 확인",
	    login_change_pwd_sub_new_pwd_confirm_input_holder: "새 비밀번호 확인",	    
	    login_change_pwd_title_text: "비밀번호 변경",	    
	    login_change_pwd_desc_text_p: "변경하실 비밀번호를 입력해주세요.<br/>6자리 이상 입력해야 비밀번호를<br/>변경하실 수 있습니다.<br/>",
	    login_change_pwd_desc_text_l: "변경하실 비밀번호를 입력해주세요.<br/>6자리 이상 입력해야 비밀번호를 변경하실 수 있습니다.<br/>",
	    login_change_pwd_current_pwd_input: "현재 비밀번호",
	    login_change_pwd_new_pwd_input: "새 비밀번호",
	    login_change_pwd_new_pwd_confirm_input: "새 비밀번호 확인",
	    login_change_pwd_not_input_cur_pwd: "현재 비밀번호를 입력해주세요.",
	    login_change_pwd_not_input_new_pwd: "새로운 비밀번호를 입력해주세요.",
	    login_change_pwd_not_match_new_pwd: "새로운 비밀번호가 일치하지 않습니다.",
	    login_change_pwd_success_message:"비밀번호가 변경되었습니다.",
        
        // login_nick_name page (현재 사용안함)
	    login_nick_name_title_text: "닉네임 입력",
	    login_nick_name_sub_input_title: "닉네임",
	    login_nick_name_sub_input_holder: "입력",	    
	    login_nick_name_desc_text_p: "사용하실 닉네임을 입력해주십시오.<br/>2자 이상 입력해야 다음으로 이동됩니다.",
	    login_nick_name_desc_text_l: "사용하실 닉네임을 입력해주십시오.<br/>2자 이상 입력해야 다음으로 이동됩니다.",
	    login_nick_name_lable: "닉네임",
	    login_nick_name_input: "입력",
        
        // login_selvas_login page (현재 사용안함)
	    login_selvas_login_title_text: "사용자 로그인",
	    login_selvas_login_find_pwd_btn: "비밀번호 찾기",	    
	    login_selvas_login_desc_text_p: "SELVAS 회원가입 시에 등록하신<br/>이메일 주소와 비밀번호를 입력해 주세요.<br/>비밀번호를 분실하신 경우<br/>\"비밀번호 찾기\"를 선택하시면 됩니다.",
	    login_selvas_login_desc_text_l: "SELVAS 회원가입 시에 등록하신 이메일 주소와 비밀번호를 입력해 <br/>주세요. 비밀번호를 분실하신 경우 \"비밀번호 찾기\"를 선택하시면 됩니다.",
	    login_selvas_login_email_lable: "이메일",
	    login_selvas_login_password_lable: "비밀번호",
	    login_selvas_login_email_input: "email@selvas.com",
	    login_selvas_login_password_input: "입력",
	    login_selvas_login_join_member_btn: "회원가입",
	    login_selvas_login_sub_email_input_title: "이메일",
	    login_selvas_login_sub_email_input_holder: "email@selvas.com",
	    login_selvas_login_sub_pwd_input_title: "비밀번호",
	    login_selvas_login_sub_pwd_input_holder: "비밀번호",
	    login_selvas_login_check_password_text: "비밀번호를 입력해 주세요.",
 
		///////////////////////
		// 공통 적용및 기타
		///////////////////////	    
        // 닉네임 변경 시 error msg
        change_nick_failed : "更改昵称失败",
        
		// status bar
	    com_status_confirm_btn: "确认",
	    com_status_finish_btn: "完成",
	    com_status_cancel_btn: "取消",
	    com_status_aggree_btn: "同意",
	    com_status_close_btn: "关闭",
	    com_status_back_btn: "后退",
	    
	    // common text
	    com_google_login_box_title: "登录",
	    com_game_center_login_box_title: "Game Center登录",
	    com_selvas_login_box_title: "SELVAS登录",   
	    com_device_link_box_title: "设备联动",
		com_account_info_btn: "账户信息",
	    com_google_login_desc: "Google Play Games登录不仅账号受保护，可在多个安卓设备中运行游戏",
	    com_selvas_login_desc: "Google Play Games账号或SELVAS账号登录，都可以保护账号信息",
	    com_game_center_login_desc: "用Apple账户登录 Game Center，可以保护账户以及同时在多个IOS设备上玩游戏。"
	},
	_ja : {
		///////////////////////
		// 로그인/프로파일 Page
		///////////////////////
		// Profile view page
		profile_account_default_info: "選択しない",
		profile_basic_info_format: "{$1} / {$2}",
		profile_title_text: "使用者情報",
		profile_account: "基本情報",
	    profile_nickname: "ニックネーム",
	    profile_change_photo_btn: "変更",
	    profile_verify_email_send_msg: "認証Emailが送信されました。",

	    // profile_edit_basic_info 
	    profile_edit_basic_info_title_text: "基本情報変更",
	    profile_edit_basic_info_sex_male: "男性",
	    profile_edit_basic_info_sex_female: "女性",
	    profile_edit_basic_info_age_10: "10代",
	    profile_edit_basic_info_age_20: "20代",
	    profile_edit_basic_info_age_30: "30代",
	    profile_edit_basic_info_age_40: "40代",
	    profile_edit_basic_info_age_50: "50代",
	    profile_edit_basic_info_age_60: "60代",
	    profile_edit_basic_info_save_fail: "プロフィール保存に失敗しました。",    
	    profile_edit_basic_info_load_error: "使用者情報をリクエスト中にエラーが発生しました。",
   
	    // login_guide page
	    login_guide_title_text: "ログイン案内",  
	    login_guide_login_exist_msg: "現在ログインされています。",
	    
	    // login_set_account page
	    login_set_account_title_text: "アカウント設定",
	    login_set_account_device_link_login_desc: "現在使用中のデバイスの他に、新しいデバイスにアカウントを移行してゲームプレイが可能です。",
	    
	    // login_account_info page
	    login_account_info_title_text: "アカウント情報",
	    login_account_info_email_title_label: "SELVASアカウント",
	    login_account_info_chg_pwd_btn: "パスワード変更",
	    	    
	    // login_device_link_recommend_1 page
	    login_device_link_recommend_1_title_text: "デバイス連動",
	    login_device_link_recommend_1_google_link_desc: "Google Play Gamesにログイン後、再試行してください。",
	    login_device_link_recommend_1_selvas_link_desc: "SELVASアカウントから最初ログインした後、再試行してみてください。",
	    login_device_link_recommend_1_gamecenter_link_desc: "Appleアカウントから Game Centerに最初ログインした後、再試行してみてください。",
	 
	    // login_device_link_recommend_2 page
	    login_device_link_recommend_2_title_text: "デバイス連動",
	    login_device_link_recommend_2_link_desc: "複数の{$1}デバイスからゲームプレイを希望する場合は、ゲーム設定メニューを通じて{$2}アカウントから{$3}にログインしてください。<br><br>" +
"他の{$1}デバイスからでも同一な{$2}アカウントからログインすれば同じアカウント情報が自動的に同期化されます。",

	    // login_device_link_option_1 page
	    login_device_link_option_1_title_text: "デバイス連動",
	    login_device_link_option_1_link_desc: "２つのデバイスプレイまたは、新しいデバイスにアカウントを移動してプレイすることができます。",
	    login_device_link_option_1_current_device: "プレイ中の<br/>デバイス",
	    login_device_link_option_1_new_device: "新しい<br/>デバイス",
	    
	    // login_device_link_option_2 page
	    login_device_link_option_2_title_text: "デバイス連動",
	    login_device_link_option_2_link_desc: "新しく連動するデバイスタイプを選択してください。",
	    login_device_link_option_2_link_desc2: "※その他のOSからではゲームを支援していません。",
	    login_device_link_option_2_ios_device: "iOSデバイス",
	    login_device_link_option_2_android_device: "Androidデバイス",
	    
	    // login_device_link_code_output page
	    login_device_link_code_output_title_text: "デバイス連動",
	    login_device_link_code_output_desc1: "新しく連動するデバイスから下記のコードを<br/>入力してください。",
	    login_device_link_code_output_desc2: "新しく連動するデバイスからアカウント設定メニューのデバイス連動を選択すると、連動コードを入力することができます。",
	    login_device_link_code_output_valid_time: "連動コード有効期間",
	    login_device_link_code_output_refresh_btn: "連動コードを新しくもらう",
	    login_device_link_code_output_warn_msg: "連動コードは本人以外の第3者に提供することを禁止する。",

	    // login_device_link_code_input page
	    login_device_link_code_input_title_text: "デバイス連動",
	    login_device_link_code_input_holder: "連動コード",
	    login_device_link_code_input_desc1: "連動コードを入力してください。",
	    login_device_link_code_input_desc2: "すでに使用したデバイスからアカウント設定メニューのデバイス連動を選択して連動コードを受けることができます。",
	    
	    // login_device_link_confirm page
	    login_device_link_confirm_title_text: "デバイス連動",
	    login_device_link_confirm_desc1: "現在プレイしたアカウントのデータを削除して、本当に次のアカウントに切り替えますか？",
	    
	    // login_device_link_complete page
	    login_device_link_complete_title_text: "デバイス連動",
	    login_device_link_complete_desc1: "デバイス連動が完了しました。確認ボタンを押したら該当アカウントのゲームデータが同期化されます。",
	    
		// Change password page (현재 사용안함)
	    login_change_pwd_sub_cur_pwd_input_title: "현재 비밀번호",
	    login_change_pwd_sub_cur_pwd_input_holder: "현재 비밀번호",
	    login_change_pwd_sub_new_pwd_input_title: "새 비밀번호",
	    login_change_pwd_sub_new_pwd_input_holder: "새 비밀번호",
	    login_change_pwd_sub_new_pwd_confirm_input_title: "새 비밀번호 확인",
	    login_change_pwd_sub_new_pwd_confirm_input_holder: "새 비밀번호 확인",	    
	    login_change_pwd_title_text: "비밀번호 변경",	    
	    login_change_pwd_desc_text_p: "변경하실 비밀번호를 입력해주세요.<br/>6자리 이상 입력해야 비밀번호를<br/>변경하실 수 있습니다.<br/>",
	    login_change_pwd_desc_text_l: "변경하실 비밀번호를 입력해주세요.<br/>6자리 이상 입력해야 비밀번호를 변경하실 수 있습니다.<br/>",
	    login_change_pwd_current_pwd_input: "현재 비밀번호",
	    login_change_pwd_new_pwd_input: "새 비밀번호",
	    login_change_pwd_new_pwd_confirm_input: "새 비밀번호 확인",
	    login_change_pwd_not_input_cur_pwd: "현재 비밀번호를 입력해주세요.",
	    login_change_pwd_not_input_new_pwd: "새로운 비밀번호를 입력해주세요.",
	    login_change_pwd_not_match_new_pwd: "새로운 비밀번호가 일치하지 않습니다.",
	    login_change_pwd_success_message:"비밀번호가 변경되었습니다.",
        
        // login_nick_name page (현재 사용안함)
	    login_nick_name_title_text: "닉네임 입력",
	    login_nick_name_sub_input_title: "닉네임",
	    login_nick_name_sub_input_holder: "입력",	    
	    login_nick_name_desc_text_p: "사용하실 닉네임을 입력해주십시오.<br/>2자 이상 입력해야 다음으로 이동됩니다.",
	    login_nick_name_desc_text_l: "사용하실 닉네임을 입력해주십시오.<br/>2자 이상 입력해야 다음으로 이동됩니다.",
	    login_nick_name_lable: "닉네임",
	    login_nick_name_input: "입력",
        
        // login_selvas_login page (현재 사용안함)
	    login_selvas_login_title_text: "사용자 로그인",
	    login_selvas_login_find_pwd_btn: "비밀번호 찾기",	    
	    login_selvas_login_desc_text_p: "SELVAS 회원가입 시에 등록하신<br/>이메일 주소와 비밀번호를 입력해 주세요.<br/>비밀번호를 분실하신 경우<br/>\"비밀번호 찾기\"를 선택하시면 됩니다.",
	    login_selvas_login_desc_text_l: "SELVAS 회원가입 시에 등록하신 이메일 주소와 비밀번호를 입력해 <br/>주세요. 비밀번호를 분실하신 경우 \"비밀번호 찾기\"를 선택하시면 됩니다.",
	    login_selvas_login_email_lable: "이메일",
	    login_selvas_login_password_lable: "비밀번호",
	    login_selvas_login_email_input: "email@selvas.com",
	    login_selvas_login_password_input: "입력",
	    login_selvas_login_join_member_btn: "회원가입",
	    login_selvas_login_sub_email_input_title: "이메일",
	    login_selvas_login_sub_email_input_holder: "email@selvas.com",
	    login_selvas_login_sub_pwd_input_title: "비밀번호",
	    login_selvas_login_sub_pwd_input_holder: "비밀번호",
	    login_selvas_login_check_password_text: "비밀번호를 입력해 주세요.",	
        
		///////////////////////
		// 공통 적용및 기타
		///////////////////////	    
        // 닉네임 변경 시 error msg
        change_nick_failed : "ニックネーム変更に失敗しました。",
        
		// status bar
	    com_status_confirm_btn: "確認",
	    com_status_finish_btn: "完了",
	    com_status_cancel_btn: "キャンセル",
	    com_status_aggree_btn: "同意",
	    com_status_close_btn: "閉じる",
	    com_status_back_btn: "戻る",
	    
	    // common text	
	    com_google_login_box_title: "サインイン",
	    com_game_center_login_box_title: "Game Centerログイン",
	    com_selvas_login_box_title: "SELVAS ログイン",   
	    com_device_link_box_title: "デバイス連動",
		com_account_info_btn: "アカウント情報",
	    com_google_login_desc: "Google Play Gamesにログインするとアカウント情報保護と複数のAndroidデバイスからゲームプレイが可能です。",
	    com_selvas_login_desc: "Google Play Gamesにログインする代わり、SELVASアカウントでログイン してもアカウント情報の保護が可能です。",
	    com_game_center_login_desc: "Appleアカウントから Google Play Gamesに最初ログインしたら個人情報保護と複数のAndroidデバイスからゲームプレイが可能になります。"
	},
	_de : {			
		///////////////////////
		// 로그인/프로파일 Page
		///////////////////////
		// Profile view page
		profile_account_default_info: "Nicht wählen.",
		profile_basic_info_format: "{$1} / {$2}",
		profile_title_text: "Benutzerinformationen",
		profile_account: "Basisinformationen",
	    profile_nickname: "Benutzername",
	    profile_change_photo_btn: "Ändern",
	    profile_verify_email_send_msg: "Verifizierungsmail wurde gesendet.",

	    // profile_edit_basic_info 
	    profile_edit_basic_info_title_text: "Änderung der Basisinformationen.",
	    profile_edit_basic_info_sex_male: "Männlich",
	    profile_edit_basic_info_sex_female: "Weiblich",
	    profile_edit_basic_info_age_10: "Altersgruppe 10",
	    profile_edit_basic_info_age_20: "Altersgruppe 20",
	    profile_edit_basic_info_age_30: "Altersgruppe 30",
	    profile_edit_basic_info_age_40: "Altersgruppe 40",
	    profile_edit_basic_info_age_50: "Altersgruppe 50",
	    profile_edit_basic_info_age_60: "Altersgruppe 60",
	    profile_edit_basic_info_save_fail: "Profil konnte nicht gespeichert werden",    
	    profile_edit_basic_info_load_error: "Fehler bei der Anfrage von Benutzerinformationen",
	    
	    // login_guide page
	    login_guide_title_text: "Anmeldungsanleitung",  
	    login_guide_login_exist_msg: "Du bist nicht angemeldet",
	    
	    // login_set_account page
	    login_set_account_title_text: "Kontoeinstellung",
	    login_set_account_device_link_login_desc: "Die Kontoinformationen können auf ein zusätzliches Gerät übertragen werden",
	    
	    // login_account_info page
	    login_account_info_title_text: "Kontoinformationen",
	    login_account_info_email_title_label: "SELVAS-Konto",
	    login_account_info_chg_pwd_btn: "Passwort ändern",
	    	    
	    // login_device_link_recommend_1 page
	    login_device_link_recommend_1_title_text: "Gerät verbinden",
	    login_device_link_recommend_1_google_link_desc: "Please log into Google Play Games and try again.",
	    login_device_link_recommend_1_selvas_link_desc: "Bitte versuche dich nach dem Einloggen beim SELVAS-Konto anzumelden.",
	    login_device_link_recommend_1_gamecenter_link_desc: "Bitte versuche dich nach dem Einloggen beim Apple Game Center-Konto anzumelden.",
	 
	    // login_device_link_recommend_2 page
	    login_device_link_recommend_2_title_text: "Gerät verbinden",
	    login_device_link_recommend_2_link_desc: "Wenn du von mehreren {$1} Geräten aus spielen möchtest, versuche dich vom Menü Spieleinstellungen aus ins {$2} Konto anzumelden und logge dich ein {$3}.<br><br>" +
	    		" Es wird sich automatisch mit einem anderen {$1} Gerät verbinden, indem du dich in das {$2} Konto einloggst.",

	    // login_device_link_option_1 page
	    login_device_link_option_1_title_text: "Gerät verbinden",
	    login_device_link_option_1_link_desc: "Du kannst zwei Geräte verbinden, um zu spielen oder Dateien zu übertragen.",
	    login_device_link_option_1_current_device: "Zur Zeit aktives <br/> Gerät",
	    login_device_link_option_1_new_device: "Neues <br/> Gerät",
	    
	    // login_device_link_option_2 page
	    login_device_link_option_2_title_text: "Gerät verbinden",
	    login_device_link_option_2_link_desc: "Wähle einen neu verknüpften Gerätetyp.",
	    login_device_link_option_2_link_desc2: "※ Anderes OS wird nicht unterstützt.",
	    login_device_link_option_2_ios_device: "iOS-Gerät",
	    login_device_link_option_2_android_device: "Android-Gerät",
	    
	    // login_device_link_code_output page
	    login_device_link_code_output_title_text: "Gerät verbinden",
	    login_device_link_code_output_desc1: "Eingabe unter <br/> Link-Code zum neuen Gerät, das du verbinden möchten",
	    login_device_link_code_output_desc2: "Du kannst dich mit einem neuen Gerät verbinden, indem du einen Link-Code über das Menü Kontoeinstellungen auf dem neuen Gerät eingibst.",
	    login_device_link_code_output_valid_time: "Gültige Zeit für Link-Code",
	    login_device_link_code_output_refresh_btn: "Neuen Link-Code ausgeben",
	    login_device_link_code_output_warn_msg: "Warnung: Teile den Link-Code nicht mit anderen.",

	    // login_device_link_code_input page
	    login_device_link_code_input_title_text: "Gerät verbinden",
	    login_device_link_code_input_holder: "Link-Code",
	    login_device_link_code_input_desc1: "Bitte gib den Link-Code ein.",
	    login_device_link_code_input_desc2: "Du kannst den Link-Code vom zu verbindenden Gerät im Menü Kontoeinstellungen deines ursprünglichen Gerätes finden.",
	    
	    // login_device_link_confirm page
	    login_device_link_confirm_title_text: "Gerät verbinden",
	    login_device_link_confirm_desc1: "Bist du sicher, dass du den aktuellen Fortschritt auf diesem Gerät löschen und durch die folgenden Kontoinformationen ersetzen möchtest?",
	    
	    // login_device_link_complete page
	    login_device_link_complete_title_text: "Gerät verbinden",
	    login_device_link_complete_desc1: "Geräteverbindung abgeschlossen. Klicke auf OK, um Kontoinformationen zu synchronisieren.",
	    
		// Change password page (현재 사용안함)
	    login_change_pwd_sub_cur_pwd_input_title: "현재 비밀번호",
	    login_change_pwd_sub_cur_pwd_input_holder: "현재 비밀번호",
	    login_change_pwd_sub_new_pwd_input_title: "새 비밀번호",
	    login_change_pwd_sub_new_pwd_input_holder: "새 비밀번호",
	    login_change_pwd_sub_new_pwd_confirm_input_title: "새 비밀번호 확인",
	    login_change_pwd_sub_new_pwd_confirm_input_holder: "새 비밀번호 확인",	    
	    login_change_pwd_title_text: "비밀번호 변경",	    
	    login_change_pwd_desc_text_p: "변경하실 비밀번호를 입력해주세요.<br/>6자리 이상 입력해야 비밀번호를<br/>변경하실 수 있습니다.<br/>",
	    login_change_pwd_desc_text_l: "변경하실 비밀번호를 입력해주세요.<br/>6자리 이상 입력해야 비밀번호를 변경하실 수 있습니다.<br/>",
	    login_change_pwd_current_pwd_input: "현재 비밀번호",
	    login_change_pwd_new_pwd_input: "새 비밀번호",
	    login_change_pwd_new_pwd_confirm_input: "새 비밀번호 확인",
	    login_change_pwd_not_input_cur_pwd: "현재 비밀번호를 입력해주세요.",
	    login_change_pwd_not_input_new_pwd: "새로운 비밀번호를 입력해주세요.",
	    login_change_pwd_not_match_new_pwd: "새로운 비밀번호가 일치하지 않습니다.",
	    login_change_pwd_success_message:"비밀번호가 변경되었습니다.",
        
        // login_nick_name page (현재 사용안함)
	    login_nick_name_title_text: "닉네임 입력",
	    login_nick_name_sub_input_title: "Nick name",
	    login_nick_name_sub_input_holder: "입력",	    
	    login_nick_name_desc_text_p: "사용하실 닉네임을 입력해주십시오.<br/>2자 이상 입력해야 다음으로 이동됩니다.",
	    login_nick_name_desc_text_l: "사용하실 닉네임을 입력해주십시오.<br/>2자 이상 입력해야 다음으로 이동됩니다.",
	    login_nick_name_lable: "Nick name",
	    login_nick_name_input: "입력",
        
        // login_selvas_login page (현재 사용안함)
	    login_selvas_login_title_text: "사용자 로그인",
	    login_selvas_login_find_pwd_btn: "비밀번호 찾기",	    
	    login_selvas_login_desc_text_p: "SELVAS 회원가입 시에 등록하신<br/>이메일 주소와 비밀번호를 입력해 주세요.<br/>비밀번호를 분실하신 경우<br/>\"비밀번호 찾기\"를 선택하시면 됩니다.",
	    login_selvas_login_desc_text_l: "SELVAS 회원가입 시에 등록하신 이메일 주소와 비밀번호를 입력해 <br/>주세요. 비밀번호를 분실하신 경우 \"비밀번호 찾기\"를 선택하시면 됩니다.",
	    login_selvas_login_email_lable: "이메일",
	    login_selvas_login_password_lable: "Password",
	    login_selvas_login_email_input: "email@selvas.com",
	    login_selvas_login_password_input: "입력",
	    login_selvas_login_join_member_btn: "Member register",
	    login_selvas_login_sub_email_input_title: "이메일",
	    login_selvas_login_sub_email_input_holder: "email@selvas.com",
	    login_selvas_login_sub_pwd_input_title: "Password",
	    login_selvas_login_sub_pwd_input_holder: "Password",
	    login_selvas_login_check_password_text: "비밀번호를 입력해 주세요.",	
         
		///////////////////////
		// 공통 적용및 기타
		///////////////////////	    
        // 닉네임 변경 시 error msg
        change_nick_failed : "Fehler beim Ändern des Benutzernamens",
        
		// status bar
	    com_status_confirm_btn: "Ok",
	    com_status_finish_btn: "Komplett",
	    com_status_cancel_btn: "Abbrechen",
	    com_status_aggree_btn: "Zustimmen",
	    com_status_close_btn: "Schließen",
	    com_status_back_btn: "Zurück",
	    
	    // common text	
	    com_google_login_box_title: "Sign in",
	    com_game_center_login_box_title: "Game Center Anmelden",
	    com_selvas_login_box_title: "SELVAS Anmelden",   
	    com_device_link_box_title: "Gerät verbinden",
		com_account_info_btn: "Kontoinformationen",
	    com_google_login_desc: "Logging into Google Play Games will not only protect user information, but also allow game play from multiple Android devices.",
	    com_selvas_login_desc: "Logging into Selvas account instead of Google Play Games will also protect user information.",
	    com_game_center_login_desc: "Das Anmelden bei Game Center mit einem iTunes-Konto wird nicht nur die Informationen eines Benutzers schützen, sondern auch das Spielen über mehrere iOS-Geräte ermöglichen."
	},
	_it : {			
		///////////////////////
		// 로그인/프로파일 Page
		///////////////////////
		// Profile view page
		profile_account_default_info: "Non selezionare.",
		profile_basic_info_format: "{$1} / {$2}",
		profile_title_text: "Dati utente",
		profile_account: "Dati di base",
	    profile_nickname: "Nome utente",
	    profile_change_photo_btn: "Cambiamento",
	    profile_verify_email_send_msg: "L’email di verifica è stata inviata.",

	    // profile_edit_basic_info 
	    profile_edit_basic_info_title_text: "Cambiamento dati di base.",
	    profile_edit_basic_info_sex_male: "Maschio",
	    profile_edit_basic_info_sex_female: "Femmina",
	    profile_edit_basic_info_age_10: "fascia di età 10",
	    profile_edit_basic_info_age_20: "fascia di età 20",
	    profile_edit_basic_info_age_30: "fascia di età 30",
	    profile_edit_basic_info_age_40: "fascia di età 40",
	    profile_edit_basic_info_age_50: "fascia di età 50",
	    profile_edit_basic_info_age_60: "fascia di età 60",
	    profile_edit_basic_info_save_fail: "Impossibile salvare il profilo",    
	    profile_edit_basic_info_load_error: "Si è verificato un errore durante la richiesta di dati dell’utente",
	    
	    // login_guide page
	    login_guide_title_text: "Guida al login",  
	    login_guide_login_exist_msg: "Non sei iscritto",
	    
	    // login_set_account page
	    login_set_account_title_text: "Impostazioni account",
	    login_set_account_device_link_login_desc: "I dati dell’account possono essere trasferiti al dispositivo aggiuntivo",
	    
	    // login_account_info page
	    login_account_info_title_text: "Dati dell’account",
	    login_account_info_email_title_label: "Account SELVAS",
	    login_account_info_chg_pwd_btn: "Cambia la password",
	    	    
	    // login_device_link_recommend_1 page
	    login_device_link_recommend_1_title_text: "Collega dispositivo",
	    login_device_link_recommend_1_google_link_desc: "Please log into Google Play Games and try again.",
	    login_device_link_recommend_1_selvas_link_desc: "Prova ad accedere dopo l'accesso all’account SELVAS.",
	    login_device_link_recommend_1_gamecenter_link_desc: "Prova ad accedere dopo l'accesso all’account Apple Game Center.",
	 
	    // login_device_link_recommend_2 page
	    login_device_link_recommend_2_title_text: "Collega dispositivo",
	    login_device_link_recommend_2_link_desc: "Se vuoi giocare da più {$1} dispositivi, prova accedendo {$2} all’account dal menu di impostazione di gioco e accedi {$3}.<br><br>" +
	    		" Si collegherà automaticamente con altri {$1} dispositivi accedendo all’ {$2} account.",

	    // login_device_link_option_1 page
	    login_device_link_option_1_title_text: "Collega dispositivo",
	    login_device_link_option_1_link_desc: "È possibile collegare due dispositivi per riprodurre o trasferire i file.",
	    login_device_link_option_1_current_device: "Dispositivo attualmente <br/> attivo",
	    login_device_link_option_1_new_device: "Nuovo <br/> dispositivo",
	    
	    // login_device_link_option_2 page
	    login_device_link_option_2_title_text: "Collega dispositivo",
	    login_device_link_option_2_link_desc: "Seleziona il tipo di dispositivo appena collegato.",
	    login_device_link_option_2_link_desc2: "※ Altri OS non supportati.",
	    login_device_link_option_2_ios_device: "Dispositivo iOS",
	    login_device_link_option_2_android_device: "Dispositivo Android",
	    
	    // login_device_link_code_output page
	    login_device_link_code_output_title_text: "Collega dispositivo",
	    login_device_link_code_output_desc1: "Inserire di seguito <br/> il codice di collegamento al nuovo dispositivo che si desidera collegare",
	    login_device_link_code_output_desc2: "È possibile collegare un nuovo dispositivo inserendo un codice di collegamento tramite il menu impostazioni dell'account sul nuovo dispositivo.",
	    login_device_link_code_output_valid_time: "Tempo valido per il codice di collegamento",
	    login_device_link_code_output_refresh_btn: "Emetti nuovo codice di collegamento",
	    login_device_link_code_output_warn_msg: "Attenzione: Non condividere il codice di collegamento con altri.",

	    // login_device_link_code_input page
	    login_device_link_code_input_title_text: "Collega dispositivo",
	    login_device_link_code_input_holder: "Codice di collegamento",
	    login_device_link_code_input_desc1: "Inserisci il codice di collegamento.",
	    login_device_link_code_input_desc2: "È possibile trovare il codice di collegamento dal dispositivo collegato nel menu di impostazione dell’account del dispositivo originale.",
	    
	    // login_device_link_confirm page
	    login_device_link_confirm_title_text: "Collega dispositivo",
	    login_device_link_confirm_desc1: "Sei sicuro di voler eliminare gli attuali progressi su questo dispositivo e sostituirlo con i seguenti dati di account?",
	    
	    // login_device_link_complete page
	    login_device_link_complete_title_text: "Collega dispositivo",
	    login_device_link_complete_desc1: "Collegamento del dispositivo completato. Clicca Ok per sincronizzare le informazioni dell'account.",
	    
		// Change password page (현재 사용안함)
	    login_change_pwd_sub_cur_pwd_input_title: "현재 비밀번호",
	    login_change_pwd_sub_cur_pwd_input_holder: "현재 비밀번호",
	    login_change_pwd_sub_new_pwd_input_title: "새 비밀번호",
	    login_change_pwd_sub_new_pwd_input_holder: "새 비밀번호",
	    login_change_pwd_sub_new_pwd_confirm_input_title: "새 비밀번호 확인",
	    login_change_pwd_sub_new_pwd_confirm_input_holder: "새 비밀번호 확인",	    
	    login_change_pwd_title_text: "비밀번호 변경",	    
	    login_change_pwd_desc_text_p: "변경하실 비밀번호를 입력해주세요.<br/>6자리 이상 입력해야 비밀번호를<br/>변경하실 수 있습니다.<br/>",
	    login_change_pwd_desc_text_l: "변경하실 비밀번호를 입력해주세요.<br/>6자리 이상 입력해야 비밀번호를 변경하실 수 있습니다.<br/>",
	    login_change_pwd_current_pwd_input: "현재 비밀번호",
	    login_change_pwd_new_pwd_input: "새 비밀번호",
	    login_change_pwd_new_pwd_confirm_input: "새 비밀번호 확인",
	    login_change_pwd_not_input_cur_pwd: "현재 비밀번호를 입력해주세요.",
	    login_change_pwd_not_input_new_pwd: "새로운 비밀번호를 입력해주세요.",
	    login_change_pwd_not_match_new_pwd: "새로운 비밀번호가 일치하지 않습니다.",
	    login_change_pwd_success_message:"비밀번호가 변경되었습니다.",
        
        // login_nick_name page (현재 사용안함)
	    login_nick_name_title_text: "닉네임 입력",
	    login_nick_name_sub_input_title: "Nick name",
	    login_nick_name_sub_input_holder: "입력",	    
	    login_nick_name_desc_text_p: "사용하실 닉네임을 입력해주십시오.<br/>2자 이상 입력해야 다음으로 이동됩니다.",
	    login_nick_name_desc_text_l: "사용하실 닉네임을 입력해주십시오.<br/>2자 이상 입력해야 다음으로 이동됩니다.",
	    login_nick_name_lable: "Nick name",
	    login_nick_name_input: "입력",
        
        // login_selvas_login page (현재 사용안함)
	    login_selvas_login_title_text: "사용자 로그인",
	    login_selvas_login_find_pwd_btn: "비밀번호 찾기",	    
	    login_selvas_login_desc_text_p: "SELVAS 회원가입 시에 등록하신<br/>이메일 주소와 비밀번호를 입력해 주세요.<br/>비밀번호를 분실하신 경우<br/>\"비밀번호 찾기\"를 선택하시면 됩니다.",
	    login_selvas_login_desc_text_l: "SELVAS 회원가입 시에 등록하신 이메일 주소와 비밀번호를 입력해 <br/>주세요. 비밀번호를 분실하신 경우 \"비밀번호 찾기\"를 선택하시면 됩니다.",
	    login_selvas_login_email_lable: "이메일",
	    login_selvas_login_password_lable: "Password",
	    login_selvas_login_email_input: "email@selvas.com",
	    login_selvas_login_password_input: "입력",
	    login_selvas_login_join_member_btn: "Member register",
	    login_selvas_login_sub_email_input_title: "이메일",
	    login_selvas_login_sub_email_input_holder: "email@selvas.com",
	    login_selvas_login_sub_pwd_input_title: "Password",
	    login_selvas_login_sub_pwd_input_holder: "Password",
	    login_selvas_login_check_password_text: "비밀번호를 입력해 주세요.",	

		///////////////////////
		// 공통 적용및 기타
		///////////////////////	    
        // 닉네임 변경 시 error msg
        change_nick_failed : "Impossibile modificare il nome utente",
        
		// status bar
	    com_status_confirm_btn: "Ok",
	    com_status_finish_btn: "Completo",
	    com_status_cancel_btn: "Elimina",
	    com_status_aggree_btn: "Accetto",
	    com_status_close_btn: "Chiudi",
	    com_status_back_btn: "Indietro",
	    
	    // common text	
	    com_google_login_box_title: "Sign in",
	    com_game_center_login_box_title: "Accesso a Game Center",
	    com_selvas_login_box_title: "Accesso a SELVAS",   
	    com_device_link_box_title: "Collega dispositivo",
		com_account_info_btn: "Dati account",
	    com_google_login_desc: "Logging into Google Play Games will not only protect user information, but also allow game play from multiple Android devices.",
	    com_selvas_login_desc: "Logging into Selvas account instead of Google Play Games will also protect user information.",
	    com_game_center_login_desc: "Accedere a Game Center utilizzando un account iTunes non soltanto proteggerà i dati dell’utente, ma permetterà anche di giocare tra più dispositivi iOS."
	},
	_fr : {			
		///////////////////////
		// 로그인/프로파일 Page
		///////////////////////
		// Profile view page
		profile_account_default_info: "Ne sélectionnez pas.",
		profile_basic_info_format: "{$1} / {$2}",
		profile_title_text: "Informations sur l'utilisateur",
		profile_account: "Informations de base",
	    profile_nickname: "Nom d'utilisateur",
	    profile_change_photo_btn: "Modification",
	    profile_verify_email_send_msg: "Un e-mail de vérification a été envoyé.",

	    // profile_edit_basic_info 
	    profile_edit_basic_info_title_text: "Modification des informations de base.",
	    profile_edit_basic_info_sex_male: "Homme",
	    profile_edit_basic_info_sex_female: "Femme",
	    profile_edit_basic_info_age_10: "groupe d'âge 10",
	    profile_edit_basic_info_age_20: "groupe d'âge 20",
	    profile_edit_basic_info_age_30: "groupe d'âge 30",
	    profile_edit_basic_info_age_40: "groupe d'âge 40",
	    profile_edit_basic_info_age_50: "groupe d'âge 50",
	    profile_edit_basic_info_age_60: "groupe d'âge 60",
	    profile_edit_basic_info_save_fail: "Impossible d'enregistrer le profil",    
	    profile_edit_basic_info_load_error: "Une erreur est survenue lors de la demande d'informations de l'utilisateur",
	    
	    // login_guide page
	    login_guide_title_text: "Guide de connexion",  
	    login_guide_login_exist_msg: "Vous n'êtes pas connecté",
	    
	    // login_set_account page
	    login_set_account_title_text: "Configuration du compte",
	    login_set_account_device_link_login_desc: "Les informations de compte peuvent être transférées à un dispositif supplémentaire",
	    
	    // login_account_info page
	    login_account_info_title_text: "Infos sur le compte",
	    login_account_info_email_title_label: "Compte SELVAS",
	    login_account_info_chg_pwd_btn: "Modifier le mot de passe",
	    	    
	    // login_device_link_recommend_1 page
	    login_device_link_recommend_1_title_text: "Associer le dispositif",
	    login_device_link_recommend_1_google_link_desc: "Please log into Google Play Games and try again.",
	    login_device_link_recommend_1_selvas_link_desc: "Veuillez essayer de vous connecter après la connexion au compte SELVAS.",
	    login_device_link_recommend_1_gamecenter_link_desc: "Veuillez essayer de vous connecter après la connexion au compte Game Center d'Apple.",
	 
	    // login_device_link_recommend_2 page
	    login_device_link_recommend_2_title_text: "Associer le dispositif",
	    login_device_link_recommend_2_link_desc: "Si vous voulez jouer depuis plusieurs {$1} dispositifs, essayez de vous connecter au {$2} compte à partir du menu de réglage des jeux et connectez-vous {$3}.<br><br>" +
	    		" Il sera automatiquement associé avec les autres {$1} dispositifs en se connectant au {$2} compte",

	    // login_device_link_option_1 page
	    login_device_link_option_1_title_text: "Associer le dispositif",
	    login_device_link_option_1_link_desc: "Vous pouvez associer deux dispositifs pour jouer ou transférer des fichiers.",
	    login_device_link_option_1_current_device: "Dispositif actuellement <br/> actif",
	    login_device_link_option_1_new_device: "Nouveau <br/> dispositif",
	    
	    // login_device_link_option_2 page
	    login_device_link_option_2_title_text: "Associer le dispositif",
	    login_device_link_option_2_link_desc: "Sélectionnez le type de dispositif nouvellement associé.",
	    login_device_link_option_2_link_desc2: "※ Pas d’autre système d’exploitation pris en charge.",
	    login_device_link_option_2_ios_device: "Périphérique iOS",
	    login_device_link_option_2_android_device: "Dispositif Android",
	    
	    // login_device_link_code_output page
	    login_device_link_code_output_title_text: "Associer le dispositif",
	    login_device_link_code_output_desc1: "Saisissez ci-dessous <br/> le code d’association vers le nouveau dispositif que vous souhaitez associer",
	    login_device_link_code_output_desc2: "Vous pouvez associer à un nouveau dispositif en saisissant un code d’association via le menu de réglages du compte sur le nouveau dispositif.",
	    login_device_link_code_output_valid_time: "Durée de validité du code d’association",
	    login_device_link_code_output_refresh_btn: "Émettre un nouveau code d’association",
	    login_device_link_code_output_warn_msg: "Attention : Ne pas partager le code d’association avec les autres.",

	    // login_device_link_code_input page
	    login_device_link_code_input_title_text: "Associer le dispositif",
	    login_device_link_code_input_holder: "Code d’association",
	    login_device_link_code_input_desc1: "Veuillez saisir le code d’association.",
	    login_device_link_code_input_desc2: "Vous pouvez trouver le code d’association depuis le dispositif d’association dans le menu de réglages du compte de votre dispositif d’origine.",
	    
	    // login_device_link_confirm page
	    login_device_link_confirm_title_text: "Associer le dispositif",
	    login_device_link_confirm_desc1: "Êtes-vous sûr de vouloir supprimer les progrès actuels sur ce dispositif et de vouloir les remplacer par les données de comptes suivantes ?",
	    
	    // login_device_link_complete page
	    login_device_link_complete_title_text: "Associer le dispositif",
	    login_device_link_complete_desc1: "Association de dispositif terminée. Cliquez sur OK pour synchroniser les informations de compte.",
	    
		// Change password page (현재 사용안함)
	    login_change_pwd_sub_cur_pwd_input_title: "현재 비밀번호",
	    login_change_pwd_sub_cur_pwd_input_holder: "현재 비밀번호",
	    login_change_pwd_sub_new_pwd_input_title: "새 비밀번호",
	    login_change_pwd_sub_new_pwd_input_holder: "새 비밀번호",
	    login_change_pwd_sub_new_pwd_confirm_input_title: "새 비밀번호 확인",
	    login_change_pwd_sub_new_pwd_confirm_input_holder: "새 비밀번호 확인",	    
	    login_change_pwd_title_text: "비밀번호 변경",	    
	    login_change_pwd_desc_text_p: "변경하실 비밀번호를 입력해주세요.<br/>6자리 이상 입력해야 비밀번호를<br/>변경하실 수 있습니다.<br/>",
	    login_change_pwd_desc_text_l: "변경하실 비밀번호를 입력해주세요.<br/>6자리 이상 입력해야 비밀번호를 변경하실 수 있습니다.<br/>",
	    login_change_pwd_current_pwd_input: "현재 비밀번호",
	    login_change_pwd_new_pwd_input: "새 비밀번호",
	    login_change_pwd_new_pwd_confirm_input: "새 비밀번호 확인",
	    login_change_pwd_not_input_cur_pwd: "현재 비밀번호를 입력해주세요.",
	    login_change_pwd_not_input_new_pwd: "새로운 비밀번호를 입력해주세요.",
	    login_change_pwd_not_match_new_pwd: "새로운 비밀번호가 일치하지 않습니다.",
	    login_change_pwd_success_message:"비밀번호가 변경되었습니다.",
        
        // login_nick_name page (현재 사용안함)
	    login_nick_name_title_text: "닉네임 입력",
	    login_nick_name_sub_input_title: "Nick name",
	    login_nick_name_sub_input_holder: "입력",	    
	    login_nick_name_desc_text_p: "사용하실 닉네임을 입력해주십시오.<br/>2자 이상 입력해야 다음으로 이동됩니다.",
	    login_nick_name_desc_text_l: "사용하실 닉네임을 입력해주십시오.<br/>2자 이상 입력해야 다음으로 이동됩니다.",
	    login_nick_name_lable: "Nick name",
	    login_nick_name_input: "입력",
        
        // login_selvas_login page (현재 사용안함)
	    login_selvas_login_title_text: "사용자 로그인",
	    login_selvas_login_find_pwd_btn: "비밀번호 찾기",	    
	    login_selvas_login_desc_text_p: "SELVAS 회원가입 시에 등록하신<br/>이메일 주소와 비밀번호를 입력해 주세요.<br/>비밀번호를 분실하신 경우<br/>\"비밀번호 찾기\"를 선택하시면 됩니다.",
	    login_selvas_login_desc_text_l: "SELVAS 회원가입 시에 등록하신 이메일 주소와 비밀번호를 입력해 <br/>주세요. 비밀번호를 분실하신 경우 \"비밀번호 찾기\"를 선택하시면 됩니다.",
	    login_selvas_login_email_lable: "이메일",
	    login_selvas_login_password_lable: "Password",
	    login_selvas_login_email_input: "email@selvas.com",
	    login_selvas_login_password_input: "입력",
	    login_selvas_login_join_member_btn: "Member register",
	    login_selvas_login_sub_email_input_title: "이메일",
	    login_selvas_login_sub_email_input_holder: "email@selvas.com",
	    login_selvas_login_sub_pwd_input_title: "Password",
	    login_selvas_login_sub_pwd_input_holder: "Password",
	    login_selvas_login_check_password_text: "비밀번호를 입력해 주세요.",	
         
		///////////////////////
		// 공통 적용및 기타
		///////////////////////	    
        // 닉네임 변경 시 error msg
        change_nick_failed : "Impossible de modifier le nom d'utilisateur",
        
		// status bar
	    com_status_confirm_btn: "Ok",
	    com_status_finish_btn: "Terminer",
	    com_status_cancel_btn: "Annuler",
	    com_status_aggree_btn: "Accepter",
	    com_status_close_btn: "Fermer",
	    com_status_back_btn: "Retour",
	    
	    // common text	
	    com_google_login_box_title: "Sign in",
	    com_game_center_login_box_title: "Connexion au Game Center",
	    com_selvas_login_box_title: "Connexion à SELVAS",   
	    com_device_link_box_title: "Associer le dispositif",
		com_account_info_btn: "Informations du compte",
	    com_google_login_desc: "Logging into Google Play Games will not only protect user information, but also allow game play from multiple Android devices.",
	    com_selvas_login_desc: "Logging into Selvas account instead of Google Play Games will also protect user information.",
	    com_game_center_login_desc: "La connexion au Game Center à l’aide d’un compte iTunes non seulement protégera les informations d'utilisateur mais permettra également de jouer à travers plusieurs dispositifs iOS."
	},
	_es : {			
		///////////////////////
		// 로그인/프로파일 Page
		///////////////////////
		// Profile view page
		profile_account_default_info: "No seleccione.",
		profile_basic_info_format: "{$1} / {$2}",
		profile_title_text: "Información de usuario",
		profile_account: "Información básica",
	    profile_nickname: "Nombre de usuario",
	    profile_change_photo_btn: "Cambiar",
	    profile_verify_email_send_msg: "Correo de verificación ha sido enviado.",

	    // profile_edit_basic_info 
	    profile_edit_basic_info_title_text: "Cambio de información básica.",
	    profile_edit_basic_info_sex_male: "Masculino",
	    profile_edit_basic_info_sex_female: "Femenino",
	    profile_edit_basic_info_age_10: "grupo de edad de 10",
	    profile_edit_basic_info_age_20: "grupo de edad de 20",
	    profile_edit_basic_info_age_30: "grupo de edad de 30",
	    profile_edit_basic_info_age_40: "grupo de edad de 40",
	    profile_edit_basic_info_age_50: "grupo de edad de 50",
	    profile_edit_basic_info_age_60: "grupo de edad de 60",
	    profile_edit_basic_info_save_fail: "Error al guardar el perfil",    
	    profile_edit_basic_info_load_error: "Un error ocurrió al solicitar información de usuario",
	    
	    // login_guide page
	    login_guide_title_text: "Manual de login",  
	    login_guide_login_exist_msg: "Usted no está en el sistema",
	    
	    // login_set_account page
	    login_set_account_title_text: "Configuración de cuenta",
	    login_set_account_device_link_login_desc: "Información de la cuenta puede ser transferida a dispositivo adicional",
	    
	    // login_account_info page
	    login_account_info_title_text: "Información de la cuenta",
	    login_account_info_email_title_label: "Cuenta SELVAS",
	    login_account_info_chg_pwd_btn: "Cambiar la contraseña",
	    	    
	    // login_device_link_recommend_1 page
	    login_device_link_recommend_1_title_text: "Dispositivo de enlace",
	    login_device_link_recommend_1_google_link_desc: "Please log into Google Play Games and try again.",
	    login_device_link_recommend_1_selvas_link_desc: "Por favor, intente acceder después de ingresar a cuenta SELVAS.",
	    login_device_link_recommend_1_gamecenter_link_desc: "Por favor, intente acceder después de ingresar a cuenta de Apple Game Center.",
	 
	    // login_device_link_recommend_2 page
	    login_device_link_recommend_2_title_text: "Dispositivo de enlace",
	    login_device_link_recommend_2_link_desc: "Si quiere jugar desde múltiples {$1} dispositivos, intente iniciar sesión en {$2} cuenta desde el menú de configuración de juego e inicie sesión en {$3}.<br><br>" +
	    		" Va a enlazar automáticamente con otro {$1} dispositivo ingresando en {$2} cuenta.",

	    // login_device_link_option_1 page
	    login_device_link_option_1_title_text: "Dispositivo de enlace",
	    login_device_link_option_1_link_desc: "Puede enlazar dos dispositivos para reproducir o transferir archivos.",
	    login_device_link_option_1_current_device: "Dispositivo <br/> actualmente activo",
	    login_device_link_option_1_new_device: "Nuevo <br/> dispositivo",
	    
	    // login_device_link_option_2 page
	    login_device_link_option_2_title_text: "Dispositivo de enlace",
	    login_device_link_option_2_link_desc: "Seleccione el tipo de dispositivo recién vinculado.",
	    login_device_link_option_2_link_desc2: "※ Otro sistema operativo no compatible.",
	    login_device_link_option_2_ios_device: "Dispositivo iOS",
	    login_device_link_option_2_android_device: "Dispositivo Android",
	    
	    // login_device_link_code_output page
	    login_device_link_code_output_title_text: "Dispositivo de enlace",
	    login_device_link_code_output_desc1: "Ingrese más abajo <br/> código de enlace a nuevo dispositivo que desea vincular",
	    login_device_link_code_output_desc2: "Puede vincular a un nuevo dispositivo introduciendo un código de enlace a través del menú de configuración de la cuenta en el nuevo dispositivo.",
	    login_device_link_code_output_valid_time: "Tiempo válido para el código de enlace",
	    login_device_link_code_output_refresh_btn: "Emitir nuevo código de enlace",
	    login_device_link_code_output_warn_msg: "Advertencia: No comparta código de enlace con los demás.",

	    // login_device_link_code_input page
	    login_device_link_code_input_title_text: "Dispositivo de enlace",
	    login_device_link_code_input_holder: "Código de enlace",
	    login_device_link_code_input_desc1: "Por favor, introduzca el código de enlace.",
	    login_device_link_code_input_desc2: "Usted puede encontrar el código de enlace del dispositivo de enlace en el menú de configuración de la cuenta de su dispositivo original.",
	    
	    // login_device_link_confirm page
	    login_device_link_confirm_title_text: "Link Device",
	    login_device_link_confirm_desc1: "Are you sure about deleting current progress on this device and replacing with following account data?",
	    
	    // login_device_link_complete page
	    login_device_link_complete_title_text: "Dispositivo de enlace",
	    login_device_link_complete_desc1: "¿Seguro que quiere eliminar el progreso actual en este dispositivo y reemplazarlo con los siguientes datos de la cuenta?",
	    
		// Change password page (현재 사용안함)
	    login_change_pwd_sub_cur_pwd_input_title: "현재 비밀번호",
	    login_change_pwd_sub_cur_pwd_input_holder: "현재 비밀번호",
	    login_change_pwd_sub_new_pwd_input_title: "새 비밀번호",
	    login_change_pwd_sub_new_pwd_input_holder: "새 비밀번호",
	    login_change_pwd_sub_new_pwd_confirm_input_title: "새 비밀번호 확인",
	    login_change_pwd_sub_new_pwd_confirm_input_holder: "새 비밀번호 확인",	    
	    login_change_pwd_title_text: "비밀번호 변경",	    
	    login_change_pwd_desc_text_p: "변경하실 비밀번호를 입력해주세요.<br/>6자리 이상 입력해야 비밀번호를<br/>변경하실 수 있습니다.<br/>",
	    login_change_pwd_desc_text_l: "변경하실 비밀번호를 입력해주세요.<br/>6자리 이상 입력해야 비밀번호를 변경하실 수 있습니다.<br/>",
	    login_change_pwd_current_pwd_input: "현재 비밀번호",
	    login_change_pwd_new_pwd_input: "새 비밀번호",
	    login_change_pwd_new_pwd_confirm_input: "새 비밀번호 확인",
	    login_change_pwd_not_input_cur_pwd: "현재 비밀번호를 입력해주세요.",
	    login_change_pwd_not_input_new_pwd: "새로운 비밀번호를 입력해주세요.",
	    login_change_pwd_not_match_new_pwd: "새로운 비밀번호가 일치하지 않습니다.",
	    login_change_pwd_success_message:"비밀번호가 변경되었습니다.",
        
        // login_nick_name page (현재 사용안함)
	    login_nick_name_title_text: "닉네임 입력",
	    login_nick_name_sub_input_title: "Nick name",
	    login_nick_name_sub_input_holder: "입력",	    
	    login_nick_name_desc_text_p: "사용하실 닉네임을 입력해주십시오.<br/>2자 이상 입력해야 다음으로 이동됩니다.",
	    login_nick_name_desc_text_l: "사용하실 닉네임을 입력해주십시오.<br/>2자 이상 입력해야 다음으로 이동됩니다.",
	    login_nick_name_lable: "Nick name",
	    login_nick_name_input: "입력",
        
        // login_selvas_login page (현재 사용안함)
	    login_selvas_login_title_text: "사용자 로그인",
	    login_selvas_login_find_pwd_btn: "비밀번호 찾기",	    
	    login_selvas_login_desc_text_p: "SELVAS 회원가입 시에 등록하신<br/>이메일 주소와 비밀번호를 입력해 주세요.<br/>비밀번호를 분실하신 경우<br/>\"비밀번호 찾기\"를 선택하시면 됩니다.",
	    login_selvas_login_desc_text_l: "SELVAS 회원가입 시에 등록하신 이메일 주소와 비밀번호를 입력해 <br/>주세요. 비밀번호를 분실하신 경우 \"비밀번호 찾기\"를 선택하시면 됩니다.",
	    login_selvas_login_email_lable: "이메일",
	    login_selvas_login_password_lable: "Password",
	    login_selvas_login_email_input: "email@selvas.com",
	    login_selvas_login_password_input: "입력",
	    login_selvas_login_join_member_btn: "Member register",
	    login_selvas_login_sub_email_input_title: "이메일",
	    login_selvas_login_sub_email_input_holder: "email@selvas.com",
	    login_selvas_login_sub_pwd_input_title: "Password",
	    login_selvas_login_sub_pwd_input_holder: "Password",
	    login_selvas_login_check_password_text: "비밀번호를 입력해 주세요.",	
        
		///////////////////////
		// 공통 적용및 기타
		///////////////////////	    
        // 닉네임 변경 시 error msg
        change_nick_failed : "Error al cambiar nombre de usuario",
        
		// status bar
	    com_status_confirm_btn: "De acuerdo",
	    com_status_finish_btn: "Completo",
	    com_status_cancel_btn: "Cancelar",
	    com_status_aggree_btn: "Acordar",
	    com_status_close_btn: "Cerrar",
	    com_status_back_btn: "Atrás",
	    
	    // common text	
	    com_google_login_box_title: "Sign in",
	    com_game_center_login_box_title: "Game Center Login",
	    com_selvas_login_box_title: "SELVAS Login",   
	    com_device_link_box_title: "Dispositivo de enlace",
		com_account_info_btn: "Información de la cuenta",
	    com_google_login_desc: "Logging into Google Play Games will not only protect user information, but also allow game play from multiple Android devices.",
	    com_selvas_login_desc: "Logging into Selvas account instead of Google Play Games will also protect user information.",
	    com_game_center_login_desc: "Inicio de sesión en el centro de juego con una cuenta de iTunes no sólo protegerá la información de un usuario, sino también permite el juego a través de múltiples dispositivos iOS."
	},
};
